import ha, { useState as yr, useEffect as Lr, useRef as Za, useMemo as Kn } from "react";
const Qa = {
  required: (e) => `${e.missingProperty} is required.`,
  minLength: (e) => e.limit === 1 ? "This field is required." : `Should be at least ${e.limit} characters long.`,
  maxLength: (e) => `Should not exceed ${e.limit} characters.`,
  pattern: () => "Invalid format.",
  minimum: (e) => `Should be greater than or equal to ${e.limit}.`,
  maximum: (e) => `Should be less than or equal to ${e.limit}.`,
  enum: (e) => {
    var t;
    return `${(t = e.allowedValues) == null ? void 0 : t.join(", ")} are the only allowed values.`;
  },
  type: (e) => `Should be of type ${e.type}.`,
  format: (e) => `Should be in ${e.format} format.`
}, xa = (e) => e.instancePath.slice(1), es = (e, t) => {
  const r = "Unknown validation error";
  try {
    const a = e.keyword, n = { ...Qa, ...t }[a];
    return typeof n == "function" ? n(e.params) : e.message || r;
  } catch {
    return r;
  }
}, Mr = (e, t) => e.reduce((r, a) => {
  const n = xa(a);
  return n ? {
    ...r,
    [n]: es(a, t)
  } : r;
}, {}), Gn = (e) => {
  const t = {};
  for (const r in e)
    Object.prototype.hasOwnProperty.call(e, r) && (t[r] = { value: e[r], error: "" });
  return t;
}, dr = (e) => e == null ? "" : e ?? "", ts = (e, t) => {
  t.forEach((r) => {
    e.getKeyword(r.keyword) || e.addKeyword(r);
  });
};
var rs = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function Qr(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Kr = { exports: {} }, ma = {}, ke = {}, Tt = {}, jt = {}, re = {}, Nt = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.regexpCode = e.getEsmExportName = e.getProperty = e.safeStringify = e.stringify = e.strConcat = e.addCodeArg = e.str = e._ = e.nil = e._Code = e.Name = e.IDENTIFIER = e._CodeOrName = void 0;
  class t {
  }
  e._CodeOrName = t, e.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
  class r extends t {
    constructor(d) {
      if (super(), !e.IDENTIFIER.test(d))
        throw new Error("CodeGen: name must be a valid identifier");
      this.str = d;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      return !1;
    }
    get names() {
      return { [this.str]: 1 };
    }
  }
  e.Name = r;
  class a extends t {
    constructor(d) {
      super(), this._items = typeof d == "string" ? [d] : d;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      if (this._items.length > 1)
        return !1;
      const d = this._items[0];
      return d === "" || d === '""';
    }
    get str() {
      var d;
      return (d = this._str) !== null && d !== void 0 ? d : this._str = this._items.reduce((N, j) => `${N}${j}`, "");
    }
    get names() {
      var d;
      return (d = this._names) !== null && d !== void 0 ? d : this._names = this._items.reduce((N, j) => (j instanceof r && (N[j.str] = (N[j.str] || 0) + 1), N), {});
    }
  }
  e._Code = a, e.nil = new a("");
  function n(p, ...d) {
    const N = [p[0]];
    let j = 0;
    for (; j < d.length; )
      v(N, d[j]), N.push(p[++j]);
    return new a(N);
  }
  e._ = n;
  const c = new a("+");
  function f(p, ...d) {
    const N = [k(p[0])];
    let j = 0;
    for (; j < d.length; )
      N.push(c), v(N, d[j]), N.push(c, k(p[++j]));
    return $(N), new a(N);
  }
  e.str = f;
  function v(p, d) {
    d instanceof a ? p.push(...d._items) : d instanceof r ? p.push(d) : p.push(E(d));
  }
  e.addCodeArg = v;
  function $(p) {
    let d = 1;
    for (; d < p.length - 1; ) {
      if (p[d] === c) {
        const N = m(p[d - 1], p[d + 1]);
        if (N !== void 0) {
          p.splice(d - 1, 3, N);
          continue;
        }
        p[d++] = "+";
      }
      d++;
    }
  }
  function m(p, d) {
    if (d === '""')
      return p;
    if (p === '""')
      return d;
    if (typeof p == "string")
      return d instanceof r || p[p.length - 1] !== '"' ? void 0 : typeof d != "string" ? `${p.slice(0, -1)}${d}"` : d[0] === '"' ? p.slice(0, -1) + d.slice(1) : void 0;
    if (typeof d == "string" && d[0] === '"' && !(p instanceof r))
      return `"${p}${d.slice(1)}`;
  }
  function h(p, d) {
    return d.emptyStr() ? p : p.emptyStr() ? d : f`${p}${d}`;
  }
  e.strConcat = h;
  function E(p) {
    return typeof p == "number" || typeof p == "boolean" || p === null ? p : k(Array.isArray(p) ? p.join(",") : p);
  }
  function D(p) {
    return new a(k(p));
  }
  e.stringify = D;
  function k(p) {
    return JSON.stringify(p).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
  }
  e.safeStringify = k;
  function R(p) {
    return typeof p == "string" && e.IDENTIFIER.test(p) ? new a(`.${p}`) : n`[${p}]`;
  }
  e.getProperty = R;
  function T(p) {
    if (typeof p == "string" && e.IDENTIFIER.test(p))
      return new a(`${p}`);
    throw new Error(`CodeGen: invalid export name: ${p}, use explicit $id name mapping`);
  }
  e.getEsmExportName = T;
  function w(p) {
    return new a(p.toString());
  }
  e.regexpCode = w;
})(Nt);
var Gr = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.ValueScope = e.ValueScopeName = e.Scope = e.varKinds = e.UsedValueState = void 0;
  const t = Nt;
  class r extends Error {
    constructor(m) {
      super(`CodeGen: "code" for ${m} not defined`), this.value = m.value;
    }
  }
  var a;
  (function($) {
    $[$.Started = 0] = "Started", $[$.Completed = 1] = "Completed";
  })(a = e.UsedValueState || (e.UsedValueState = {})), e.varKinds = {
    const: new t.Name("const"),
    let: new t.Name("let"),
    var: new t.Name("var")
  };
  class n {
    constructor({ prefixes: m, parent: h } = {}) {
      this._names = {}, this._prefixes = m, this._parent = h;
    }
    toName(m) {
      return m instanceof t.Name ? m : this.name(m);
    }
    name(m) {
      return new t.Name(this._newName(m));
    }
    _newName(m) {
      const h = this._names[m] || this._nameGroup(m);
      return `${m}${h.index++}`;
    }
    _nameGroup(m) {
      var h, E;
      if (!((E = (h = this._parent) === null || h === void 0 ? void 0 : h._prefixes) === null || E === void 0) && E.has(m) || this._prefixes && !this._prefixes.has(m))
        throw new Error(`CodeGen: prefix "${m}" is not allowed in this scope`);
      return this._names[m] = { prefix: m, index: 0 };
    }
  }
  e.Scope = n;
  class c extends t.Name {
    constructor(m, h) {
      super(h), this.prefix = m;
    }
    setValue(m, { property: h, itemIndex: E }) {
      this.value = m, this.scopePath = (0, t._)`.${new t.Name(h)}[${E}]`;
    }
  }
  e.ValueScopeName = c;
  const f = (0, t._)`\n`;
  class v extends n {
    constructor(m) {
      super(m), this._values = {}, this._scope = m.scope, this.opts = { ...m, _n: m.lines ? f : t.nil };
    }
    get() {
      return this._scope;
    }
    name(m) {
      return new c(m, this._newName(m));
    }
    value(m, h) {
      var E;
      if (h.ref === void 0)
        throw new Error("CodeGen: ref must be passed in value");
      const D = this.toName(m), { prefix: k } = D, R = (E = h.key) !== null && E !== void 0 ? E : h.ref;
      let T = this._values[k];
      if (T) {
        const d = T.get(R);
        if (d)
          return d;
      } else
        T = this._values[k] = /* @__PURE__ */ new Map();
      T.set(R, D);
      const w = this._scope[k] || (this._scope[k] = []), p = w.length;
      return w[p] = h.ref, D.setValue(h, { property: k, itemIndex: p }), D;
    }
    getValue(m, h) {
      const E = this._values[m];
      if (E)
        return E.get(h);
    }
    scopeRefs(m, h = this._values) {
      return this._reduceValues(h, (E) => {
        if (E.scopePath === void 0)
          throw new Error(`CodeGen: name "${E}" has no value`);
        return (0, t._)`${m}${E.scopePath}`;
      });
    }
    scopeCode(m = this._values, h, E) {
      return this._reduceValues(m, (D) => {
        if (D.value === void 0)
          throw new Error(`CodeGen: name "${D}" has no value`);
        return D.value.code;
      }, h, E);
    }
    _reduceValues(m, h, E = {}, D) {
      let k = t.nil;
      for (const R in m) {
        const T = m[R];
        if (!T)
          continue;
        const w = E[R] = E[R] || /* @__PURE__ */ new Map();
        T.forEach((p) => {
          if (w.has(p))
            return;
          w.set(p, a.Started);
          let d = h(p);
          if (d) {
            const N = this.opts.es5 ? e.varKinds.var : e.varKinds.const;
            k = (0, t._)`${k}${N} ${p} = ${d};${this.opts._n}`;
          } else if (d = D == null ? void 0 : D(p))
            k = (0, t._)`${k}${d}${this.opts._n}`;
          else
            throw new r(p);
          w.set(p, a.Completed);
        });
      }
      return k;
    }
  }
  e.ValueScope = v;
})(Gr);
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.or = e.and = e.not = e.CodeGen = e.operators = e.varKinds = e.ValueScopeName = e.ValueScope = e.Scope = e.Name = e.regexpCode = e.stringify = e.getProperty = e.nil = e.strConcat = e.str = e._ = void 0;
  const t = Nt, r = Gr;
  var a = Nt;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return a._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return a.str;
  } }), Object.defineProperty(e, "strConcat", { enumerable: !0, get: function() {
    return a.strConcat;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return a.nil;
  } }), Object.defineProperty(e, "getProperty", { enumerable: !0, get: function() {
    return a.getProperty;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return a.stringify;
  } }), Object.defineProperty(e, "regexpCode", { enumerable: !0, get: function() {
    return a.regexpCode;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return a.Name;
  } });
  var n = Gr;
  Object.defineProperty(e, "Scope", { enumerable: !0, get: function() {
    return n.Scope;
  } }), Object.defineProperty(e, "ValueScope", { enumerable: !0, get: function() {
    return n.ValueScope;
  } }), Object.defineProperty(e, "ValueScopeName", { enumerable: !0, get: function() {
    return n.ValueScopeName;
  } }), Object.defineProperty(e, "varKinds", { enumerable: !0, get: function() {
    return n.varKinds;
  } }), e.operators = {
    GT: new t._Code(">"),
    GTE: new t._Code(">="),
    LT: new t._Code("<"),
    LTE: new t._Code("<="),
    EQ: new t._Code("==="),
    NEQ: new t._Code("!=="),
    NOT: new t._Code("!"),
    OR: new t._Code("||"),
    AND: new t._Code("&&"),
    ADD: new t._Code("+")
  };
  class c {
    optimizeNodes() {
      return this;
    }
    optimizeNames(o, l) {
      return this;
    }
  }
  class f extends c {
    constructor(o, l, C) {
      super(), this.varKind = o, this.name = l, this.rhs = C;
    }
    render({ es5: o, _n: l }) {
      const C = o ? r.varKinds.var : this.varKind, U = this.rhs === void 0 ? "" : ` = ${this.rhs}`;
      return `${C} ${this.name}${U};` + l;
    }
    optimizeNames(o, l) {
      if (o[this.name.str])
        return this.rhs && (this.rhs = se(this.rhs, o, l)), this;
    }
    get names() {
      return this.rhs instanceof t._CodeOrName ? this.rhs.names : {};
    }
  }
  class v extends c {
    constructor(o, l, C) {
      super(), this.lhs = o, this.rhs = l, this.sideEffects = C;
    }
    render({ _n: o }) {
      return `${this.lhs} = ${this.rhs};` + o;
    }
    optimizeNames(o, l) {
      if (!(this.lhs instanceof t.Name && !o[this.lhs.str] && !this.sideEffects))
        return this.rhs = se(this.rhs, o, l), this;
    }
    get names() {
      const o = this.lhs instanceof t.Name ? {} : { ...this.lhs.names };
      return ie(o, this.rhs);
    }
  }
  class $ extends v {
    constructor(o, l, C, U) {
      super(o, C, U), this.op = l;
    }
    render({ _n: o }) {
      return `${this.lhs} ${this.op}= ${this.rhs};` + o;
    }
  }
  class m extends c {
    constructor(o) {
      super(), this.label = o, this.names = {};
    }
    render({ _n: o }) {
      return `${this.label}:` + o;
    }
  }
  class h extends c {
    constructor(o) {
      super(), this.label = o, this.names = {};
    }
    render({ _n: o }) {
      return `break${this.label ? ` ${this.label}` : ""};` + o;
    }
  }
  class E extends c {
    constructor(o) {
      super(), this.error = o;
    }
    render({ _n: o }) {
      return `throw ${this.error};` + o;
    }
    get names() {
      return this.error.names;
    }
  }
  class D extends c {
    constructor(o) {
      super(), this.code = o;
    }
    render({ _n: o }) {
      return `${this.code};` + o;
    }
    optimizeNodes() {
      return `${this.code}` ? this : void 0;
    }
    optimizeNames(o, l) {
      return this.code = se(this.code, o, l), this;
    }
    get names() {
      return this.code instanceof t._CodeOrName ? this.code.names : {};
    }
  }
  class k extends c {
    constructor(o = []) {
      super(), this.nodes = o;
    }
    render(o) {
      return this.nodes.reduce((l, C) => l + C.render(o), "");
    }
    optimizeNodes() {
      const { nodes: o } = this;
      let l = o.length;
      for (; l--; ) {
        const C = o[l].optimizeNodes();
        Array.isArray(C) ? o.splice(l, 1, ...C) : C ? o[l] = C : o.splice(l, 1);
      }
      return o.length > 0 ? this : void 0;
    }
    optimizeNames(o, l) {
      const { nodes: C } = this;
      let U = C.length;
      for (; U--; ) {
        const F = C[U];
        F.optimizeNames(o, l) || (me(o, F.names), C.splice(U, 1));
      }
      return C.length > 0 ? this : void 0;
    }
    get names() {
      return this.nodes.reduce((o, l) => J(o, l.names), {});
    }
  }
  class R extends k {
    render(o) {
      return "{" + o._n + super.render(o) + "}" + o._n;
    }
  }
  class T extends k {
  }
  class w extends R {
  }
  w.kind = "else";
  class p extends R {
    constructor(o, l) {
      super(l), this.condition = o;
    }
    render(o) {
      let l = `if(${this.condition})` + super.render(o);
      return this.else && (l += "else " + this.else.render(o)), l;
    }
    optimizeNodes() {
      super.optimizeNodes();
      const o = this.condition;
      if (o === !0)
        return this.nodes;
      let l = this.else;
      if (l) {
        const C = l.optimizeNodes();
        l = this.else = Array.isArray(C) ? new w(C) : C;
      }
      if (l)
        return o === !1 ? l instanceof p ? l : l.nodes : this.nodes.length ? this : new p(Oe(o), l instanceof p ? [l] : l.nodes);
      if (!(o === !1 || !this.nodes.length))
        return this;
    }
    optimizeNames(o, l) {
      var C;
      if (this.else = (C = this.else) === null || C === void 0 ? void 0 : C.optimizeNames(o, l), !!(super.optimizeNames(o, l) || this.else))
        return this.condition = se(this.condition, o, l), this;
    }
    get names() {
      const o = super.names;
      return ie(o, this.condition), this.else && J(o, this.else.names), o;
    }
  }
  p.kind = "if";
  class d extends R {
  }
  d.kind = "for";
  class N extends d {
    constructor(o) {
      super(), this.iteration = o;
    }
    render(o) {
      return `for(${this.iteration})` + super.render(o);
    }
    optimizeNames(o, l) {
      if (super.optimizeNames(o, l))
        return this.iteration = se(this.iteration, o, l), this;
    }
    get names() {
      return J(super.names, this.iteration.names);
    }
  }
  class j extends d {
    constructor(o, l, C, U) {
      super(), this.varKind = o, this.name = l, this.from = C, this.to = U;
    }
    render(o) {
      const l = o.es5 ? r.varKinds.var : this.varKind, { name: C, from: U, to: F } = this;
      return `for(${l} ${C}=${U}; ${C}<${F}; ${C}++)` + super.render(o);
    }
    get names() {
      const o = ie(super.names, this.from);
      return ie(o, this.to);
    }
  }
  class z extends d {
    constructor(o, l, C, U) {
      super(), this.loop = o, this.varKind = l, this.name = C, this.iterable = U;
    }
    render(o) {
      return `for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})` + super.render(o);
    }
    optimizeNames(o, l) {
      if (super.optimizeNames(o, l))
        return this.iterable = se(this.iterable, o, l), this;
    }
    get names() {
      return J(super.names, this.iterable.names);
    }
  }
  class S extends R {
    constructor(o, l, C) {
      super(), this.name = o, this.args = l, this.async = C;
    }
    render(o) {
      return `${this.async ? "async " : ""}function ${this.name}(${this.args})` + super.render(o);
    }
  }
  S.kind = "func";
  class b extends k {
    render(o) {
      return "return " + super.render(o);
    }
  }
  b.kind = "return";
  class A extends R {
    render(o) {
      let l = "try" + super.render(o);
      return this.catch && (l += this.catch.render(o)), this.finally && (l += this.finally.render(o)), l;
    }
    optimizeNodes() {
      var o, l;
      return super.optimizeNodes(), (o = this.catch) === null || o === void 0 || o.optimizeNodes(), (l = this.finally) === null || l === void 0 || l.optimizeNodes(), this;
    }
    optimizeNames(o, l) {
      var C, U;
      return super.optimizeNames(o, l), (C = this.catch) === null || C === void 0 || C.optimizeNames(o, l), (U = this.finally) === null || U === void 0 || U.optimizeNames(o, l), this;
    }
    get names() {
      const o = super.names;
      return this.catch && J(o, this.catch.names), this.finally && J(o, this.finally.names), o;
    }
  }
  class M extends R {
    constructor(o) {
      super(), this.error = o;
    }
    render(o) {
      return `catch(${this.error})` + super.render(o);
    }
  }
  M.kind = "catch";
  class L extends R {
    render(o) {
      return "finally" + super.render(o);
    }
  }
  L.kind = "finally";
  class Q {
    constructor(o, l = {}) {
      this._values = {}, this._blockStarts = [], this._constants = {}, this.opts = { ...l, _n: l.lines ? `
` : "" }, this._extScope = o, this._scope = new r.Scope({ parent: o }), this._nodes = [new T()];
    }
    toString() {
      return this._root.render(this.opts);
    }
    // returns unique name in the internal scope
    name(o) {
      return this._scope.name(o);
    }
    // reserves unique name in the external scope
    scopeName(o) {
      return this._extScope.name(o);
    }
    // reserves unique name in the external scope and assigns value to it
    scopeValue(o, l) {
      const C = this._extScope.value(o, l);
      return (this._values[C.prefix] || (this._values[C.prefix] = /* @__PURE__ */ new Set())).add(C), C;
    }
    getScopeValue(o, l) {
      return this._extScope.getValue(o, l);
    }
    // return code that assigns values in the external scope to the names that are used internally
    // (same names that were returned by gen.scopeName or gen.scopeValue)
    scopeRefs(o) {
      return this._extScope.scopeRefs(o, this._values);
    }
    scopeCode() {
      return this._extScope.scopeCode(this._values);
    }
    _def(o, l, C, U) {
      const F = this._scope.toName(l);
      return C !== void 0 && U && (this._constants[F.str] = C), this._leafNode(new f(o, F, C)), F;
    }
    // `const` declaration (`var` in es5 mode)
    const(o, l, C) {
      return this._def(r.varKinds.const, o, l, C);
    }
    // `let` declaration with optional assignment (`var` in es5 mode)
    let(o, l, C) {
      return this._def(r.varKinds.let, o, l, C);
    }
    // `var` declaration with optional assignment
    var(o, l, C) {
      return this._def(r.varKinds.var, o, l, C);
    }
    // assignment code
    assign(o, l, C) {
      return this._leafNode(new v(o, l, C));
    }
    // `+=` code
    add(o, l) {
      return this._leafNode(new $(o, e.operators.ADD, l));
    }
    // appends passed SafeExpr to code or executes Block
    code(o) {
      return typeof o == "function" ? o() : o !== t.nil && this._leafNode(new D(o)), this;
    }
    // returns code for object literal for the passed argument list of key-value pairs
    object(...o) {
      const l = ["{"];
      for (const [C, U] of o)
        l.length > 1 && l.push(","), l.push(C), (C !== U || this.opts.es5) && (l.push(":"), (0, t.addCodeArg)(l, U));
      return l.push("}"), new t._Code(l);
    }
    // `if` clause (or statement if `thenBody` and, optionally, `elseBody` are passed)
    if(o, l, C) {
      if (this._blockNode(new p(o)), l && C)
        this.code(l).else().code(C).endIf();
      else if (l)
        this.code(l).endIf();
      else if (C)
        throw new Error('CodeGen: "else" body without "then" body');
      return this;
    }
    // `else if` clause - invalid without `if` or after `else` clauses
    elseIf(o) {
      return this._elseNode(new p(o));
    }
    // `else` clause - only valid after `if` or `else if` clauses
    else() {
      return this._elseNode(new w());
    }
    // end `if` statement (needed if gen.if was used only with condition)
    endIf() {
      return this._endBlockNode(p, w);
    }
    _for(o, l) {
      return this._blockNode(o), l && this.code(l).endFor(), this;
    }
    // a generic `for` clause (or statement if `forBody` is passed)
    for(o, l) {
      return this._for(new N(o), l);
    }
    // `for` statement for a range of values
    forRange(o, l, C, U, F = this.opts.es5 ? r.varKinds.var : r.varKinds.let) {
      const G = this._scope.toName(o);
      return this._for(new j(F, G, l, C), () => U(G));
    }
    // `for-of` statement (in es5 mode replace with a normal for loop)
    forOf(o, l, C, U = r.varKinds.const) {
      const F = this._scope.toName(o);
      if (this.opts.es5) {
        const G = l instanceof t.Name ? l : this.var("_arr", l);
        return this.forRange("_i", 0, (0, t._)`${G}.length`, (Z) => {
          this.var(F, (0, t._)`${G}[${Z}]`), C(F);
        });
      }
      return this._for(new z("of", U, F, l), () => C(F));
    }
    // `for-in` statement.
    // With option `ownProperties` replaced with a `for-of` loop for object keys
    forIn(o, l, C, U = this.opts.es5 ? r.varKinds.var : r.varKinds.const) {
      if (this.opts.ownProperties)
        return this.forOf(o, (0, t._)`Object.keys(${l})`, C);
      const F = this._scope.toName(o);
      return this._for(new z("in", U, F, l), () => C(F));
    }
    // end `for` loop
    endFor() {
      return this._endBlockNode(d);
    }
    // `label` statement
    label(o) {
      return this._leafNode(new m(o));
    }
    // `break` statement
    break(o) {
      return this._leafNode(new h(o));
    }
    // `return` statement
    return(o) {
      const l = new b();
      if (this._blockNode(l), this.code(o), l.nodes.length !== 1)
        throw new Error('CodeGen: "return" should have one node');
      return this._endBlockNode(b);
    }
    // `try` statement
    try(o, l, C) {
      if (!l && !C)
        throw new Error('CodeGen: "try" without "catch" and "finally"');
      const U = new A();
      if (this._blockNode(U), this.code(o), l) {
        const F = this.name("e");
        this._currNode = U.catch = new M(F), l(F);
      }
      return C && (this._currNode = U.finally = new L(), this.code(C)), this._endBlockNode(M, L);
    }
    // `throw` statement
    throw(o) {
      return this._leafNode(new E(o));
    }
    // start self-balancing block
    block(o, l) {
      return this._blockStarts.push(this._nodes.length), o && this.code(o).endBlock(l), this;
    }
    // end the current self-balancing block
    endBlock(o) {
      const l = this._blockStarts.pop();
      if (l === void 0)
        throw new Error("CodeGen: not in self-balancing block");
      const C = this._nodes.length - l;
      if (C < 0 || o !== void 0 && C !== o)
        throw new Error(`CodeGen: wrong number of nodes: ${C} vs ${o} expected`);
      return this._nodes.length = l, this;
    }
    // `function` heading (or definition if funcBody is passed)
    func(o, l = t.nil, C, U) {
      return this._blockNode(new S(o, l, C)), U && this.code(U).endFunc(), this;
    }
    // end function definition
    endFunc() {
      return this._endBlockNode(S);
    }
    optimize(o = 1) {
      for (; o-- > 0; )
        this._root.optimizeNodes(), this._root.optimizeNames(this._root.names, this._constants);
    }
    _leafNode(o) {
      return this._currNode.nodes.push(o), this;
    }
    _blockNode(o) {
      this._currNode.nodes.push(o), this._nodes.push(o);
    }
    _endBlockNode(o, l) {
      const C = this._currNode;
      if (C instanceof o || l && C instanceof l)
        return this._nodes.pop(), this;
      throw new Error(`CodeGen: not in block "${l ? `${o.kind}/${l.kind}` : o.kind}"`);
    }
    _elseNode(o) {
      const l = this._currNode;
      if (!(l instanceof p))
        throw new Error('CodeGen: "else" without "if"');
      return this._currNode = l.else = o, this;
    }
    get _root() {
      return this._nodes[0];
    }
    get _currNode() {
      const o = this._nodes;
      return o[o.length - 1];
    }
    set _currNode(o) {
      const l = this._nodes;
      l[l.length - 1] = o;
    }
  }
  e.CodeGen = Q;
  function J(g, o) {
    for (const l in o)
      g[l] = (g[l] || 0) + (o[l] || 0);
    return g;
  }
  function ie(g, o) {
    return o instanceof t._CodeOrName ? J(g, o.names) : g;
  }
  function se(g, o, l) {
    if (g instanceof t.Name)
      return C(g);
    if (!U(g))
      return g;
    return new t._Code(g._items.reduce((F, G) => (G instanceof t.Name && (G = C(G)), G instanceof t._Code ? F.push(...G._items) : F.push(G), F), []));
    function C(F) {
      const G = l[F.str];
      return G === void 0 || o[F.str] !== 1 ? F : (delete o[F.str], G);
    }
    function U(F) {
      return F instanceof t._Code && F._items.some((G) => G instanceof t.Name && o[G.str] === 1 && l[G.str] !== void 0);
    }
  }
  function me(g, o) {
    for (const l in o)
      g[l] = (g[l] || 0) - (o[l] || 0);
  }
  function Oe(g) {
    return typeof g == "boolean" || typeof g == "number" || g === null ? !g : (0, t._)`!${O(g)}`;
  }
  e.not = Oe;
  const Ie = P(e.operators.AND);
  function Ue(...g) {
    return g.reduce(Ie);
  }
  e.and = Ue;
  const Re = P(e.operators.OR);
  function q(...g) {
    return g.reduce(Re);
  }
  e.or = q;
  function P(g) {
    return (o, l) => o === t.nil ? l : l === t.nil ? o : (0, t._)`${O(o)} ${g} ${O(l)}`;
  }
  function O(g) {
    return g instanceof t.Name ? g : (0, t._)`(${g})`;
  }
})(re);
var oe = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.checkStrictMode = e.getErrorPath = e.Type = e.useFunc = e.setEvaluated = e.evaluatedPropsToName = e.mergeEvaluated = e.eachItem = e.unescapeJsonPointer = e.escapeJsonPointer = e.escapeFragment = e.unescapeFragment = e.schemaRefOrVal = e.schemaHasRulesButRef = e.schemaHasRules = e.checkUnknownRules = e.alwaysValidSchema = e.toHash = void 0;
  const t = re, r = Nt;
  function a(S) {
    const b = {};
    for (const A of S)
      b[A] = !0;
    return b;
  }
  e.toHash = a;
  function n(S, b) {
    return typeof b == "boolean" ? b : Object.keys(b).length === 0 ? !0 : (c(S, b), !f(b, S.self.RULES.all));
  }
  e.alwaysValidSchema = n;
  function c(S, b = S.schema) {
    const { opts: A, self: M } = S;
    if (!A.strictSchema || typeof b == "boolean")
      return;
    const L = M.RULES.keywords;
    for (const Q in b)
      L[Q] || z(S, `unknown keyword: "${Q}"`);
  }
  e.checkUnknownRules = c;
  function f(S, b) {
    if (typeof S == "boolean")
      return !S;
    for (const A in S)
      if (b[A])
        return !0;
    return !1;
  }
  e.schemaHasRules = f;
  function v(S, b) {
    if (typeof S == "boolean")
      return !S;
    for (const A in S)
      if (A !== "$ref" && b.all[A])
        return !0;
    return !1;
  }
  e.schemaHasRulesButRef = v;
  function $({ topSchemaRef: S, schemaPath: b }, A, M, L) {
    if (!L) {
      if (typeof A == "number" || typeof A == "boolean")
        return A;
      if (typeof A == "string")
        return (0, t._)`${A}`;
    }
    return (0, t._)`${S}${b}${(0, t.getProperty)(M)}`;
  }
  e.schemaRefOrVal = $;
  function m(S) {
    return D(decodeURIComponent(S));
  }
  e.unescapeFragment = m;
  function h(S) {
    return encodeURIComponent(E(S));
  }
  e.escapeFragment = h;
  function E(S) {
    return typeof S == "number" ? `${S}` : S.replace(/~/g, "~0").replace(/\//g, "~1");
  }
  e.escapeJsonPointer = E;
  function D(S) {
    return S.replace(/~1/g, "/").replace(/~0/g, "~");
  }
  e.unescapeJsonPointer = D;
  function k(S, b) {
    if (Array.isArray(S))
      for (const A of S)
        b(A);
    else
      b(S);
  }
  e.eachItem = k;
  function R({ mergeNames: S, mergeToName: b, mergeValues: A, resultToName: M }) {
    return (L, Q, J, ie) => {
      const se = J === void 0 ? Q : J instanceof t.Name ? (Q instanceof t.Name ? S(L, Q, J) : b(L, Q, J), J) : Q instanceof t.Name ? (b(L, J, Q), Q) : A(Q, J);
      return ie === t.Name && !(se instanceof t.Name) ? M(L, se) : se;
    };
  }
  e.mergeEvaluated = {
    props: R({
      mergeNames: (S, b, A) => S.if((0, t._)`${A} !== true && ${b} !== undefined`, () => {
        S.if((0, t._)`${b} === true`, () => S.assign(A, !0), () => S.assign(A, (0, t._)`${A} || {}`).code((0, t._)`Object.assign(${A}, ${b})`));
      }),
      mergeToName: (S, b, A) => S.if((0, t._)`${A} !== true`, () => {
        b === !0 ? S.assign(A, !0) : (S.assign(A, (0, t._)`${A} || {}`), w(S, A, b));
      }),
      mergeValues: (S, b) => S === !0 ? !0 : { ...S, ...b },
      resultToName: T
    }),
    items: R({
      mergeNames: (S, b, A) => S.if((0, t._)`${A} !== true && ${b} !== undefined`, () => S.assign(A, (0, t._)`${b} === true ? true : ${A} > ${b} ? ${A} : ${b}`)),
      mergeToName: (S, b, A) => S.if((0, t._)`${A} !== true`, () => S.assign(A, b === !0 ? !0 : (0, t._)`${A} > ${b} ? ${A} : ${b}`)),
      mergeValues: (S, b) => S === !0 ? !0 : Math.max(S, b),
      resultToName: (S, b) => S.var("items", b)
    })
  };
  function T(S, b) {
    if (b === !0)
      return S.var("props", !0);
    const A = S.var("props", (0, t._)`{}`);
    return b !== void 0 && w(S, A, b), A;
  }
  e.evaluatedPropsToName = T;
  function w(S, b, A) {
    Object.keys(A).forEach((M) => S.assign((0, t._)`${b}${(0, t.getProperty)(M)}`, !0));
  }
  e.setEvaluated = w;
  const p = {};
  function d(S, b) {
    return S.scopeValue("func", {
      ref: b,
      code: p[b.code] || (p[b.code] = new r._Code(b.code))
    });
  }
  e.useFunc = d;
  var N;
  (function(S) {
    S[S.Num = 0] = "Num", S[S.Str = 1] = "Str";
  })(N = e.Type || (e.Type = {}));
  function j(S, b, A) {
    if (S instanceof t.Name) {
      const M = b === N.Num;
      return A ? M ? (0, t._)`"[" + ${S} + "]"` : (0, t._)`"['" + ${S} + "']"` : M ? (0, t._)`"/" + ${S}` : (0, t._)`"/" + ${S}.replace(/~/g, "~0").replace(/\\//g, "~1")`;
    }
    return A ? (0, t.getProperty)(S).toString() : "/" + E(S);
  }
  e.getErrorPath = j;
  function z(S, b, A = S.opts.strictSchema) {
    if (A) {
      if (b = `strict mode: ${b}`, A === !0)
        throw new Error(b);
      S.self.logger.warn(b);
    }
  }
  e.checkStrictMode = z;
})(oe);
var ze = {};
Object.defineProperty(ze, "__esModule", { value: !0 });
const ge = re, ns = {
  // validation function arguments
  data: new ge.Name("data"),
  // args passed from referencing schema
  valCxt: new ge.Name("valCxt"),
  instancePath: new ge.Name("instancePath"),
  parentData: new ge.Name("parentData"),
  parentDataProperty: new ge.Name("parentDataProperty"),
  rootData: new ge.Name("rootData"),
  dynamicAnchors: new ge.Name("dynamicAnchors"),
  // function scoped variables
  vErrors: new ge.Name("vErrors"),
  errors: new ge.Name("errors"),
  this: new ge.Name("this"),
  // "globals"
  self: new ge.Name("self"),
  scope: new ge.Name("scope"),
  // JTD serialize/parse name for JSON string and position
  json: new ge.Name("json"),
  jsonPos: new ge.Name("jsonPos"),
  jsonLen: new ge.Name("jsonLen"),
  jsonPart: new ge.Name("jsonPart")
};
ze.default = ns;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.extendErrors = e.resetErrorsCount = e.reportExtraError = e.reportError = e.keyword$DataError = e.keywordError = void 0;
  const t = re, r = oe, a = ze;
  e.keywordError = {
    message: ({ keyword: w }) => (0, t.str)`must pass "${w}" keyword validation`
  }, e.keyword$DataError = {
    message: ({ keyword: w, schemaType: p }) => p ? (0, t.str)`"${w}" keyword must be ${p} ($data)` : (0, t.str)`"${w}" keyword is invalid ($data)`
  };
  function n(w, p = e.keywordError, d, N) {
    const { it: j } = w, { gen: z, compositeRule: S, allErrors: b } = j, A = E(w, p, d);
    N ?? (S || b) ? $(z, A) : m(j, (0, t._)`[${A}]`);
  }
  e.reportError = n;
  function c(w, p = e.keywordError, d) {
    const { it: N } = w, { gen: j, compositeRule: z, allErrors: S } = N, b = E(w, p, d);
    $(j, b), z || S || m(N, a.default.vErrors);
  }
  e.reportExtraError = c;
  function f(w, p) {
    w.assign(a.default.errors, p), w.if((0, t._)`${a.default.vErrors} !== null`, () => w.if(p, () => w.assign((0, t._)`${a.default.vErrors}.length`, p), () => w.assign(a.default.vErrors, null)));
  }
  e.resetErrorsCount = f;
  function v({ gen: w, keyword: p, schemaValue: d, data: N, errsCount: j, it: z }) {
    if (j === void 0)
      throw new Error("ajv implementation error");
    const S = w.name("err");
    w.forRange("i", j, a.default.errors, (b) => {
      w.const(S, (0, t._)`${a.default.vErrors}[${b}]`), w.if((0, t._)`${S}.instancePath === undefined`, () => w.assign((0, t._)`${S}.instancePath`, (0, t.strConcat)(a.default.instancePath, z.errorPath))), w.assign((0, t._)`${S}.schemaPath`, (0, t.str)`${z.errSchemaPath}/${p}`), z.opts.verbose && (w.assign((0, t._)`${S}.schema`, d), w.assign((0, t._)`${S}.data`, N));
    });
  }
  e.extendErrors = v;
  function $(w, p) {
    const d = w.const("err", p);
    w.if((0, t._)`${a.default.vErrors} === null`, () => w.assign(a.default.vErrors, (0, t._)`[${d}]`), (0, t._)`${a.default.vErrors}.push(${d})`), w.code((0, t._)`${a.default.errors}++`);
  }
  function m(w, p) {
    const { gen: d, validateName: N, schemaEnv: j } = w;
    j.$async ? d.throw((0, t._)`new ${w.ValidationError}(${p})`) : (d.assign((0, t._)`${N}.errors`, p), d.return(!1));
  }
  const h = {
    keyword: new t.Name("keyword"),
    schemaPath: new t.Name("schemaPath"),
    params: new t.Name("params"),
    propertyName: new t.Name("propertyName"),
    message: new t.Name("message"),
    schema: new t.Name("schema"),
    parentSchema: new t.Name("parentSchema")
  };
  function E(w, p, d) {
    const { createErrors: N } = w.it;
    return N === !1 ? (0, t._)`{}` : D(w, p, d);
  }
  function D(w, p, d = {}) {
    const { gen: N, it: j } = w, z = [
      k(j, d),
      R(w, d)
    ];
    return T(w, p, z), N.object(...z);
  }
  function k({ errorPath: w }, { instancePath: p }) {
    const d = p ? (0, t.str)`${w}${(0, r.getErrorPath)(p, r.Type.Str)}` : w;
    return [a.default.instancePath, (0, t.strConcat)(a.default.instancePath, d)];
  }
  function R({ keyword: w, it: { errSchemaPath: p } }, { schemaPath: d, parentSchema: N }) {
    let j = N ? p : (0, t.str)`${p}/${w}`;
    return d && (j = (0, t.str)`${j}${(0, r.getErrorPath)(d, r.Type.Str)}`), [h.schemaPath, j];
  }
  function T(w, { params: p, message: d }, N) {
    const { keyword: j, data: z, schemaValue: S, it: b } = w, { opts: A, propertyName: M, topSchemaRef: L, schemaPath: Q } = b;
    N.push([h.keyword, j], [h.params, typeof p == "function" ? p(w) : p || (0, t._)`{}`]), A.messages && N.push([h.message, typeof d == "function" ? d(w) : d]), A.verbose && N.push([h.schema, S], [h.parentSchema, (0, t._)`${L}${Q}`], [a.default.data, z]), M && N.push([h.propertyName, M]);
  }
})(jt);
Object.defineProperty(Tt, "__esModule", { value: !0 });
Tt.boolOrEmptySchema = Tt.topBoolOrEmptySchema = void 0;
const as = jt, ss = re, os = ze, is = {
  message: "boolean schema is false"
};
function cs(e) {
  const { gen: t, schema: r, validateName: a } = e;
  r === !1 ? pa(e, !1) : typeof r == "object" && r.$async === !0 ? t.return(os.default.data) : (t.assign((0, ss._)`${a}.errors`, null), t.return(!0));
}
Tt.topBoolOrEmptySchema = cs;
function us(e, t) {
  const { gen: r, schema: a } = e;
  a === !1 ? (r.var(t, !1), pa(e)) : r.var(t, !0);
}
Tt.boolOrEmptySchema = us;
function pa(e, t) {
  const { gen: r, data: a } = e, n = {
    gen: r,
    keyword: "false schema",
    data: a,
    schema: !1,
    schemaCode: !1,
    schemaValue: !1,
    params: {},
    it: e
  };
  (0, as.reportError)(n, is, void 0, t);
}
var Zt = {}, $t = {};
Object.defineProperty($t, "__esModule", { value: !0 });
$t.getRules = $t.isJSONType = void 0;
const ls = ["string", "number", "integer", "boolean", "null", "object", "array"], ds = new Set(ls);
function fs(e) {
  return typeof e == "string" && ds.has(e);
}
$t.isJSONType = fs;
function hs() {
  const e = {
    number: { type: "number", rules: [] },
    string: { type: "string", rules: [] },
    array: { type: "array", rules: [] },
    object: { type: "object", rules: [] }
  };
  return {
    types: { ...e, integer: !0, boolean: !0, null: !0 },
    rules: [{ rules: [] }, e.number, e.string, e.array, e.object],
    post: { rules: [] },
    all: {},
    keywords: {}
  };
}
$t.getRules = hs;
var Qe = {};
Object.defineProperty(Qe, "__esModule", { value: !0 });
Qe.shouldUseRule = Qe.shouldUseGroup = Qe.schemaHasRulesForType = void 0;
function ms({ schema: e, self: t }, r) {
  const a = t.RULES.types[r];
  return a && a !== !0 && va(e, a);
}
Qe.schemaHasRulesForType = ms;
function va(e, t) {
  return t.rules.some((r) => ya(e, r));
}
Qe.shouldUseGroup = va;
function ya(e, t) {
  var r;
  return e[t.keyword] !== void 0 || ((r = t.definition.implements) === null || r === void 0 ? void 0 : r.some((a) => e[a] !== void 0));
}
Qe.shouldUseRule = ya;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.reportTypeError = e.checkDataTypes = e.checkDataType = e.coerceAndCheckDataType = e.getJSONTypes = e.getSchemaTypes = e.DataType = void 0;
  const t = $t, r = Qe, a = jt, n = re, c = oe;
  var f;
  (function(N) {
    N[N.Correct = 0] = "Correct", N[N.Wrong = 1] = "Wrong";
  })(f = e.DataType || (e.DataType = {}));
  function v(N) {
    const j = $(N.type);
    if (j.includes("null")) {
      if (N.nullable === !1)
        throw new Error("type: null contradicts nullable: false");
    } else {
      if (!j.length && N.nullable !== void 0)
        throw new Error('"nullable" cannot be used without "type"');
      N.nullable === !0 && j.push("null");
    }
    return j;
  }
  e.getSchemaTypes = v;
  function $(N) {
    const j = Array.isArray(N) ? N : N ? [N] : [];
    if (j.every(t.isJSONType))
      return j;
    throw new Error("type must be JSONType or JSONType[]: " + j.join(","));
  }
  e.getJSONTypes = $;
  function m(N, j) {
    const { gen: z, data: S, opts: b } = N, A = E(j, b.coerceTypes), M = j.length > 0 && !(A.length === 0 && j.length === 1 && (0, r.schemaHasRulesForType)(N, j[0]));
    if (M) {
      const L = T(j, S, b.strictNumbers, f.Wrong);
      z.if(L, () => {
        A.length ? D(N, j, A) : p(N);
      });
    }
    return M;
  }
  e.coerceAndCheckDataType = m;
  const h = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
  function E(N, j) {
    return j ? N.filter((z) => h.has(z) || j === "array" && z === "array") : [];
  }
  function D(N, j, z) {
    const { gen: S, data: b, opts: A } = N, M = S.let("dataType", (0, n._)`typeof ${b}`), L = S.let("coerced", (0, n._)`undefined`);
    A.coerceTypes === "array" && S.if((0, n._)`${M} == 'object' && Array.isArray(${b}) && ${b}.length == 1`, () => S.assign(b, (0, n._)`${b}[0]`).assign(M, (0, n._)`typeof ${b}`).if(T(j, b, A.strictNumbers), () => S.assign(L, b))), S.if((0, n._)`${L} !== undefined`);
    for (const J of z)
      (h.has(J) || J === "array" && A.coerceTypes === "array") && Q(J);
    S.else(), p(N), S.endIf(), S.if((0, n._)`${L} !== undefined`, () => {
      S.assign(b, L), k(N, L);
    });
    function Q(J) {
      switch (J) {
        case "string":
          S.elseIf((0, n._)`${M} == "number" || ${M} == "boolean"`).assign(L, (0, n._)`"" + ${b}`).elseIf((0, n._)`${b} === null`).assign(L, (0, n._)`""`);
          return;
        case "number":
          S.elseIf((0, n._)`${M} == "boolean" || ${b} === null
              || (${M} == "string" && ${b} && ${b} == +${b})`).assign(L, (0, n._)`+${b}`);
          return;
        case "integer":
          S.elseIf((0, n._)`${M} === "boolean" || ${b} === null
              || (${M} === "string" && ${b} && ${b} == +${b} && !(${b} % 1))`).assign(L, (0, n._)`+${b}`);
          return;
        case "boolean":
          S.elseIf((0, n._)`${b} === "false" || ${b} === 0 || ${b} === null`).assign(L, !1).elseIf((0, n._)`${b} === "true" || ${b} === 1`).assign(L, !0);
          return;
        case "null":
          S.elseIf((0, n._)`${b} === "" || ${b} === 0 || ${b} === false`), S.assign(L, null);
          return;
        case "array":
          S.elseIf((0, n._)`${M} === "string" || ${M} === "number"
              || ${M} === "boolean" || ${b} === null`).assign(L, (0, n._)`[${b}]`);
      }
    }
  }
  function k({ gen: N, parentData: j, parentDataProperty: z }, S) {
    N.if((0, n._)`${j} !== undefined`, () => N.assign((0, n._)`${j}[${z}]`, S));
  }
  function R(N, j, z, S = f.Correct) {
    const b = S === f.Correct ? n.operators.EQ : n.operators.NEQ;
    let A;
    switch (N) {
      case "null":
        return (0, n._)`${j} ${b} null`;
      case "array":
        A = (0, n._)`Array.isArray(${j})`;
        break;
      case "object":
        A = (0, n._)`${j} && typeof ${j} == "object" && !Array.isArray(${j})`;
        break;
      case "integer":
        A = M((0, n._)`!(${j} % 1) && !isNaN(${j})`);
        break;
      case "number":
        A = M();
        break;
      default:
        return (0, n._)`typeof ${j} ${b} ${N}`;
    }
    return S === f.Correct ? A : (0, n.not)(A);
    function M(L = n.nil) {
      return (0, n.and)((0, n._)`typeof ${j} == "number"`, L, z ? (0, n._)`isFinite(${j})` : n.nil);
    }
  }
  e.checkDataType = R;
  function T(N, j, z, S) {
    if (N.length === 1)
      return R(N[0], j, z, S);
    let b;
    const A = (0, c.toHash)(N);
    if (A.array && A.object) {
      const M = (0, n._)`typeof ${j} != "object"`;
      b = A.null ? M : (0, n._)`!${j} || ${M}`, delete A.null, delete A.array, delete A.object;
    } else
      b = n.nil;
    A.number && delete A.integer;
    for (const M in A)
      b = (0, n.and)(b, R(M, j, z, S));
    return b;
  }
  e.checkDataTypes = T;
  const w = {
    message: ({ schema: N }) => `must be ${N}`,
    params: ({ schema: N, schemaValue: j }) => typeof N == "string" ? (0, n._)`{type: ${N}}` : (0, n._)`{type: ${j}}`
  };
  function p(N) {
    const j = d(N);
    (0, a.reportError)(j, w);
  }
  e.reportTypeError = p;
  function d(N) {
    const { gen: j, data: z, schema: S } = N, b = (0, c.schemaRefOrVal)(N, S, "type");
    return {
      gen: j,
      keyword: "type",
      data: z,
      schema: S.type,
      schemaCode: b,
      schemaValue: b,
      parentSchema: S,
      params: {},
      it: N
    };
  }
})(Zt);
var Rr = {};
Object.defineProperty(Rr, "__esModule", { value: !0 });
Rr.assignDefaults = void 0;
const St = re, ps = oe;
function vs(e, t) {
  const { properties: r, items: a } = e.schema;
  if (t === "object" && r)
    for (const n in r)
      Hn(e, n, r[n].default);
  else
    t === "array" && Array.isArray(a) && a.forEach((n, c) => Hn(e, c, n.default));
}
Rr.assignDefaults = vs;
function Hn(e, t, r) {
  const { gen: a, compositeRule: n, data: c, opts: f } = e;
  if (r === void 0)
    return;
  const v = (0, St._)`${c}${(0, St.getProperty)(t)}`;
  if (n) {
    (0, ps.checkStrictMode)(e, `default is ignored for: ${v}`);
    return;
  }
  let $ = (0, St._)`${v} === undefined`;
  f.useDefaults === "empty" && ($ = (0, St._)`${$} || ${v} === null || ${v} === ""`), a.if($, (0, St._)`${v} = ${(0, St.stringify)(r)}`);
}
var Ye = {}, ne = {};
Object.defineProperty(ne, "__esModule", { value: !0 });
ne.validateUnion = ne.validateArray = ne.usePattern = ne.callValidateCode = ne.schemaProperties = ne.allSchemaProperties = ne.noPropertyInData = ne.propertyInData = ne.isOwnProperty = ne.hasPropFunc = ne.reportMissingProp = ne.checkMissingProp = ne.checkReportMissingProp = void 0;
const fe = re, xr = oe, st = ze, ys = oe;
function $s(e, t) {
  const { gen: r, data: a, it: n } = e;
  r.if(tn(r, a, t, n.opts.ownProperties), () => {
    e.setParams({ missingProperty: (0, fe._)`${t}` }, !0), e.error();
  });
}
ne.checkReportMissingProp = $s;
function _s({ gen: e, data: t, it: { opts: r } }, a, n) {
  return (0, fe.or)(...a.map((c) => (0, fe.and)(tn(e, t, c, r.ownProperties), (0, fe._)`${n} = ${c}`)));
}
ne.checkMissingProp = _s;
function gs(e, t) {
  e.setParams({ missingProperty: t }, !0), e.error();
}
ne.reportMissingProp = gs;
function $a(e) {
  return e.scopeValue("func", {
    // eslint-disable-next-line @typescript-eslint/unbound-method
    ref: Object.prototype.hasOwnProperty,
    code: (0, fe._)`Object.prototype.hasOwnProperty`
  });
}
ne.hasPropFunc = $a;
function en(e, t, r) {
  return (0, fe._)`${$a(e)}.call(${t}, ${r})`;
}
ne.isOwnProperty = en;
function Es(e, t, r, a) {
  const n = (0, fe._)`${t}${(0, fe.getProperty)(r)} !== undefined`;
  return a ? (0, fe._)`${n} && ${en(e, t, r)}` : n;
}
ne.propertyInData = Es;
function tn(e, t, r, a) {
  const n = (0, fe._)`${t}${(0, fe.getProperty)(r)} === undefined`;
  return a ? (0, fe.or)(n, (0, fe.not)(en(e, t, r))) : n;
}
ne.noPropertyInData = tn;
function _a(e) {
  return e ? Object.keys(e).filter((t) => t !== "__proto__") : [];
}
ne.allSchemaProperties = _a;
function ws(e, t) {
  return _a(t).filter((r) => !(0, xr.alwaysValidSchema)(e, t[r]));
}
ne.schemaProperties = ws;
function bs({ schemaCode: e, data: t, it: { gen: r, topSchemaRef: a, schemaPath: n, errorPath: c }, it: f }, v, $, m) {
  const h = m ? (0, fe._)`${e}, ${t}, ${a}${n}` : t, E = [
    [st.default.instancePath, (0, fe.strConcat)(st.default.instancePath, c)],
    [st.default.parentData, f.parentData],
    [st.default.parentDataProperty, f.parentDataProperty],
    [st.default.rootData, st.default.rootData]
  ];
  f.opts.dynamicRef && E.push([st.default.dynamicAnchors, st.default.dynamicAnchors]);
  const D = (0, fe._)`${h}, ${r.object(...E)}`;
  return $ !== fe.nil ? (0, fe._)`${v}.call(${$}, ${D})` : (0, fe._)`${v}(${D})`;
}
ne.callValidateCode = bs;
const Ss = (0, fe._)`new RegExp`;
function Ps({ gen: e, it: { opts: t } }, r) {
  const a = t.unicodeRegExp ? "u" : "", { regExp: n } = t.code, c = n(r, a);
  return e.scopeValue("pattern", {
    key: c.toString(),
    ref: c,
    code: (0, fe._)`${n.code === "new RegExp" ? Ss : (0, ys.useFunc)(e, n)}(${r}, ${a})`
  });
}
ne.usePattern = Ps;
function Os(e) {
  const { gen: t, data: r, keyword: a, it: n } = e, c = t.name("valid");
  if (n.allErrors) {
    const v = t.let("valid", !0);
    return f(() => t.assign(v, !1)), v;
  }
  return t.var(c, !0), f(() => t.break()), c;
  function f(v) {
    const $ = t.const("len", (0, fe._)`${r}.length`);
    t.forRange("i", 0, $, (m) => {
      e.subschema({
        keyword: a,
        dataProp: m,
        dataPropType: xr.Type.Num
      }, c), t.if((0, fe.not)(c), v);
    });
  }
}
ne.validateArray = Os;
function Rs(e) {
  const { gen: t, schema: r, keyword: a, it: n } = e;
  if (!Array.isArray(r))
    throw new Error("ajv implementation error");
  if (r.some(($) => (0, xr.alwaysValidSchema)(n, $)) && !n.opts.unevaluated)
    return;
  const f = t.let("valid", !1), v = t.name("_valid");
  t.block(() => r.forEach(($, m) => {
    const h = e.subschema({
      keyword: a,
      schemaProp: m,
      compositeRule: !0
    }, v);
    t.assign(f, (0, fe._)`${f} || ${v}`), e.mergeValidEvaluated(h, v) || t.if((0, fe.not)(f));
  })), e.result(f, () => e.reset(), () => e.error(!0));
}
ne.validateUnion = Rs;
Object.defineProperty(Ye, "__esModule", { value: !0 });
Ye.validateKeywordUsage = Ye.validSchemaType = Ye.funcKeywordCode = Ye.macroKeywordCode = void 0;
const we = re, pt = ze, Ts = ne, Ns = jt;
function Cs(e, t) {
  const { gen: r, keyword: a, schema: n, parentSchema: c, it: f } = e, v = t.macro.call(f.self, n, c, f), $ = ga(r, a, v);
  f.opts.validateSchema !== !1 && f.self.validateSchema(v, !0);
  const m = r.name("valid");
  e.subschema({
    schema: v,
    schemaPath: we.nil,
    errSchemaPath: `${f.errSchemaPath}/${a}`,
    topSchemaRef: $,
    compositeRule: !0
  }, m), e.pass(m, () => e.error(!0));
}
Ye.macroKeywordCode = Cs;
function js(e, t) {
  var r;
  const { gen: a, keyword: n, schema: c, parentSchema: f, $data: v, it: $ } = e;
  Is($, t);
  const m = !v && t.compile ? t.compile.call($.self, c, f, $) : t.validate, h = ga(a, n, m), E = a.let("valid");
  e.block$data(E, D), e.ok((r = t.valid) !== null && r !== void 0 ? r : E);
  function D() {
    if (t.errors === !1)
      T(), t.modifying && Wn(e), w(() => e.error());
    else {
      const p = t.async ? k() : R();
      t.modifying && Wn(e), w(() => ks(e, p));
    }
  }
  function k() {
    const p = a.let("ruleErrs", null);
    return a.try(() => T((0, we._)`await `), (d) => a.assign(E, !1).if((0, we._)`${d} instanceof ${$.ValidationError}`, () => a.assign(p, (0, we._)`${d}.errors`), () => a.throw(d))), p;
  }
  function R() {
    const p = (0, we._)`${h}.errors`;
    return a.assign(p, null), T(we.nil), p;
  }
  function T(p = t.async ? (0, we._)`await ` : we.nil) {
    const d = $.opts.passContext ? pt.default.this : pt.default.self, N = !("compile" in t && !v || t.schema === !1);
    a.assign(E, (0, we._)`${p}${(0, Ts.callValidateCode)(e, h, d, N)}`, t.modifying);
  }
  function w(p) {
    var d;
    a.if((0, we.not)((d = t.valid) !== null && d !== void 0 ? d : E), p);
  }
}
Ye.funcKeywordCode = js;
function Wn(e) {
  const { gen: t, data: r, it: a } = e;
  t.if(a.parentData, () => t.assign(r, (0, we._)`${a.parentData}[${a.parentDataProperty}]`));
}
function ks(e, t) {
  const { gen: r } = e;
  r.if((0, we._)`Array.isArray(${t})`, () => {
    r.assign(pt.default.vErrors, (0, we._)`${pt.default.vErrors} === null ? ${t} : ${pt.default.vErrors}.concat(${t})`).assign(pt.default.errors, (0, we._)`${pt.default.vErrors}.length`), (0, Ns.extendErrors)(e);
  }, () => e.error());
}
function Is({ schemaEnv: e }, t) {
  if (t.async && !e.$async)
    throw new Error("async keyword in sync schema");
}
function ga(e, t, r) {
  if (r === void 0)
    throw new Error(`keyword "${t}" failed to compile`);
  return e.scopeValue("keyword", typeof r == "function" ? { ref: r } : { ref: r, code: (0, we.stringify)(r) });
}
function Ds(e, t, r = !1) {
  return !t.length || t.some((a) => a === "array" ? Array.isArray(e) : a === "object" ? e && typeof e == "object" && !Array.isArray(e) : typeof e == a || r && typeof e > "u");
}
Ye.validSchemaType = Ds;
function As({ schema: e, opts: t, self: r, errSchemaPath: a }, n, c) {
  if (Array.isArray(n.keyword) ? !n.keyword.includes(c) : n.keyword !== c)
    throw new Error("ajv implementation error");
  const f = n.dependencies;
  if (f != null && f.some((v) => !Object.prototype.hasOwnProperty.call(e, v)))
    throw new Error(`parent schema must have dependencies of ${c}: ${f.join(",")}`);
  if (n.validateSchema && !n.validateSchema(e[c])) {
    const $ = `keyword "${c}" value is invalid at path "${a}": ` + r.errorsText(n.validateSchema.errors);
    if (t.validateSchema === "log")
      r.logger.error($);
    else
      throw new Error($);
  }
}
Ye.validateKeywordUsage = As;
var ct = {};
Object.defineProperty(ct, "__esModule", { value: !0 });
ct.extendSubschemaMode = ct.extendSubschemaData = ct.getSubschema = void 0;
const Je = re, Ea = oe;
function Ms(e, { keyword: t, schemaProp: r, schema: a, schemaPath: n, errSchemaPath: c, topSchemaRef: f }) {
  if (t !== void 0 && a !== void 0)
    throw new Error('both "keyword" and "schema" passed, only one allowed');
  if (t !== void 0) {
    const v = e.schema[t];
    return r === void 0 ? {
      schema: v,
      schemaPath: (0, Je._)`${e.schemaPath}${(0, Je.getProperty)(t)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}`
    } : {
      schema: v[r],
      schemaPath: (0, Je._)`${e.schemaPath}${(0, Je.getProperty)(t)}${(0, Je.getProperty)(r)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}/${(0, Ea.escapeFragment)(r)}`
    };
  }
  if (a !== void 0) {
    if (n === void 0 || c === void 0 || f === void 0)
      throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
    return {
      schema: a,
      schemaPath: n,
      topSchemaRef: f,
      errSchemaPath: c
    };
  }
  throw new Error('either "keyword" or "schema" must be passed');
}
ct.getSubschema = Ms;
function Fs(e, t, { dataProp: r, dataPropType: a, data: n, dataTypes: c, propertyName: f }) {
  if (n !== void 0 && r !== void 0)
    throw new Error('both "data" and "dataProp" passed, only one allowed');
  const { gen: v } = t;
  if (r !== void 0) {
    const { errorPath: m, dataPathArr: h, opts: E } = t, D = v.let("data", (0, Je._)`${t.data}${(0, Je.getProperty)(r)}`, !0);
    $(D), e.errorPath = (0, Je.str)`${m}${(0, Ea.getErrorPath)(r, a, E.jsPropertySyntax)}`, e.parentDataProperty = (0, Je._)`${r}`, e.dataPathArr = [...h, e.parentDataProperty];
  }
  if (n !== void 0) {
    const m = n instanceof Je.Name ? n : v.let("data", n, !0);
    $(m), f !== void 0 && (e.propertyName = f);
  }
  c && (e.dataTypes = c);
  function $(m) {
    e.data = m, e.dataLevel = t.dataLevel + 1, e.dataTypes = [], t.definedProperties = /* @__PURE__ */ new Set(), e.parentData = t.data, e.dataNames = [...t.dataNames, m];
  }
}
ct.extendSubschemaData = Fs;
function Vs(e, { jtdDiscriminator: t, jtdMetadata: r, compositeRule: a, createErrors: n, allErrors: c }) {
  a !== void 0 && (e.compositeRule = a), n !== void 0 && (e.createErrors = n), c !== void 0 && (e.allErrors = c), e.jtdDiscriminator = t, e.jtdMetadata = r;
}
ct.extendSubschemaMode = Vs;
var $e = {}, wa = function e(t, r) {
  if (t === r)
    return !0;
  if (t && r && typeof t == "object" && typeof r == "object") {
    if (t.constructor !== r.constructor)
      return !1;
    var a, n, c;
    if (Array.isArray(t)) {
      if (a = t.length, a != r.length)
        return !1;
      for (n = a; n-- !== 0; )
        if (!e(t[n], r[n]))
          return !1;
      return !0;
    }
    if (t.constructor === RegExp)
      return t.source === r.source && t.flags === r.flags;
    if (t.valueOf !== Object.prototype.valueOf)
      return t.valueOf() === r.valueOf();
    if (t.toString !== Object.prototype.toString)
      return t.toString() === r.toString();
    if (c = Object.keys(t), a = c.length, a !== Object.keys(r).length)
      return !1;
    for (n = a; n-- !== 0; )
      if (!Object.prototype.hasOwnProperty.call(r, c[n]))
        return !1;
    for (n = a; n-- !== 0; ) {
      var f = c[n];
      if (!e(t[f], r[f]))
        return !1;
    }
    return !0;
  }
  return t !== t && r !== r;
}, ba = { exports: {} }, it = ba.exports = function(e, t, r) {
  typeof t == "function" && (r = t, t = {}), r = t.cb || r;
  var a = typeof r == "function" ? r : r.pre || function() {
  }, n = r.post || function() {
  };
  $r(t, a, n, e, "", e);
};
it.keywords = {
  additionalItems: !0,
  items: !0,
  contains: !0,
  additionalProperties: !0,
  propertyNames: !0,
  not: !0,
  if: !0,
  then: !0,
  else: !0
};
it.arrayKeywords = {
  items: !0,
  allOf: !0,
  anyOf: !0,
  oneOf: !0
};
it.propsKeywords = {
  $defs: !0,
  definitions: !0,
  properties: !0,
  patternProperties: !0,
  dependencies: !0
};
it.skipKeywords = {
  default: !0,
  enum: !0,
  const: !0,
  required: !0,
  maximum: !0,
  minimum: !0,
  exclusiveMaximum: !0,
  exclusiveMinimum: !0,
  multipleOf: !0,
  maxLength: !0,
  minLength: !0,
  pattern: !0,
  format: !0,
  maxItems: !0,
  minItems: !0,
  uniqueItems: !0,
  maxProperties: !0,
  minProperties: !0
};
function $r(e, t, r, a, n, c, f, v, $, m) {
  if (a && typeof a == "object" && !Array.isArray(a)) {
    t(a, n, c, f, v, $, m);
    for (var h in a) {
      var E = a[h];
      if (Array.isArray(E)) {
        if (h in it.arrayKeywords)
          for (var D = 0; D < E.length; D++)
            $r(e, t, r, E[D], n + "/" + h + "/" + D, c, n, h, a, D);
      } else if (h in it.propsKeywords) {
        if (E && typeof E == "object")
          for (var k in E)
            $r(e, t, r, E[k], n + "/" + h + "/" + zs(k), c, n, h, a, k);
      } else
        (h in it.keywords || e.allKeys && !(h in it.skipKeywords)) && $r(e, t, r, E, n + "/" + h, c, n, h, a);
    }
    r(a, n, c, f, v, $, m);
  }
}
function zs(e) {
  return e.replace(/~/g, "~0").replace(/\//g, "~1");
}
var Us = ba.exports;
Object.defineProperty($e, "__esModule", { value: !0 });
$e.getSchemaRefs = $e.resolveUrl = $e.normalizeId = $e._getFullPath = $e.getFullPath = $e.inlineRef = void 0;
const qs = oe, Ls = wa, Ks = Us, Gs = /* @__PURE__ */ new Set([
  "type",
  "format",
  "pattern",
  "maxLength",
  "minLength",
  "maxProperties",
  "minProperties",
  "maxItems",
  "minItems",
  "maximum",
  "minimum",
  "uniqueItems",
  "multipleOf",
  "required",
  "enum",
  "const"
]);
function Hs(e, t = !0) {
  return typeof e == "boolean" ? !0 : t === !0 ? !Hr(e) : t ? Sa(e) <= t : !1;
}
$e.inlineRef = Hs;
const Ws = /* @__PURE__ */ new Set([
  "$ref",
  "$recursiveRef",
  "$recursiveAnchor",
  "$dynamicRef",
  "$dynamicAnchor"
]);
function Hr(e) {
  for (const t in e) {
    if (Ws.has(t))
      return !0;
    const r = e[t];
    if (Array.isArray(r) && r.some(Hr) || typeof r == "object" && Hr(r))
      return !0;
  }
  return !1;
}
function Sa(e) {
  let t = 0;
  for (const r in e) {
    if (r === "$ref")
      return 1 / 0;
    if (t++, !Gs.has(r) && (typeof e[r] == "object" && (0, qs.eachItem)(e[r], (a) => t += Sa(a)), t === 1 / 0))
      return 1 / 0;
  }
  return t;
}
function Pa(e, t = "", r) {
  r !== !1 && (t = Rt(t));
  const a = e.parse(t);
  return Oa(e, a);
}
$e.getFullPath = Pa;
function Oa(e, t) {
  return e.serialize(t).split("#")[0] + "#";
}
$e._getFullPath = Oa;
const Js = /#\/?$/;
function Rt(e) {
  return e ? e.replace(Js, "") : "";
}
$e.normalizeId = Rt;
function Ys(e, t, r) {
  return r = Rt(r), e.resolve(t, r);
}
$e.resolveUrl = Ys;
const Bs = /^[a-z_][-a-z0-9._]*$/i;
function Xs(e, t) {
  if (typeof e == "boolean")
    return {};
  const { schemaId: r, uriResolver: a } = this.opts, n = Rt(e[r] || t), c = { "": n }, f = Pa(a, n, !1), v = {}, $ = /* @__PURE__ */ new Set();
  return Ks(e, { allKeys: !0 }, (E, D, k, R) => {
    if (R === void 0)
      return;
    const T = f + D;
    let w = c[R];
    typeof E[r] == "string" && (w = p.call(this, E[r])), d.call(this, E.$anchor), d.call(this, E.$dynamicAnchor), c[D] = w;
    function p(N) {
      const j = this.opts.uriResolver.resolve;
      if (N = Rt(w ? j(w, N) : N), $.has(N))
        throw h(N);
      $.add(N);
      let z = this.refs[N];
      return typeof z == "string" && (z = this.refs[z]), typeof z == "object" ? m(E, z.schema, N) : N !== Rt(T) && (N[0] === "#" ? (m(E, v[N], N), v[N] = E) : this.refs[N] = T), N;
    }
    function d(N) {
      if (typeof N == "string") {
        if (!Bs.test(N))
          throw new Error(`invalid anchor "${N}"`);
        p.call(this, `#${N}`);
      }
    }
  }), v;
  function m(E, D, k) {
    if (D !== void 0 && !Ls(E, D))
      throw h(k);
  }
  function h(E) {
    return new Error(`reference "${E}" resolves to more than one schema`);
  }
}
$e.getSchemaRefs = Xs;
Object.defineProperty(ke, "__esModule", { value: !0 });
ke.getData = ke.KeywordCxt = ke.validateFunctionCode = void 0;
const Ra = Tt, Jn = Zt, rn = Qe, wr = Zt, Zs = Rr, Wt = Ye, Fr = ct, Y = re, x = ze, Qs = $e, xe = oe, qt = jt;
function xs(e) {
  if (Ca(e) && (ja(e), Na(e))) {
    ro(e);
    return;
  }
  Ta(e, () => (0, Ra.topBoolOrEmptySchema)(e));
}
ke.validateFunctionCode = xs;
function Ta({ gen: e, validateName: t, schema: r, schemaEnv: a, opts: n }, c) {
  n.code.es5 ? e.func(t, (0, Y._)`${x.default.data}, ${x.default.valCxt}`, a.$async, () => {
    e.code((0, Y._)`"use strict"; ${Yn(r, n)}`), to(e, n), e.code(c);
  }) : e.func(t, (0, Y._)`${x.default.data}, ${eo(n)}`, a.$async, () => e.code(Yn(r, n)).code(c));
}
function eo(e) {
  return (0, Y._)`{${x.default.instancePath}="", ${x.default.parentData}, ${x.default.parentDataProperty}, ${x.default.rootData}=${x.default.data}${e.dynamicRef ? (0, Y._)`, ${x.default.dynamicAnchors}={}` : Y.nil}}={}`;
}
function to(e, t) {
  e.if(x.default.valCxt, () => {
    e.var(x.default.instancePath, (0, Y._)`${x.default.valCxt}.${x.default.instancePath}`), e.var(x.default.parentData, (0, Y._)`${x.default.valCxt}.${x.default.parentData}`), e.var(x.default.parentDataProperty, (0, Y._)`${x.default.valCxt}.${x.default.parentDataProperty}`), e.var(x.default.rootData, (0, Y._)`${x.default.valCxt}.${x.default.rootData}`), t.dynamicRef && e.var(x.default.dynamicAnchors, (0, Y._)`${x.default.valCxt}.${x.default.dynamicAnchors}`);
  }, () => {
    e.var(x.default.instancePath, (0, Y._)`""`), e.var(x.default.parentData, (0, Y._)`undefined`), e.var(x.default.parentDataProperty, (0, Y._)`undefined`), e.var(x.default.rootData, x.default.data), t.dynamicRef && e.var(x.default.dynamicAnchors, (0, Y._)`{}`);
  });
}
function ro(e) {
  const { schema: t, opts: r, gen: a } = e;
  Ta(e, () => {
    r.$comment && t.$comment && Ia(e), io(e), a.let(x.default.vErrors, null), a.let(x.default.errors, 0), r.unevaluated && no(e), ka(e), lo(e);
  });
}
function no(e) {
  const { gen: t, validateName: r } = e;
  e.evaluated = t.const("evaluated", (0, Y._)`${r}.evaluated`), t.if((0, Y._)`${e.evaluated}.dynamicProps`, () => t.assign((0, Y._)`${e.evaluated}.props`, (0, Y._)`undefined`)), t.if((0, Y._)`${e.evaluated}.dynamicItems`, () => t.assign((0, Y._)`${e.evaluated}.items`, (0, Y._)`undefined`));
}
function Yn(e, t) {
  const r = typeof e == "object" && e[t.schemaId];
  return r && (t.code.source || t.code.process) ? (0, Y._)`/*# sourceURL=${r} */` : Y.nil;
}
function ao(e, t) {
  if (Ca(e) && (ja(e), Na(e))) {
    so(e, t);
    return;
  }
  (0, Ra.boolOrEmptySchema)(e, t);
}
function Na({ schema: e, self: t }) {
  if (typeof e == "boolean")
    return !e;
  for (const r in e)
    if (t.RULES.all[r])
      return !0;
  return !1;
}
function Ca(e) {
  return typeof e.schema != "boolean";
}
function so(e, t) {
  const { schema: r, gen: a, opts: n } = e;
  n.$comment && r.$comment && Ia(e), co(e), uo(e);
  const c = a.const("_errs", x.default.errors);
  ka(e, c), a.var(t, (0, Y._)`${c} === ${x.default.errors}`);
}
function ja(e) {
  (0, xe.checkUnknownRules)(e), oo(e);
}
function ka(e, t) {
  if (e.opts.jtd)
    return Bn(e, [], !1, t);
  const r = (0, Jn.getSchemaTypes)(e.schema), a = (0, Jn.coerceAndCheckDataType)(e, r);
  Bn(e, r, !a, t);
}
function oo(e) {
  const { schema: t, errSchemaPath: r, opts: a, self: n } = e;
  t.$ref && a.ignoreKeywordsWithRef && (0, xe.schemaHasRulesButRef)(t, n.RULES) && n.logger.warn(`$ref: keywords ignored in schema at path "${r}"`);
}
function io(e) {
  const { schema: t, opts: r } = e;
  t.default !== void 0 && r.useDefaults && r.strictSchema && (0, xe.checkStrictMode)(e, "default is ignored in the schema root");
}
function co(e) {
  const t = e.schema[e.opts.schemaId];
  t && (e.baseId = (0, Qs.resolveUrl)(e.opts.uriResolver, e.baseId, t));
}
function uo(e) {
  if (e.schema.$async && !e.schemaEnv.$async)
    throw new Error("async schema in sync schema");
}
function Ia({ gen: e, schemaEnv: t, schema: r, errSchemaPath: a, opts: n }) {
  const c = r.$comment;
  if (n.$comment === !0)
    e.code((0, Y._)`${x.default.self}.logger.log(${c})`);
  else if (typeof n.$comment == "function") {
    const f = (0, Y.str)`${a}/$comment`, v = e.scopeValue("root", { ref: t.root });
    e.code((0, Y._)`${x.default.self}.opts.$comment(${c}, ${f}, ${v}.schema)`);
  }
}
function lo(e) {
  const { gen: t, schemaEnv: r, validateName: a, ValidationError: n, opts: c } = e;
  r.$async ? t.if((0, Y._)`${x.default.errors} === 0`, () => t.return(x.default.data), () => t.throw((0, Y._)`new ${n}(${x.default.vErrors})`)) : (t.assign((0, Y._)`${a}.errors`, x.default.vErrors), c.unevaluated && fo(e), t.return((0, Y._)`${x.default.errors} === 0`));
}
function fo({ gen: e, evaluated: t, props: r, items: a }) {
  r instanceof Y.Name && e.assign((0, Y._)`${t}.props`, r), a instanceof Y.Name && e.assign((0, Y._)`${t}.items`, a);
}
function Bn(e, t, r, a) {
  const { gen: n, schema: c, data: f, allErrors: v, opts: $, self: m } = e, { RULES: h } = m;
  if (c.$ref && ($.ignoreKeywordsWithRef || !(0, xe.schemaHasRulesButRef)(c, h))) {
    n.block(() => Ma(e, "$ref", h.all.$ref.definition));
    return;
  }
  $.jtd || ho(e, t), n.block(() => {
    for (const D of h.rules)
      E(D);
    E(h.post);
  });
  function E(D) {
    (0, rn.shouldUseGroup)(c, D) && (D.type ? (n.if((0, wr.checkDataType)(D.type, f, $.strictNumbers)), Xn(e, D), t.length === 1 && t[0] === D.type && r && (n.else(), (0, wr.reportTypeError)(e)), n.endIf()) : Xn(e, D), v || n.if((0, Y._)`${x.default.errors} === ${a || 0}`));
  }
}
function Xn(e, t) {
  const { gen: r, schema: a, opts: { useDefaults: n } } = e;
  n && (0, Zs.assignDefaults)(e, t.type), r.block(() => {
    for (const c of t.rules)
      (0, rn.shouldUseRule)(a, c) && Ma(e, c.keyword, c.definition, t.type);
  });
}
function ho(e, t) {
  e.schemaEnv.meta || !e.opts.strictTypes || (mo(e, t), e.opts.allowUnionTypes || po(e, t), vo(e, e.dataTypes));
}
function mo(e, t) {
  if (t.length) {
    if (!e.dataTypes.length) {
      e.dataTypes = t;
      return;
    }
    t.forEach((r) => {
      Da(e.dataTypes, r) || nn(e, `type "${r}" not allowed by context "${e.dataTypes.join(",")}"`);
    }), $o(e, t);
  }
}
function po(e, t) {
  t.length > 1 && !(t.length === 2 && t.includes("null")) && nn(e, "use allowUnionTypes to allow union type keyword");
}
function vo(e, t) {
  const r = e.self.RULES.all;
  for (const a in r) {
    const n = r[a];
    if (typeof n == "object" && (0, rn.shouldUseRule)(e.schema, n)) {
      const { type: c } = n.definition;
      c.length && !c.some((f) => yo(t, f)) && nn(e, `missing type "${c.join(",")}" for keyword "${a}"`);
    }
  }
}
function yo(e, t) {
  return e.includes(t) || t === "number" && e.includes("integer");
}
function Da(e, t) {
  return e.includes(t) || t === "integer" && e.includes("number");
}
function $o(e, t) {
  const r = [];
  for (const a of e.dataTypes)
    Da(t, a) ? r.push(a) : t.includes("integer") && a === "number" && r.push("integer");
  e.dataTypes = r;
}
function nn(e, t) {
  const r = e.schemaEnv.baseId + e.errSchemaPath;
  t += ` at "${r}" (strictTypes)`, (0, xe.checkStrictMode)(e, t, e.opts.strictTypes);
}
class Aa {
  constructor(t, r, a) {
    if ((0, Wt.validateKeywordUsage)(t, r, a), this.gen = t.gen, this.allErrors = t.allErrors, this.keyword = a, this.data = t.data, this.schema = t.schema[a], this.$data = r.$data && t.opts.$data && this.schema && this.schema.$data, this.schemaValue = (0, xe.schemaRefOrVal)(t, this.schema, a, this.$data), this.schemaType = r.schemaType, this.parentSchema = t.schema, this.params = {}, this.it = t, this.def = r, this.$data)
      this.schemaCode = t.gen.const("vSchema", Fa(this.$data, t));
    else if (this.schemaCode = this.schemaValue, !(0, Wt.validSchemaType)(this.schema, r.schemaType, r.allowUndefined))
      throw new Error(`${a} value must be ${JSON.stringify(r.schemaType)}`);
    ("code" in r ? r.trackErrors : r.errors !== !1) && (this.errsCount = t.gen.const("_errs", x.default.errors));
  }
  result(t, r, a) {
    this.failResult((0, Y.not)(t), r, a);
  }
  failResult(t, r, a) {
    this.gen.if(t), a ? a() : this.error(), r ? (this.gen.else(), r(), this.allErrors && this.gen.endIf()) : this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  pass(t, r) {
    this.failResult((0, Y.not)(t), void 0, r);
  }
  fail(t) {
    if (t === void 0) {
      this.error(), this.allErrors || this.gen.if(!1);
      return;
    }
    this.gen.if(t), this.error(), this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  fail$data(t) {
    if (!this.$data)
      return this.fail(t);
    const { schemaCode: r } = this;
    this.fail((0, Y._)`${r} !== undefined && (${(0, Y.or)(this.invalid$data(), t)})`);
  }
  error(t, r, a) {
    if (r) {
      this.setParams(r), this._error(t, a), this.setParams({});
      return;
    }
    this._error(t, a);
  }
  _error(t, r) {
    (t ? qt.reportExtraError : qt.reportError)(this, this.def.error, r);
  }
  $dataError() {
    (0, qt.reportError)(this, this.def.$dataError || qt.keyword$DataError);
  }
  reset() {
    if (this.errsCount === void 0)
      throw new Error('add "trackErrors" to keyword definition');
    (0, qt.resetErrorsCount)(this.gen, this.errsCount);
  }
  ok(t) {
    this.allErrors || this.gen.if(t);
  }
  setParams(t, r) {
    r ? Object.assign(this.params, t) : this.params = t;
  }
  block$data(t, r, a = Y.nil) {
    this.gen.block(() => {
      this.check$data(t, a), r();
    });
  }
  check$data(t = Y.nil, r = Y.nil) {
    if (!this.$data)
      return;
    const { gen: a, schemaCode: n, schemaType: c, def: f } = this;
    a.if((0, Y.or)((0, Y._)`${n} === undefined`, r)), t !== Y.nil && a.assign(t, !0), (c.length || f.validateSchema) && (a.elseIf(this.invalid$data()), this.$dataError(), t !== Y.nil && a.assign(t, !1)), a.else();
  }
  invalid$data() {
    const { gen: t, schemaCode: r, schemaType: a, def: n, it: c } = this;
    return (0, Y.or)(f(), v());
    function f() {
      if (a.length) {
        if (!(r instanceof Y.Name))
          throw new Error("ajv implementation error");
        const $ = Array.isArray(a) ? a : [a];
        return (0, Y._)`${(0, wr.checkDataTypes)($, r, c.opts.strictNumbers, wr.DataType.Wrong)}`;
      }
      return Y.nil;
    }
    function v() {
      if (n.validateSchema) {
        const $ = t.scopeValue("validate$data", { ref: n.validateSchema });
        return (0, Y._)`!${$}(${r})`;
      }
      return Y.nil;
    }
  }
  subschema(t, r) {
    const a = (0, Fr.getSubschema)(this.it, t);
    (0, Fr.extendSubschemaData)(a, this.it, t), (0, Fr.extendSubschemaMode)(a, t);
    const n = { ...this.it, ...a, items: void 0, props: void 0 };
    return ao(n, r), n;
  }
  mergeEvaluated(t, r) {
    const { it: a, gen: n } = this;
    a.opts.unevaluated && (a.props !== !0 && t.props !== void 0 && (a.props = xe.mergeEvaluated.props(n, t.props, a.props, r)), a.items !== !0 && t.items !== void 0 && (a.items = xe.mergeEvaluated.items(n, t.items, a.items, r)));
  }
  mergeValidEvaluated(t, r) {
    const { it: a, gen: n } = this;
    if (a.opts.unevaluated && (a.props !== !0 || a.items !== !0))
      return n.if(r, () => this.mergeEvaluated(t, Y.Name)), !0;
  }
}
ke.KeywordCxt = Aa;
function Ma(e, t, r, a) {
  const n = new Aa(e, r, t);
  "code" in r ? r.code(n, a) : n.$data && r.validate ? (0, Wt.funcKeywordCode)(n, r) : "macro" in r ? (0, Wt.macroKeywordCode)(n, r) : (r.compile || r.validate) && (0, Wt.funcKeywordCode)(n, r);
}
const _o = /^\/(?:[^~]|~0|~1)*$/, go = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
function Fa(e, { dataLevel: t, dataNames: r, dataPathArr: a }) {
  let n, c;
  if (e === "")
    return x.default.rootData;
  if (e[0] === "/") {
    if (!_o.test(e))
      throw new Error(`Invalid JSON-pointer: ${e}`);
    n = e, c = x.default.rootData;
  } else {
    const m = go.exec(e);
    if (!m)
      throw new Error(`Invalid JSON-pointer: ${e}`);
    const h = +m[1];
    if (n = m[2], n === "#") {
      if (h >= t)
        throw new Error($("property/index", h));
      return a[t - h];
    }
    if (h > t)
      throw new Error($("data", h));
    if (c = r[t - h], !n)
      return c;
  }
  let f = c;
  const v = n.split("/");
  for (const m of v)
    m && (c = (0, Y._)`${c}${(0, Y.getProperty)((0, xe.unescapeJsonPointer)(m))}`, f = (0, Y._)`${f} && ${c}`);
  return f;
  function $(m, h) {
    return `Cannot access ${m} ${h} levels up, current level is ${t}`;
  }
}
ke.getData = Fa;
var Qt = {};
Object.defineProperty(Qt, "__esModule", { value: !0 });
class Eo extends Error {
  constructor(t) {
    super("validation failed"), this.errors = t, this.ajv = this.validation = !0;
  }
}
Qt.default = Eo;
var xt = {};
Object.defineProperty(xt, "__esModule", { value: !0 });
const Vr = $e;
class wo extends Error {
  constructor(t, r, a, n) {
    super(n || `can't resolve reference ${a} from id ${r}`), this.missingRef = (0, Vr.resolveUrl)(t, r, a), this.missingSchema = (0, Vr.normalizeId)((0, Vr.getFullPath)(t, this.missingRef));
  }
}
xt.default = wo;
var Pe = {};
Object.defineProperty(Pe, "__esModule", { value: !0 });
Pe.resolveSchema = Pe.getCompilingSchema = Pe.resolveRef = Pe.compileSchema = Pe.SchemaEnv = void 0;
const Me = re, bo = Qt, mt = ze, Ve = $e, Zn = oe, So = ke;
class Tr {
  constructor(t) {
    var r;
    this.refs = {}, this.dynamicAnchors = {};
    let a;
    typeof t.schema == "object" && (a = t.schema), this.schema = t.schema, this.schemaId = t.schemaId, this.root = t.root || this, this.baseId = (r = t.baseId) !== null && r !== void 0 ? r : (0, Ve.normalizeId)(a == null ? void 0 : a[t.schemaId || "$id"]), this.schemaPath = t.schemaPath, this.localRefs = t.localRefs, this.meta = t.meta, this.$async = a == null ? void 0 : a.$async, this.refs = {};
  }
}
Pe.SchemaEnv = Tr;
function an(e) {
  const t = Va.call(this, e);
  if (t)
    return t;
  const r = (0, Ve.getFullPath)(this.opts.uriResolver, e.root.baseId), { es5: a, lines: n } = this.opts.code, { ownProperties: c } = this.opts, f = new Me.CodeGen(this.scope, { es5: a, lines: n, ownProperties: c });
  let v;
  e.$async && (v = f.scopeValue("Error", {
    ref: bo.default,
    code: (0, Me._)`require("ajv/dist/runtime/validation_error").default`
  }));
  const $ = f.scopeName("validate");
  e.validateName = $;
  const m = {
    gen: f,
    allErrors: this.opts.allErrors,
    data: mt.default.data,
    parentData: mt.default.parentData,
    parentDataProperty: mt.default.parentDataProperty,
    dataNames: [mt.default.data],
    dataPathArr: [Me.nil],
    dataLevel: 0,
    dataTypes: [],
    definedProperties: /* @__PURE__ */ new Set(),
    topSchemaRef: f.scopeValue("schema", this.opts.code.source === !0 ? { ref: e.schema, code: (0, Me.stringify)(e.schema) } : { ref: e.schema }),
    validateName: $,
    ValidationError: v,
    schema: e.schema,
    schemaEnv: e,
    rootId: r,
    baseId: e.baseId || r,
    schemaPath: Me.nil,
    errSchemaPath: e.schemaPath || (this.opts.jtd ? "" : "#"),
    errorPath: (0, Me._)`""`,
    opts: this.opts,
    self: this
  };
  let h;
  try {
    this._compilations.add(e), (0, So.validateFunctionCode)(m), f.optimize(this.opts.code.optimize);
    const E = f.toString();
    h = `${f.scopeRefs(mt.default.scope)}return ${E}`, this.opts.code.process && (h = this.opts.code.process(h, e));
    const k = new Function(`${mt.default.self}`, `${mt.default.scope}`, h)(this, this.scope.get());
    if (this.scope.value($, { ref: k }), k.errors = null, k.schema = e.schema, k.schemaEnv = e, e.$async && (k.$async = !0), this.opts.code.source === !0 && (k.source = { validateName: $, validateCode: E, scopeValues: f._values }), this.opts.unevaluated) {
      const { props: R, items: T } = m;
      k.evaluated = {
        props: R instanceof Me.Name ? void 0 : R,
        items: T instanceof Me.Name ? void 0 : T,
        dynamicProps: R instanceof Me.Name,
        dynamicItems: T instanceof Me.Name
      }, k.source && (k.source.evaluated = (0, Me.stringify)(k.evaluated));
    }
    return e.validate = k, e;
  } catch (E) {
    throw delete e.validate, delete e.validateName, h && this.logger.error("Error compiling schema, function code:", h), E;
  } finally {
    this._compilations.delete(e);
  }
}
Pe.compileSchema = an;
function Po(e, t, r) {
  var a;
  r = (0, Ve.resolveUrl)(this.opts.uriResolver, t, r);
  const n = e.refs[r];
  if (n)
    return n;
  let c = To.call(this, e, r);
  if (c === void 0) {
    const f = (a = e.localRefs) === null || a === void 0 ? void 0 : a[r], { schemaId: v } = this.opts;
    f && (c = new Tr({ schema: f, schemaId: v, root: e, baseId: t }));
  }
  if (c !== void 0)
    return e.refs[r] = Oo.call(this, c);
}
Pe.resolveRef = Po;
function Oo(e) {
  return (0, Ve.inlineRef)(e.schema, this.opts.inlineRefs) ? e.schema : e.validate ? e : an.call(this, e);
}
function Va(e) {
  for (const t of this._compilations)
    if (Ro(t, e))
      return t;
}
Pe.getCompilingSchema = Va;
function Ro(e, t) {
  return e.schema === t.schema && e.root === t.root && e.baseId === t.baseId;
}
function To(e, t) {
  let r;
  for (; typeof (r = this.refs[t]) == "string"; )
    t = r;
  return r || this.schemas[t] || Nr.call(this, e, t);
}
function Nr(e, t) {
  const r = this.opts.uriResolver.parse(t), a = (0, Ve._getFullPath)(this.opts.uriResolver, r);
  let n = (0, Ve.getFullPath)(this.opts.uriResolver, e.baseId, void 0);
  if (Object.keys(e.schema).length > 0 && a === n)
    return zr.call(this, r, e);
  const c = (0, Ve.normalizeId)(a), f = this.refs[c] || this.schemas[c];
  if (typeof f == "string") {
    const v = Nr.call(this, e, f);
    return typeof (v == null ? void 0 : v.schema) != "object" ? void 0 : zr.call(this, r, v);
  }
  if (typeof (f == null ? void 0 : f.schema) == "object") {
    if (f.validate || an.call(this, f), c === (0, Ve.normalizeId)(t)) {
      const { schema: v } = f, { schemaId: $ } = this.opts, m = v[$];
      return m && (n = (0, Ve.resolveUrl)(this.opts.uriResolver, n, m)), new Tr({ schema: v, schemaId: $, root: e, baseId: n });
    }
    return zr.call(this, r, f);
  }
}
Pe.resolveSchema = Nr;
const No = /* @__PURE__ */ new Set([
  "properties",
  "patternProperties",
  "enum",
  "dependencies",
  "definitions"
]);
function zr(e, { baseId: t, schema: r, root: a }) {
  var n;
  if (((n = e.fragment) === null || n === void 0 ? void 0 : n[0]) !== "/")
    return;
  for (const v of e.fragment.slice(1).split("/")) {
    if (typeof r == "boolean")
      return;
    const $ = r[(0, Zn.unescapeFragment)(v)];
    if ($ === void 0)
      return;
    r = $;
    const m = typeof r == "object" && r[this.opts.schemaId];
    !No.has(v) && m && (t = (0, Ve.resolveUrl)(this.opts.uriResolver, t, m));
  }
  let c;
  if (typeof r != "boolean" && r.$ref && !(0, Zn.schemaHasRulesButRef)(r, this.RULES)) {
    const v = (0, Ve.resolveUrl)(this.opts.uriResolver, t, r.$ref);
    c = Nr.call(this, a, v);
  }
  const { schemaId: f } = this.opts;
  if (c = c || new Tr({ schema: r, schemaId: f, root: a, baseId: t }), c.schema !== c.root.schema)
    return c;
}
const Co = "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#", jo = "Meta-schema for $data reference (JSON AnySchema extension proposal)", ko = "object", Io = [
  "$data"
], Do = {
  $data: {
    type: "string",
    anyOf: [
      {
        format: "relative-json-pointer"
      },
      {
        format: "json-pointer"
      }
    ]
  }
}, Ao = !1, Mo = {
  $id: Co,
  description: jo,
  type: ko,
  required: Io,
  properties: Do,
  additionalProperties: Ao
};
var sn = {}, Wr = { exports: {} };
/** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js */
(function(e, t) {
  (function(r, a) {
    a(t);
  })(rs, function(r) {
    function a() {
      for (var y = arguments.length, i = Array(y), _ = 0; _ < y; _++)
        i[_] = arguments[_];
      if (i.length > 1) {
        i[0] = i[0].slice(0, -1);
        for (var s = i.length - 1, u = 1; u < s; ++u)
          i[u] = i[u].slice(1, -1);
        return i[s] = i[s].slice(1), i.join("");
      } else
        return i[0];
    }
    function n(y) {
      return "(?:" + y + ")";
    }
    function c(y) {
      return y === void 0 ? "undefined" : y === null ? "null" : Object.prototype.toString.call(y).split(" ").pop().split("]").shift().toLowerCase();
    }
    function f(y) {
      return y.toUpperCase();
    }
    function v(y) {
      return y != null ? y instanceof Array ? y : typeof y.length != "number" || y.split || y.setInterval || y.call ? [y] : Array.prototype.slice.call(y) : [];
    }
    function $(y, i) {
      var _ = y;
      if (i)
        for (var s in i)
          _[s] = i[s];
      return _;
    }
    function m(y) {
      var i = "[A-Za-z]", _ = "[0-9]", s = a(_, "[A-Fa-f]"), u = n(n("%[EFef]" + s + "%" + s + s + "%" + s + s) + "|" + n("%[89A-Fa-f]" + s + "%" + s + s) + "|" + n("%" + s + s)), I = "[\\:\\/\\?\\#\\[\\]\\@]", V = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", H = a(I, V), X = y ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]", B = y ? "[\\uE000-\\uF8FF]" : "[]", K = a(i, _, "[\\-\\.\\_\\~]", X);
      n(i + a(i, _, "[\\+\\-\\.]") + "*"), n(n(u + "|" + a(K, V, "[\\:]")) + "*");
      var te = n(n("25[0-5]") + "|" + n("2[0-4]" + _) + "|" + n("1" + _ + _) + "|" + n("0?[1-9]" + _) + "|0?0?" + _), ee = n(te + "\\." + te + "\\." + te + "\\." + te), W = n(s + "{1,4}"), ae = n(n(W + "\\:" + W) + "|" + ee), le = n(n(W + "\\:") + "{6}" + ae), de = n("\\:\\:" + n(W + "\\:") + "{5}" + ae), ve = n(n(W) + "?\\:\\:" + n(W + "\\:") + "{4}" + ae), Ge = n(n(n(W + "\\:") + "{0,1}" + W) + "?\\:\\:" + n(W + "\\:") + "{3}" + ae), He = n(n(n(W + "\\:") + "{0,2}" + W) + "?\\:\\:" + n(W + "\\:") + "{2}" + ae), bt = n(n(n(W + "\\:") + "{0,3}" + W) + "?\\:\\:" + W + "\\:" + ae), ft = n(n(n(W + "\\:") + "{0,4}" + W) + "?\\:\\:" + ae), Ce = n(n(n(W + "\\:") + "{0,5}" + W) + "?\\:\\:" + W), We = n(n(n(W + "\\:") + "{0,6}" + W) + "?\\:\\:"), ht = n([le, de, ve, Ge, He, bt, ft, Ce, We].join("|")), Ze = n(n(K + "|" + u) + "+");
      n("[vV]" + s + "+\\." + a(K, V, "[\\:]") + "+"), n(n(u + "|" + a(K, V)) + "*");
      var zt = n(u + "|" + a(K, V, "[\\:\\@]"));
      return n(n(u + "|" + a(K, V, "[\\@]")) + "+"), n(n(zt + "|" + a("[\\/\\?]", B)) + "*"), {
        NOT_SCHEME: new RegExp(a("[^]", i, _, "[\\+\\-\\.]"), "g"),
        NOT_USERINFO: new RegExp(a("[^\\%\\:]", K, V), "g"),
        NOT_HOST: new RegExp(a("[^\\%\\[\\]\\:]", K, V), "g"),
        NOT_PATH: new RegExp(a("[^\\%\\/\\:\\@]", K, V), "g"),
        NOT_PATH_NOSCHEME: new RegExp(a("[^\\%\\/\\@]", K, V), "g"),
        NOT_QUERY: new RegExp(a("[^\\%]", K, V, "[\\:\\@\\/\\?]", B), "g"),
        NOT_FRAGMENT: new RegExp(a("[^\\%]", K, V, "[\\:\\@\\/\\?]"), "g"),
        ESCAPE: new RegExp(a("[^]", K, V), "g"),
        UNRESERVED: new RegExp(K, "g"),
        OTHER_CHARS: new RegExp(a("[^\\%]", K, H), "g"),
        PCT_ENCODED: new RegExp(u, "g"),
        IPV4ADDRESS: new RegExp("^(" + ee + ")$"),
        IPV6ADDRESS: new RegExp("^\\[?(" + ht + ")" + n(n("\\%25|\\%(?!" + s + "{2})") + "(" + Ze + ")") + "?\\]?$")
        //RFC 6874, with relaxed parsing rules
      };
    }
    var h = m(!1), E = m(!0), D = /* @__PURE__ */ function() {
      function y(i, _) {
        var s = [], u = !0, I = !1, V = void 0;
        try {
          for (var H = i[Symbol.iterator](), X; !(u = (X = H.next()).done) && (s.push(X.value), !(_ && s.length === _)); u = !0)
            ;
        } catch (B) {
          I = !0, V = B;
        } finally {
          try {
            !u && H.return && H.return();
          } finally {
            if (I)
              throw V;
          }
        }
        return s;
      }
      return function(i, _) {
        if (Array.isArray(i))
          return i;
        if (Symbol.iterator in Object(i))
          return y(i, _);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }(), k = function(y) {
      if (Array.isArray(y)) {
        for (var i = 0, _ = Array(y.length); i < y.length; i++)
          _[i] = y[i];
        return _;
      } else
        return Array.from(y);
    }, R = 2147483647, T = 36, w = 1, p = 26, d = 38, N = 700, j = 72, z = 128, S = "-", b = /^xn--/, A = /[^\0-\x7E]/, M = /[\x2E\u3002\uFF0E\uFF61]/g, L = {
      overflow: "Overflow: input needs wider integers to process",
      "not-basic": "Illegal input >= 0x80 (not a basic code point)",
      "invalid-input": "Invalid input"
    }, Q = T - w, J = Math.floor, ie = String.fromCharCode;
    function se(y) {
      throw new RangeError(L[y]);
    }
    function me(y, i) {
      for (var _ = [], s = y.length; s--; )
        _[s] = i(y[s]);
      return _;
    }
    function Oe(y, i) {
      var _ = y.split("@"), s = "";
      _.length > 1 && (s = _[0] + "@", y = _[1]), y = y.replace(M, ".");
      var u = y.split("."), I = me(u, i).join(".");
      return s + I;
    }
    function Ie(y) {
      for (var i = [], _ = 0, s = y.length; _ < s; ) {
        var u = y.charCodeAt(_++);
        if (u >= 55296 && u <= 56319 && _ < s) {
          var I = y.charCodeAt(_++);
          (I & 64512) == 56320 ? i.push(((u & 1023) << 10) + (I & 1023) + 65536) : (i.push(u), _--);
        } else
          i.push(u);
      }
      return i;
    }
    var Ue = function(i) {
      return String.fromCodePoint.apply(String, k(i));
    }, Re = function(i) {
      return i - 48 < 10 ? i - 22 : i - 65 < 26 ? i - 65 : i - 97 < 26 ? i - 97 : T;
    }, q = function(i, _) {
      return i + 22 + 75 * (i < 26) - ((_ != 0) << 5);
    }, P = function(i, _, s) {
      var u = 0;
      for (
        i = s ? J(i / N) : i >> 1, i += J(i / _);
        /* no initialization */
        i > Q * p >> 1;
        u += T
      )
        i = J(i / Q);
      return J(u + (Q + 1) * i / (i + d));
    }, O = function(i) {
      var _ = [], s = i.length, u = 0, I = z, V = j, H = i.lastIndexOf(S);
      H < 0 && (H = 0);
      for (var X = 0; X < H; ++X)
        i.charCodeAt(X) >= 128 && se("not-basic"), _.push(i.charCodeAt(X));
      for (var B = H > 0 ? H + 1 : 0; B < s; ) {
        for (
          var K = u, te = 1, ee = T;
          ;
          /* no condition */
          ee += T
        ) {
          B >= s && se("invalid-input");
          var W = Re(i.charCodeAt(B++));
          (W >= T || W > J((R - u) / te)) && se("overflow"), u += W * te;
          var ae = ee <= V ? w : ee >= V + p ? p : ee - V;
          if (W < ae)
            break;
          var le = T - ae;
          te > J(R / le) && se("overflow"), te *= le;
        }
        var de = _.length + 1;
        V = P(u - K, de, K == 0), J(u / de) > R - I && se("overflow"), I += J(u / de), u %= de, _.splice(u++, 0, I);
      }
      return String.fromCodePoint.apply(String, _);
    }, g = function(i) {
      var _ = [];
      i = Ie(i);
      var s = i.length, u = z, I = 0, V = j, H = !0, X = !1, B = void 0;
      try {
        for (var K = i[Symbol.iterator](), te; !(H = (te = K.next()).done); H = !0) {
          var ee = te.value;
          ee < 128 && _.push(ie(ee));
        }
      } catch (Ut) {
        X = !0, B = Ut;
      } finally {
        try {
          !H && K.return && K.return();
        } finally {
          if (X)
            throw B;
        }
      }
      var W = _.length, ae = W;
      for (W && _.push(S); ae < s; ) {
        var le = R, de = !0, ve = !1, Ge = void 0;
        try {
          for (var He = i[Symbol.iterator](), bt; !(de = (bt = He.next()).done); de = !0) {
            var ft = bt.value;
            ft >= u && ft < le && (le = ft);
          }
        } catch (Ut) {
          ve = !0, Ge = Ut;
        } finally {
          try {
            !de && He.return && He.return();
          } finally {
            if (ve)
              throw Ge;
          }
        }
        var Ce = ae + 1;
        le - u > J((R - I) / Ce) && se("overflow"), I += (le - u) * Ce, u = le;
        var We = !0, ht = !1, Ze = void 0;
        try {
          for (var zt = i[Symbol.iterator](), zn; !(We = (zn = zt.next()).done); We = !0) {
            var Un = zn.value;
            if (Un < u && ++I > R && se("overflow"), Un == u) {
              for (
                var cr = I, ur = T;
                ;
                /* no condition */
                ur += T
              ) {
                var lr = ur <= V ? w : ur >= V + p ? p : ur - V;
                if (cr < lr)
                  break;
                var qn = cr - lr, Ln = T - lr;
                _.push(ie(q(lr + qn % Ln, 0))), cr = J(qn / Ln);
              }
              _.push(ie(q(cr, 0))), V = P(I, Ce, ae == W), I = 0, ++ae;
            }
          }
        } catch (Ut) {
          ht = !0, Ze = Ut;
        } finally {
          try {
            !We && zt.return && zt.return();
          } finally {
            if (ht)
              throw Ze;
          }
        }
        ++I, ++u;
      }
      return _.join("");
    }, o = function(i) {
      return Oe(i, function(_) {
        return b.test(_) ? O(_.slice(4).toLowerCase()) : _;
      });
    }, l = function(i) {
      return Oe(i, function(_) {
        return A.test(_) ? "xn--" + g(_) : _;
      });
    }, C = {
      /**
       * A string representing the current Punycode.js version number.
       * @memberOf punycode
       * @type String
       */
      version: "2.1.0",
      /**
       * An object of methods to convert from JavaScript's internal character
       * representation (UCS-2) to Unicode code points, and back.
       * @see <https://mathiasbynens.be/notes/javascript-encoding>
       * @memberOf punycode
       * @type Object
       */
      ucs2: {
        decode: Ie,
        encode: Ue
      },
      decode: O,
      encode: g,
      toASCII: l,
      toUnicode: o
    }, U = {};
    function F(y) {
      var i = y.charCodeAt(0), _ = void 0;
      return i < 16 ? _ = "%0" + i.toString(16).toUpperCase() : i < 128 ? _ = "%" + i.toString(16).toUpperCase() : i < 2048 ? _ = "%" + (i >> 6 | 192).toString(16).toUpperCase() + "%" + (i & 63 | 128).toString(16).toUpperCase() : _ = "%" + (i >> 12 | 224).toString(16).toUpperCase() + "%" + (i >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (i & 63 | 128).toString(16).toUpperCase(), _;
    }
    function G(y) {
      for (var i = "", _ = 0, s = y.length; _ < s; ) {
        var u = parseInt(y.substr(_ + 1, 2), 16);
        if (u < 128)
          i += String.fromCharCode(u), _ += 3;
        else if (u >= 194 && u < 224) {
          if (s - _ >= 6) {
            var I = parseInt(y.substr(_ + 4, 2), 16);
            i += String.fromCharCode((u & 31) << 6 | I & 63);
          } else
            i += y.substr(_, 6);
          _ += 6;
        } else if (u >= 224) {
          if (s - _ >= 9) {
            var V = parseInt(y.substr(_ + 4, 2), 16), H = parseInt(y.substr(_ + 7, 2), 16);
            i += String.fromCharCode((u & 15) << 12 | (V & 63) << 6 | H & 63);
          } else
            i += y.substr(_, 9);
          _ += 9;
        } else
          i += y.substr(_, 3), _ += 3;
      }
      return i;
    }
    function Z(y, i) {
      function _(s) {
        var u = G(s);
        return u.match(i.UNRESERVED) ? u : s;
      }
      return y.scheme && (y.scheme = String(y.scheme).replace(i.PCT_ENCODED, _).toLowerCase().replace(i.NOT_SCHEME, "")), y.userinfo !== void 0 && (y.userinfo = String(y.userinfo).replace(i.PCT_ENCODED, _).replace(i.NOT_USERINFO, F).replace(i.PCT_ENCODED, f)), y.host !== void 0 && (y.host = String(y.host).replace(i.PCT_ENCODED, _).toLowerCase().replace(i.NOT_HOST, F).replace(i.PCT_ENCODED, f)), y.path !== void 0 && (y.path = String(y.path).replace(i.PCT_ENCODED, _).replace(y.scheme ? i.NOT_PATH : i.NOT_PATH_NOSCHEME, F).replace(i.PCT_ENCODED, f)), y.query !== void 0 && (y.query = String(y.query).replace(i.PCT_ENCODED, _).replace(i.NOT_QUERY, F).replace(i.PCT_ENCODED, f)), y.fragment !== void 0 && (y.fragment = String(y.fragment).replace(i.PCT_ENCODED, _).replace(i.NOT_FRAGMENT, F).replace(i.PCT_ENCODED, f)), y;
    }
    function ce(y) {
      return y.replace(/^0*(.*)/, "$1") || "0";
    }
    function ue(y, i) {
      var _ = y.match(i.IPV4ADDRESS) || [], s = D(_, 2), u = s[1];
      return u ? u.split(".").map(ce).join(".") : y;
    }
    function Te(y, i) {
      var _ = y.match(i.IPV6ADDRESS) || [], s = D(_, 3), u = s[1], I = s[2];
      if (u) {
        for (var V = u.toLowerCase().split("::").reverse(), H = D(V, 2), X = H[0], B = H[1], K = B ? B.split(":").map(ce) : [], te = X.split(":").map(ce), ee = i.IPV4ADDRESS.test(te[te.length - 1]), W = ee ? 7 : 8, ae = te.length - W, le = Array(W), de = 0; de < W; ++de)
          le[de] = K[de] || te[ae + de] || "";
        ee && (le[W - 1] = ue(le[W - 1], i));
        var ve = le.reduce(function(Ce, We, ht) {
          if (!We || We === "0") {
            var Ze = Ce[Ce.length - 1];
            Ze && Ze.index + Ze.length === ht ? Ze.length++ : Ce.push({ index: ht, length: 1 });
          }
          return Ce;
        }, []), Ge = ve.sort(function(Ce, We) {
          return We.length - Ce.length;
        })[0], He = void 0;
        if (Ge && Ge.length > 1) {
          var bt = le.slice(0, Ge.index), ft = le.slice(Ge.index + Ge.length);
          He = bt.join(":") + "::" + ft.join(":");
        } else
          He = le.join(":");
        return I && (He += "%" + I), He;
      } else
        return y;
    }
    var ut = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i, qe = "".match(/(){0}/)[1] === void 0;
    function pe(y) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ = {}, s = i.iri !== !1 ? E : h;
      i.reference === "suffix" && (y = (i.scheme ? i.scheme + ":" : "") + "//" + y);
      var u = y.match(ut);
      if (u) {
        qe ? (_.scheme = u[1], _.userinfo = u[3], _.host = u[4], _.port = parseInt(u[5], 10), _.path = u[6] || "", _.query = u[7], _.fragment = u[8], isNaN(_.port) && (_.port = u[5])) : (_.scheme = u[1] || void 0, _.userinfo = y.indexOf("@") !== -1 ? u[3] : void 0, _.host = y.indexOf("//") !== -1 ? u[4] : void 0, _.port = parseInt(u[5], 10), _.path = u[6] || "", _.query = y.indexOf("?") !== -1 ? u[7] : void 0, _.fragment = y.indexOf("#") !== -1 ? u[8] : void 0, isNaN(_.port) && (_.port = y.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? u[4] : void 0)), _.host && (_.host = Te(ue(_.host, s), s)), _.scheme === void 0 && _.userinfo === void 0 && _.host === void 0 && _.port === void 0 && !_.path && _.query === void 0 ? _.reference = "same-document" : _.scheme === void 0 ? _.reference = "relative" : _.fragment === void 0 ? _.reference = "absolute" : _.reference = "uri", i.reference && i.reference !== "suffix" && i.reference !== _.reference && (_.error = _.error || "URI is not a " + i.reference + " reference.");
        var I = U[(i.scheme || _.scheme || "").toLowerCase()];
        if (!i.unicodeSupport && (!I || !I.unicodeSupport)) {
          if (_.host && (i.domainHost || I && I.domainHost))
            try {
              _.host = C.toASCII(_.host.replace(s.PCT_ENCODED, G).toLowerCase());
            } catch (V) {
              _.error = _.error || "Host's domain name can not be converted to ASCII via punycode: " + V;
            }
          Z(_, h);
        } else
          Z(_, s);
        I && I.parse && I.parse(_, i);
      } else
        _.error = _.error || "URI can not be parsed.";
      return _;
    }
    function et(y, i) {
      var _ = i.iri !== !1 ? E : h, s = [];
      return y.userinfo !== void 0 && (s.push(y.userinfo), s.push("@")), y.host !== void 0 && s.push(Te(ue(String(y.host), _), _).replace(_.IPV6ADDRESS, function(u, I, V) {
        return "[" + I + (V ? "%25" + V : "") + "]";
      })), (typeof y.port == "number" || typeof y.port == "string") && (s.push(":"), s.push(String(y.port))), s.length ? s.join("") : void 0;
    }
    var Be = /^\.\.?\//, De = /^\/\.(\/|$)/, tt = /^\/\.\.(\/|$)/, lt = /^\/?(?:.|\n)*?(?=\/|$)/;
    function be(y) {
      for (var i = []; y.length; )
        if (y.match(Be))
          y = y.replace(Be, "");
        else if (y.match(De))
          y = y.replace(De, "/");
        else if (y.match(tt))
          y = y.replace(tt, "/"), i.pop();
        else if (y === "." || y === "..")
          y = "";
        else {
          var _ = y.match(lt);
          if (_) {
            var s = _[0];
            y = y.slice(s.length), i.push(s);
          } else
            throw new Error("Unexpected dot segment condition");
        }
      return i.join("");
    }
    function _e(y) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ = i.iri ? E : h, s = [], u = U[(i.scheme || y.scheme || "").toLowerCase()];
      if (u && u.serialize && u.serialize(y, i), y.host && !_.IPV6ADDRESS.test(y.host)) {
        if (i.domainHost || u && u.domainHost)
          try {
            y.host = i.iri ? C.toUnicode(y.host) : C.toASCII(y.host.replace(_.PCT_ENCODED, G).toLowerCase());
          } catch (H) {
            y.error = y.error || "Host's domain name can not be converted to " + (i.iri ? "Unicode" : "ASCII") + " via punycode: " + H;
          }
      }
      Z(y, _), i.reference !== "suffix" && y.scheme && (s.push(y.scheme), s.push(":"));
      var I = et(y, i);
      if (I !== void 0 && (i.reference !== "suffix" && s.push("//"), s.push(I), y.path && y.path.charAt(0) !== "/" && s.push("/")), y.path !== void 0) {
        var V = y.path;
        !i.absolutePath && (!u || !u.absolutePath) && (V = be(V)), I === void 0 && (V = V.replace(/^\/\//, "/%2F")), s.push(V);
      }
      return y.query !== void 0 && (s.push("?"), s.push(y.query)), y.fragment !== void 0 && (s.push("#"), s.push(y.fragment)), s.join("");
    }
    function rt(y, i) {
      var _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, s = arguments[3], u = {};
      return s || (y = pe(_e(y, _), _), i = pe(_e(i, _), _)), _ = _ || {}, !_.tolerant && i.scheme ? (u.scheme = i.scheme, u.userinfo = i.userinfo, u.host = i.host, u.port = i.port, u.path = be(i.path || ""), u.query = i.query) : (i.userinfo !== void 0 || i.host !== void 0 || i.port !== void 0 ? (u.userinfo = i.userinfo, u.host = i.host, u.port = i.port, u.path = be(i.path || ""), u.query = i.query) : (i.path ? (i.path.charAt(0) === "/" ? u.path = be(i.path) : ((y.userinfo !== void 0 || y.host !== void 0 || y.port !== void 0) && !y.path ? u.path = "/" + i.path : y.path ? u.path = y.path.slice(0, y.path.lastIndexOf("/") + 1) + i.path : u.path = i.path, u.path = be(u.path)), u.query = i.query) : (u.path = y.path, i.query !== void 0 ? u.query = i.query : u.query = y.query), u.userinfo = y.userinfo, u.host = y.host, u.port = y.port), u.scheme = y.scheme), u.fragment = i.fragment, u;
    }
    function nt(y, i, _) {
      var s = $({ scheme: "null" }, _);
      return _e(rt(pe(y, s), pe(i, s), s, !0), s);
    }
    function Le(y, i) {
      return typeof y == "string" ? y = _e(pe(y, i), i) : c(y) === "object" && (y = pe(_e(y, i), i)), y;
    }
    function Ae(y, i, _) {
      return typeof y == "string" ? y = _e(pe(y, _), _) : c(y) === "object" && (y = _e(y, _)), typeof i == "string" ? i = _e(pe(i, _), _) : c(i) === "object" && (i = _e(i, _)), y === i;
    }
    function gt(y, i) {
      return y && y.toString().replace(!i || !i.iri ? h.ESCAPE : E.ESCAPE, F);
    }
    function Ee(y, i) {
      return y && y.toString().replace(!i || !i.iri ? h.PCT_ENCODED : E.PCT_ENCODED, G);
    }
    var Ke = {
      scheme: "http",
      domainHost: !0,
      parse: function(i, _) {
        return i.host || (i.error = i.error || "HTTP URIs must have a host."), i;
      },
      serialize: function(i, _) {
        var s = String(i.scheme).toLowerCase() === "https";
        return (i.port === (s ? 443 : 80) || i.port === "") && (i.port = void 0), i.path || (i.path = "/"), i;
      }
    }, Et = {
      scheme: "https",
      domainHost: Ke.domainHost,
      parse: Ke.parse,
      serialize: Ke.serialize
    };
    function tr(y) {
      return typeof y.secure == "boolean" ? y.secure : String(y.scheme).toLowerCase() === "wss";
    }
    var dt = {
      scheme: "ws",
      domainHost: !0,
      parse: function(i, _) {
        var s = i;
        return s.secure = tr(s), s.resourceName = (s.path || "/") + (s.query ? "?" + s.query : ""), s.path = void 0, s.query = void 0, s;
      },
      serialize: function(i, _) {
        if ((i.port === (tr(i) ? 443 : 80) || i.port === "") && (i.port = void 0), typeof i.secure == "boolean" && (i.scheme = i.secure ? "wss" : "ws", i.secure = void 0), i.resourceName) {
          var s = i.resourceName.split("?"), u = D(s, 2), I = u[0], V = u[1];
          i.path = I && I !== "/" ? I : void 0, i.query = V, i.resourceName = void 0;
        }
        return i.fragment = void 0, i;
      }
    }, rr = {
      scheme: "wss",
      domainHost: dt.domainHost,
      parse: dt.parse,
      serialize: dt.serialize
    }, jr = {}, nr = "[A-Za-z0-9\\-\\.\\_\\~\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]", Ne = "[0-9A-Fa-f]", kr = n(n("%[EFef]" + Ne + "%" + Ne + Ne + "%" + Ne + Ne) + "|" + n("%[89A-Fa-f]" + Ne + "%" + Ne + Ne) + "|" + n("%" + Ne + Ne)), Dt = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]", ar = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]", at = a(ar, '[\\"\\\\]'), At = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]", Mt = new RegExp(nr, "g"), Xe = new RegExp(kr, "g"), Ir = new RegExp(a("[^]", Dt, "[\\.]", '[\\"]', at), "g"), Ft = new RegExp(a("[^]", nr, At), "g"), Dr = Ft;
    function wt(y) {
      var i = G(y);
      return i.match(Mt) ? i : y;
    }
    var Vt = {
      scheme: "mailto",
      parse: function(i, _) {
        var s = i, u = s.to = s.path ? s.path.split(",") : [];
        if (s.path = void 0, s.query) {
          for (var I = !1, V = {}, H = s.query.split("&"), X = 0, B = H.length; X < B; ++X) {
            var K = H[X].split("=");
            switch (K[0]) {
              case "to":
                for (var te = K[1].split(","), ee = 0, W = te.length; ee < W; ++ee)
                  u.push(te[ee]);
                break;
              case "subject":
                s.subject = Ee(K[1], _);
                break;
              case "body":
                s.body = Ee(K[1], _);
                break;
              default:
                I = !0, V[Ee(K[0], _)] = Ee(K[1], _);
                break;
            }
          }
          I && (s.headers = V);
        }
        s.query = void 0;
        for (var ae = 0, le = u.length; ae < le; ++ae) {
          var de = u[ae].split("@");
          if (de[0] = Ee(de[0]), _.unicodeSupport)
            de[1] = Ee(de[1], _).toLowerCase();
          else
            try {
              de[1] = C.toASCII(Ee(de[1], _).toLowerCase());
            } catch (ve) {
              s.error = s.error || "Email address's domain name can not be converted to ASCII via punycode: " + ve;
            }
          u[ae] = de.join("@");
        }
        return s;
      },
      serialize: function(i, _) {
        var s = i, u = v(i.to);
        if (u) {
          for (var I = 0, V = u.length; I < V; ++I) {
            var H = String(u[I]), X = H.lastIndexOf("@"), B = H.slice(0, X).replace(Xe, wt).replace(Xe, f).replace(Ir, F), K = H.slice(X + 1);
            try {
              K = _.iri ? C.toUnicode(K) : C.toASCII(Ee(K, _).toLowerCase());
            } catch (ae) {
              s.error = s.error || "Email address's domain name can not be converted to " + (_.iri ? "Unicode" : "ASCII") + " via punycode: " + ae;
            }
            u[I] = B + "@" + K;
          }
          s.path = u.join(",");
        }
        var te = i.headers = i.headers || {};
        i.subject && (te.subject = i.subject), i.body && (te.body = i.body);
        var ee = [];
        for (var W in te)
          te[W] !== jr[W] && ee.push(W.replace(Xe, wt).replace(Xe, f).replace(Ft, F) + "=" + te[W].replace(Xe, wt).replace(Xe, f).replace(Dr, F));
        return ee.length && (s.query = ee.join("&")), s;
      }
    }, Ar = /^([^\:]+)\:(.*)/, sr = {
      scheme: "urn",
      parse: function(i, _) {
        var s = i.path && i.path.match(Ar), u = i;
        if (s) {
          var I = _.scheme || u.scheme || "urn", V = s[1].toLowerCase(), H = s[2], X = I + ":" + (_.nid || V), B = U[X];
          u.nid = V, u.nss = H, u.path = void 0, B && (u = B.parse(u, _));
        } else
          u.error = u.error || "URN can not be parsed.";
        return u;
      },
      serialize: function(i, _) {
        var s = _.scheme || i.scheme || "urn", u = i.nid, I = s + ":" + (_.nid || u), V = U[I];
        V && (i = V.serialize(i, _));
        var H = i, X = i.nss;
        return H.path = (u || _.nid) + ":" + X, H;
      }
    }, or = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/, ir = {
      scheme: "urn:uuid",
      parse: function(i, _) {
        var s = i;
        return s.uuid = s.nss, s.nss = void 0, !_.tolerant && (!s.uuid || !s.uuid.match(or)) && (s.error = s.error || "UUID is not valid."), s;
      },
      serialize: function(i, _) {
        var s = i;
        return s.nss = (i.uuid || "").toLowerCase(), s;
      }
    };
    U[Ke.scheme] = Ke, U[Et.scheme] = Et, U[dt.scheme] = dt, U[rr.scheme] = rr, U[Vt.scheme] = Vt, U[sr.scheme] = sr, U[ir.scheme] = ir, r.SCHEMES = U, r.pctEncChar = F, r.pctDecChars = G, r.parse = pe, r.removeDotSegments = be, r.serialize = _e, r.resolveComponents = rt, r.resolve = nt, r.normalize = Le, r.equal = Ae, r.escapeComponent = gt, r.unescapeComponent = Ee, Object.defineProperty(r, "__esModule", { value: !0 });
  });
})(Wr, Wr.exports);
var Fo = Wr.exports;
Object.defineProperty(sn, "__esModule", { value: !0 });
const za = Fo;
za.code = 'require("ajv/dist/runtime/uri").default';
sn.default = za;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.CodeGen = e.Name = e.nil = e.stringify = e.str = e._ = e.KeywordCxt = void 0;
  var t = ke;
  Object.defineProperty(e, "KeywordCxt", { enumerable: !0, get: function() {
    return t.KeywordCxt;
  } });
  var r = re;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return r._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return r.str;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return r.stringify;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return r.nil;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return r.Name;
  } }), Object.defineProperty(e, "CodeGen", { enumerable: !0, get: function() {
    return r.CodeGen;
  } });
  const a = Qt, n = xt, c = $t, f = Pe, v = re, $ = $e, m = Zt, h = oe, E = Mo, D = sn, k = (q, P) => new RegExp(q, P);
  k.code = "new RegExp";
  const R = ["removeAdditional", "useDefaults", "coerceTypes"], T = /* @__PURE__ */ new Set([
    "validate",
    "serialize",
    "parse",
    "wrapper",
    "root",
    "schema",
    "keyword",
    "pattern",
    "formats",
    "validate$data",
    "func",
    "obj",
    "Error"
  ]), w = {
    errorDataPath: "",
    format: "`validateFormats: false` can be used instead.",
    nullable: '"nullable" keyword is supported by default.',
    jsonPointers: "Deprecated jsPropertySyntax can be used instead.",
    extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.",
    missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.",
    processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`",
    sourceCode: "Use option `code: {source: true}`",
    strictDefaults: "It is default now, see option `strict`.",
    strictKeywords: "It is default now, see option `strict`.",
    uniqueItems: '"uniqueItems" keyword is always validated.',
    unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",
    cache: "Map is used as cache, schema object as key.",
    serialize: "Map is used as cache, schema object as key.",
    ajvErrors: "It is default now."
  }, p = {
    ignoreKeywordsWithRef: "",
    jsPropertySyntax: "",
    unicode: '"minLength"/"maxLength" account for unicode characters by default.'
  }, d = 200;
  function N(q) {
    var P, O, g, o, l, C, U, F, G, Z, ce, ue, Te, ut, qe, pe, et, Be, De, tt, lt, be, _e, rt, nt;
    const Le = q.strict, Ae = (P = q.code) === null || P === void 0 ? void 0 : P.optimize, gt = Ae === !0 || Ae === void 0 ? 1 : Ae || 0, Ee = (g = (O = q.code) === null || O === void 0 ? void 0 : O.regExp) !== null && g !== void 0 ? g : k, Ke = (o = q.uriResolver) !== null && o !== void 0 ? o : D.default;
    return {
      strictSchema: (C = (l = q.strictSchema) !== null && l !== void 0 ? l : Le) !== null && C !== void 0 ? C : !0,
      strictNumbers: (F = (U = q.strictNumbers) !== null && U !== void 0 ? U : Le) !== null && F !== void 0 ? F : !0,
      strictTypes: (Z = (G = q.strictTypes) !== null && G !== void 0 ? G : Le) !== null && Z !== void 0 ? Z : "log",
      strictTuples: (ue = (ce = q.strictTuples) !== null && ce !== void 0 ? ce : Le) !== null && ue !== void 0 ? ue : "log",
      strictRequired: (ut = (Te = q.strictRequired) !== null && Te !== void 0 ? Te : Le) !== null && ut !== void 0 ? ut : !1,
      code: q.code ? { ...q.code, optimize: gt, regExp: Ee } : { optimize: gt, regExp: Ee },
      loopRequired: (qe = q.loopRequired) !== null && qe !== void 0 ? qe : d,
      loopEnum: (pe = q.loopEnum) !== null && pe !== void 0 ? pe : d,
      meta: (et = q.meta) !== null && et !== void 0 ? et : !0,
      messages: (Be = q.messages) !== null && Be !== void 0 ? Be : !0,
      inlineRefs: (De = q.inlineRefs) !== null && De !== void 0 ? De : !0,
      schemaId: (tt = q.schemaId) !== null && tt !== void 0 ? tt : "$id",
      addUsedSchema: (lt = q.addUsedSchema) !== null && lt !== void 0 ? lt : !0,
      validateSchema: (be = q.validateSchema) !== null && be !== void 0 ? be : !0,
      validateFormats: (_e = q.validateFormats) !== null && _e !== void 0 ? _e : !0,
      unicodeRegExp: (rt = q.unicodeRegExp) !== null && rt !== void 0 ? rt : !0,
      int32range: (nt = q.int32range) !== null && nt !== void 0 ? nt : !0,
      uriResolver: Ke
    };
  }
  class j {
    constructor(P = {}) {
      this.schemas = {}, this.refs = {}, this.formats = {}, this._compilations = /* @__PURE__ */ new Set(), this._loading = {}, this._cache = /* @__PURE__ */ new Map(), P = this.opts = { ...P, ...N(P) };
      const { es5: O, lines: g } = this.opts.code;
      this.scope = new v.ValueScope({ scope: {}, prefixes: T, es5: O, lines: g }), this.logger = J(P.logger);
      const o = P.validateFormats;
      P.validateFormats = !1, this.RULES = (0, c.getRules)(), z.call(this, w, P, "NOT SUPPORTED"), z.call(this, p, P, "DEPRECATED", "warn"), this._metaOpts = L.call(this), P.formats && A.call(this), this._addVocabularies(), this._addDefaultMetaSchema(), P.keywords && M.call(this, P.keywords), typeof P.meta == "object" && this.addMetaSchema(P.meta), b.call(this), P.validateFormats = o;
    }
    _addVocabularies() {
      this.addKeyword("$async");
    }
    _addDefaultMetaSchema() {
      const { $data: P, meta: O, schemaId: g } = this.opts;
      let o = E;
      g === "id" && (o = { ...E }, o.id = o.$id, delete o.$id), O && P && this.addMetaSchema(o, o[g], !1);
    }
    defaultMeta() {
      const { meta: P, schemaId: O } = this.opts;
      return this.opts.defaultMeta = typeof P == "object" ? P[O] || P : void 0;
    }
    validate(P, O) {
      let g;
      if (typeof P == "string") {
        if (g = this.getSchema(P), !g)
          throw new Error(`no schema with key or ref "${P}"`);
      } else
        g = this.compile(P);
      const o = g(O);
      return "$async" in g || (this.errors = g.errors), o;
    }
    compile(P, O) {
      const g = this._addSchema(P, O);
      return g.validate || this._compileSchemaEnv(g);
    }
    compileAsync(P, O) {
      if (typeof this.opts.loadSchema != "function")
        throw new Error("options.loadSchema should be a function");
      const { loadSchema: g } = this.opts;
      return o.call(this, P, O);
      async function o(Z, ce) {
        await l.call(this, Z.$schema);
        const ue = this._addSchema(Z, ce);
        return ue.validate || C.call(this, ue);
      }
      async function l(Z) {
        Z && !this.getSchema(Z) && await o.call(this, { $ref: Z }, !0);
      }
      async function C(Z) {
        try {
          return this._compileSchemaEnv(Z);
        } catch (ce) {
          if (!(ce instanceof n.default))
            throw ce;
          return U.call(this, ce), await F.call(this, ce.missingSchema), C.call(this, Z);
        }
      }
      function U({ missingSchema: Z, missingRef: ce }) {
        if (this.refs[Z])
          throw new Error(`AnySchema ${Z} is loaded but ${ce} cannot be resolved`);
      }
      async function F(Z) {
        const ce = await G.call(this, Z);
        this.refs[Z] || await l.call(this, ce.$schema), this.refs[Z] || this.addSchema(ce, Z, O);
      }
      async function G(Z) {
        const ce = this._loading[Z];
        if (ce)
          return ce;
        try {
          return await (this._loading[Z] = g(Z));
        } finally {
          delete this._loading[Z];
        }
      }
    }
    // Adds schema to the instance
    addSchema(P, O, g, o = this.opts.validateSchema) {
      if (Array.isArray(P)) {
        for (const C of P)
          this.addSchema(C, void 0, g, o);
        return this;
      }
      let l;
      if (typeof P == "object") {
        const { schemaId: C } = this.opts;
        if (l = P[C], l !== void 0 && typeof l != "string")
          throw new Error(`schema ${C} must be string`);
      }
      return O = (0, $.normalizeId)(O || l), this._checkUnique(O), this.schemas[O] = this._addSchema(P, g, O, o, !0), this;
    }
    // Add schema that will be used to validate other schemas
    // options in META_IGNORE_OPTIONS are alway set to false
    addMetaSchema(P, O, g = this.opts.validateSchema) {
      return this.addSchema(P, O, !0, g), this;
    }
    //  Validate schema against its meta-schema
    validateSchema(P, O) {
      if (typeof P == "boolean")
        return !0;
      let g;
      if (g = P.$schema, g !== void 0 && typeof g != "string")
        throw new Error("$schema must be a string");
      if (g = g || this.opts.defaultMeta || this.defaultMeta(), !g)
        return this.logger.warn("meta-schema not available"), this.errors = null, !0;
      const o = this.validate(g, P);
      if (!o && O) {
        const l = "schema is invalid: " + this.errorsText();
        if (this.opts.validateSchema === "log")
          this.logger.error(l);
        else
          throw new Error(l);
      }
      return o;
    }
    // Get compiled schema by `key` or `ref`.
    // (`key` that was passed to `addSchema` or full schema reference - `schema.$id` or resolved id)
    getSchema(P) {
      let O;
      for (; typeof (O = S.call(this, P)) == "string"; )
        P = O;
      if (O === void 0) {
        const { schemaId: g } = this.opts, o = new f.SchemaEnv({ schema: {}, schemaId: g });
        if (O = f.resolveSchema.call(this, o, P), !O)
          return;
        this.refs[P] = O;
      }
      return O.validate || this._compileSchemaEnv(O);
    }
    // Remove cached schema(s).
    // If no parameter is passed all schemas but meta-schemas are removed.
    // If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
    // Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
    removeSchema(P) {
      if (P instanceof RegExp)
        return this._removeAllSchemas(this.schemas, P), this._removeAllSchemas(this.refs, P), this;
      switch (typeof P) {
        case "undefined":
          return this._removeAllSchemas(this.schemas), this._removeAllSchemas(this.refs), this._cache.clear(), this;
        case "string": {
          const O = S.call(this, P);
          return typeof O == "object" && this._cache.delete(O.schema), delete this.schemas[P], delete this.refs[P], this;
        }
        case "object": {
          const O = P;
          this._cache.delete(O);
          let g = P[this.opts.schemaId];
          return g && (g = (0, $.normalizeId)(g), delete this.schemas[g], delete this.refs[g]), this;
        }
        default:
          throw new Error("ajv.removeSchema: invalid parameter");
      }
    }
    // add "vocabulary" - a collection of keywords
    addVocabulary(P) {
      for (const O of P)
        this.addKeyword(O);
      return this;
    }
    addKeyword(P, O) {
      let g;
      if (typeof P == "string")
        g = P, typeof O == "object" && (this.logger.warn("these parameters are deprecated, see docs for addKeyword"), O.keyword = g);
      else if (typeof P == "object" && O === void 0) {
        if (O = P, g = O.keyword, Array.isArray(g) && !g.length)
          throw new Error("addKeywords: keyword must be string or non-empty array");
      } else
        throw new Error("invalid addKeywords parameters");
      if (se.call(this, g, O), !O)
        return (0, h.eachItem)(g, (l) => me.call(this, l)), this;
      Ie.call(this, O);
      const o = {
        ...O,
        type: (0, m.getJSONTypes)(O.type),
        schemaType: (0, m.getJSONTypes)(O.schemaType)
      };
      return (0, h.eachItem)(g, o.type.length === 0 ? (l) => me.call(this, l, o) : (l) => o.type.forEach((C) => me.call(this, l, o, C))), this;
    }
    getKeyword(P) {
      const O = this.RULES.all[P];
      return typeof O == "object" ? O.definition : !!O;
    }
    // Remove keyword
    removeKeyword(P) {
      const { RULES: O } = this;
      delete O.keywords[P], delete O.all[P];
      for (const g of O.rules) {
        const o = g.rules.findIndex((l) => l.keyword === P);
        o >= 0 && g.rules.splice(o, 1);
      }
      return this;
    }
    // Add format
    addFormat(P, O) {
      return typeof O == "string" && (O = new RegExp(O)), this.formats[P] = O, this;
    }
    errorsText(P = this.errors, { separator: O = ", ", dataVar: g = "data" } = {}) {
      return !P || P.length === 0 ? "No errors" : P.map((o) => `${g}${o.instancePath} ${o.message}`).reduce((o, l) => o + O + l);
    }
    $dataMetaSchema(P, O) {
      const g = this.RULES.all;
      P = JSON.parse(JSON.stringify(P));
      for (const o of O) {
        const l = o.split("/").slice(1);
        let C = P;
        for (const U of l)
          C = C[U];
        for (const U in g) {
          const F = g[U];
          if (typeof F != "object")
            continue;
          const { $data: G } = F.definition, Z = C[U];
          G && Z && (C[U] = Re(Z));
        }
      }
      return P;
    }
    _removeAllSchemas(P, O) {
      for (const g in P) {
        const o = P[g];
        (!O || O.test(g)) && (typeof o == "string" ? delete P[g] : o && !o.meta && (this._cache.delete(o.schema), delete P[g]));
      }
    }
    _addSchema(P, O, g, o = this.opts.validateSchema, l = this.opts.addUsedSchema) {
      let C;
      const { schemaId: U } = this.opts;
      if (typeof P == "object")
        C = P[U];
      else {
        if (this.opts.jtd)
          throw new Error("schema must be object");
        if (typeof P != "boolean")
          throw new Error("schema must be object or boolean");
      }
      let F = this._cache.get(P);
      if (F !== void 0)
        return F;
      g = (0, $.normalizeId)(C || g);
      const G = $.getSchemaRefs.call(this, P, g);
      return F = new f.SchemaEnv({ schema: P, schemaId: U, meta: O, baseId: g, localRefs: G }), this._cache.set(F.schema, F), l && !g.startsWith("#") && (g && this._checkUnique(g), this.refs[g] = F), o && this.validateSchema(P, !0), F;
    }
    _checkUnique(P) {
      if (this.schemas[P] || this.refs[P])
        throw new Error(`schema with key or id "${P}" already exists`);
    }
    _compileSchemaEnv(P) {
      if (P.meta ? this._compileMetaSchema(P) : f.compileSchema.call(this, P), !P.validate)
        throw new Error("ajv implementation error");
      return P.validate;
    }
    _compileMetaSchema(P) {
      const O = this.opts;
      this.opts = this._metaOpts;
      try {
        f.compileSchema.call(this, P);
      } finally {
        this.opts = O;
      }
    }
  }
  e.default = j, j.ValidationError = a.default, j.MissingRefError = n.default;
  function z(q, P, O, g = "error") {
    for (const o in q) {
      const l = o;
      l in P && this.logger[g](`${O}: option ${o}. ${q[l]}`);
    }
  }
  function S(q) {
    return q = (0, $.normalizeId)(q), this.schemas[q] || this.refs[q];
  }
  function b() {
    const q = this.opts.schemas;
    if (q)
      if (Array.isArray(q))
        this.addSchema(q);
      else
        for (const P in q)
          this.addSchema(q[P], P);
  }
  function A() {
    for (const q in this.opts.formats) {
      const P = this.opts.formats[q];
      P && this.addFormat(q, P);
    }
  }
  function M(q) {
    if (Array.isArray(q)) {
      this.addVocabulary(q);
      return;
    }
    this.logger.warn("keywords option as map is deprecated, pass array");
    for (const P in q) {
      const O = q[P];
      O.keyword || (O.keyword = P), this.addKeyword(O);
    }
  }
  function L() {
    const q = { ...this.opts };
    for (const P of R)
      delete q[P];
    return q;
  }
  const Q = { log() {
  }, warn() {
  }, error() {
  } };
  function J(q) {
    if (q === !1)
      return Q;
    if (q === void 0)
      return console;
    if (q.log && q.warn && q.error)
      return q;
    throw new Error("logger must implement log, warn and error methods");
  }
  const ie = /^[a-z_$][a-z0-9_$:-]*$/i;
  function se(q, P) {
    const { RULES: O } = this;
    if ((0, h.eachItem)(q, (g) => {
      if (O.keywords[g])
        throw new Error(`Keyword ${g} is already defined`);
      if (!ie.test(g))
        throw new Error(`Keyword ${g} has invalid name`);
    }), !!P && P.$data && !("code" in P || "validate" in P))
      throw new Error('$data keyword must have "code" or "validate" function');
  }
  function me(q, P, O) {
    var g;
    const o = P == null ? void 0 : P.post;
    if (O && o)
      throw new Error('keyword with "post" flag cannot have "type"');
    const { RULES: l } = this;
    let C = o ? l.post : l.rules.find(({ type: F }) => F === O);
    if (C || (C = { type: O, rules: [] }, l.rules.push(C)), l.keywords[q] = !0, !P)
      return;
    const U = {
      keyword: q,
      definition: {
        ...P,
        type: (0, m.getJSONTypes)(P.type),
        schemaType: (0, m.getJSONTypes)(P.schemaType)
      }
    };
    P.before ? Oe.call(this, C, U, P.before) : C.rules.push(U), l.all[q] = U, (g = P.implements) === null || g === void 0 || g.forEach((F) => this.addKeyword(F));
  }
  function Oe(q, P, O) {
    const g = q.rules.findIndex((o) => o.keyword === O);
    g >= 0 ? q.rules.splice(g, 0, P) : (q.rules.push(P), this.logger.warn(`rule ${O} is not defined`));
  }
  function Ie(q) {
    let { metaSchema: P } = q;
    P !== void 0 && (q.$data && this.opts.$data && (P = Re(P)), q.validateSchema = this.compile(P, !0));
  }
  const Ue = {
    $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"
  };
  function Re(q) {
    return { anyOf: [q, Ue] };
  }
})(ma);
var on = {}, cn = {}, un = {};
Object.defineProperty(un, "__esModule", { value: !0 });
const Vo = {
  keyword: "id",
  code() {
    throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
  }
};
un.default = Vo;
var _t = {};
Object.defineProperty(_t, "__esModule", { value: !0 });
_t.callRef = _t.getValidate = void 0;
const zo = xt, Qn = ne, Se = re, Pt = ze, xn = Pe, fr = oe, Uo = {
  keyword: "$ref",
  schemaType: "string",
  code(e) {
    const { gen: t, schema: r, it: a } = e, { baseId: n, schemaEnv: c, validateName: f, opts: v, self: $ } = a, { root: m } = c;
    if ((r === "#" || r === "#/") && n === m.baseId)
      return E();
    const h = xn.resolveRef.call($, m, n, r);
    if (h === void 0)
      throw new zo.default(a.opts.uriResolver, n, r);
    if (h instanceof xn.SchemaEnv)
      return D(h);
    return k(h);
    function E() {
      if (c === m)
        return _r(e, f, c, c.$async);
      const R = t.scopeValue("root", { ref: m });
      return _r(e, (0, Se._)`${R}.validate`, m, m.$async);
    }
    function D(R) {
      const T = Ua(e, R);
      _r(e, T, R, R.$async);
    }
    function k(R) {
      const T = t.scopeValue("schema", v.code.source === !0 ? { ref: R, code: (0, Se.stringify)(R) } : { ref: R }), w = t.name("valid"), p = e.subschema({
        schema: R,
        dataTypes: [],
        schemaPath: Se.nil,
        topSchemaRef: T,
        errSchemaPath: r
      }, w);
      e.mergeEvaluated(p), e.ok(w);
    }
  }
};
function Ua(e, t) {
  const { gen: r } = e;
  return t.validate ? r.scopeValue("validate", { ref: t.validate }) : (0, Se._)`${r.scopeValue("wrapper", { ref: t })}.validate`;
}
_t.getValidate = Ua;
function _r(e, t, r, a) {
  const { gen: n, it: c } = e, { allErrors: f, schemaEnv: v, opts: $ } = c, m = $.passContext ? Pt.default.this : Se.nil;
  a ? h() : E();
  function h() {
    if (!v.$async)
      throw new Error("async schema referenced by sync schema");
    const R = n.let("valid");
    n.try(() => {
      n.code((0, Se._)`await ${(0, Qn.callValidateCode)(e, t, m)}`), k(t), f || n.assign(R, !0);
    }, (T) => {
      n.if((0, Se._)`!(${T} instanceof ${c.ValidationError})`, () => n.throw(T)), D(T), f || n.assign(R, !1);
    }), e.ok(R);
  }
  function E() {
    e.result((0, Qn.callValidateCode)(e, t, m), () => k(t), () => D(t));
  }
  function D(R) {
    const T = (0, Se._)`${R}.errors`;
    n.assign(Pt.default.vErrors, (0, Se._)`${Pt.default.vErrors} === null ? ${T} : ${Pt.default.vErrors}.concat(${T})`), n.assign(Pt.default.errors, (0, Se._)`${Pt.default.vErrors}.length`);
  }
  function k(R) {
    var T;
    if (!c.opts.unevaluated)
      return;
    const w = (T = r == null ? void 0 : r.validate) === null || T === void 0 ? void 0 : T.evaluated;
    if (c.props !== !0)
      if (w && !w.dynamicProps)
        w.props !== void 0 && (c.props = fr.mergeEvaluated.props(n, w.props, c.props));
      else {
        const p = n.var("props", (0, Se._)`${R}.evaluated.props`);
        c.props = fr.mergeEvaluated.props(n, p, c.props, Se.Name);
      }
    if (c.items !== !0)
      if (w && !w.dynamicItems)
        w.items !== void 0 && (c.items = fr.mergeEvaluated.items(n, w.items, c.items));
      else {
        const p = n.var("items", (0, Se._)`${R}.evaluated.items`);
        c.items = fr.mergeEvaluated.items(n, p, c.items, Se.Name);
      }
  }
}
_t.callRef = _r;
_t.default = Uo;
Object.defineProperty(cn, "__esModule", { value: !0 });
const qo = un, Lo = _t, Ko = [
  "$schema",
  "$id",
  "$defs",
  "$vocabulary",
  { keyword: "$comment" },
  "definitions",
  qo.default,
  Lo.default
];
cn.default = Ko;
var ln = {}, dn = {};
Object.defineProperty(dn, "__esModule", { value: !0 });
const br = re, ot = br.operators, Sr = {
  maximum: { okStr: "<=", ok: ot.LTE, fail: ot.GT },
  minimum: { okStr: ">=", ok: ot.GTE, fail: ot.LT },
  exclusiveMaximum: { okStr: "<", ok: ot.LT, fail: ot.GTE },
  exclusiveMinimum: { okStr: ">", ok: ot.GT, fail: ot.LTE }
}, Go = {
  message: ({ keyword: e, schemaCode: t }) => (0, br.str)`must be ${Sr[e].okStr} ${t}`,
  params: ({ keyword: e, schemaCode: t }) => (0, br._)`{comparison: ${Sr[e].okStr}, limit: ${t}}`
}, Ho = {
  keyword: Object.keys(Sr),
  type: "number",
  schemaType: "number",
  $data: !0,
  error: Go,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e;
    e.fail$data((0, br._)`${r} ${Sr[t].fail} ${a} || isNaN(${r})`);
  }
};
dn.default = Ho;
var fn = {};
Object.defineProperty(fn, "__esModule", { value: !0 });
const Jt = re, Wo = {
  message: ({ schemaCode: e }) => (0, Jt.str)`must be multiple of ${e}`,
  params: ({ schemaCode: e }) => (0, Jt._)`{multipleOf: ${e}}`
}, Jo = {
  keyword: "multipleOf",
  type: "number",
  schemaType: "number",
  $data: !0,
  error: Wo,
  code(e) {
    const { gen: t, data: r, schemaCode: a, it: n } = e, c = n.opts.multipleOfPrecision, f = t.let("res"), v = c ? (0, Jt._)`Math.abs(Math.round(${f}) - ${f}) > 1e-${c}` : (0, Jt._)`${f} !== parseInt(${f})`;
    e.fail$data((0, Jt._)`(${a} === 0 || (${f} = ${r}/${a}, ${v}))`);
  }
};
fn.default = Jo;
var hn = {}, mn = {};
Object.defineProperty(mn, "__esModule", { value: !0 });
function qa(e) {
  const t = e.length;
  let r = 0, a = 0, n;
  for (; a < t; )
    r++, n = e.charCodeAt(a++), n >= 55296 && n <= 56319 && a < t && (n = e.charCodeAt(a), (n & 64512) === 56320 && a++);
  return r;
}
mn.default = qa;
qa.code = 'require("ajv/dist/runtime/ucs2length").default';
Object.defineProperty(hn, "__esModule", { value: !0 });
const vt = re, Yo = oe, Bo = mn, Xo = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxLength" ? "more" : "fewer";
    return (0, vt.str)`must NOT have ${r} than ${t} characters`;
  },
  params: ({ schemaCode: e }) => (0, vt._)`{limit: ${e}}`
}, Zo = {
  keyword: ["maxLength", "minLength"],
  type: "string",
  schemaType: "number",
  $data: !0,
  error: Xo,
  code(e) {
    const { keyword: t, data: r, schemaCode: a, it: n } = e, c = t === "maxLength" ? vt.operators.GT : vt.operators.LT, f = n.opts.unicode === !1 ? (0, vt._)`${r}.length` : (0, vt._)`${(0, Yo.useFunc)(e.gen, Bo.default)}(${r})`;
    e.fail$data((0, vt._)`${f} ${c} ${a}`);
  }
};
hn.default = Zo;
var pn = {};
Object.defineProperty(pn, "__esModule", { value: !0 });
const Qo = ne, Pr = re, xo = {
  message: ({ schemaCode: e }) => (0, Pr.str)`must match pattern "${e}"`,
  params: ({ schemaCode: e }) => (0, Pr._)`{pattern: ${e}}`
}, ei = {
  keyword: "pattern",
  type: "string",
  schemaType: "string",
  $data: !0,
  error: xo,
  code(e) {
    const { data: t, $data: r, schema: a, schemaCode: n, it: c } = e, f = c.opts.unicodeRegExp ? "u" : "", v = r ? (0, Pr._)`(new RegExp(${n}, ${f}))` : (0, Qo.usePattern)(e, a);
    e.fail$data((0, Pr._)`!${v}.test(${t})`);
  }
};
pn.default = ei;
var vn = {};
Object.defineProperty(vn, "__esModule", { value: !0 });
const Yt = re, ti = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxProperties" ? "more" : "fewer";
    return (0, Yt.str)`must NOT have ${r} than ${t} properties`;
  },
  params: ({ schemaCode: e }) => (0, Yt._)`{limit: ${e}}`
}, ri = {
  keyword: ["maxProperties", "minProperties"],
  type: "object",
  schemaType: "number",
  $data: !0,
  error: ti,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e, n = t === "maxProperties" ? Yt.operators.GT : Yt.operators.LT;
    e.fail$data((0, Yt._)`Object.keys(${r}).length ${n} ${a}`);
  }
};
vn.default = ri;
var yn = {};
Object.defineProperty(yn, "__esModule", { value: !0 });
const Lt = ne, Bt = re, ni = oe, ai = {
  message: ({ params: { missingProperty: e } }) => (0, Bt.str)`must have required property '${e}'`,
  params: ({ params: { missingProperty: e } }) => (0, Bt._)`{missingProperty: ${e}}`
}, si = {
  keyword: "required",
  type: "object",
  schemaType: "array",
  $data: !0,
  error: ai,
  code(e) {
    const { gen: t, schema: r, schemaCode: a, data: n, $data: c, it: f } = e, { opts: v } = f;
    if (!c && r.length === 0)
      return;
    const $ = r.length >= v.loopRequired;
    if (f.allErrors ? m() : h(), v.strictRequired) {
      const k = e.parentSchema.properties, { definedProperties: R } = e.it;
      for (const T of r)
        if ((k == null ? void 0 : k[T]) === void 0 && !R.has(T)) {
          const w = f.schemaEnv.baseId + f.errSchemaPath, p = `required property "${T}" is not defined at "${w}" (strictRequired)`;
          (0, ni.checkStrictMode)(f, p, f.opts.strictRequired);
        }
    }
    function m() {
      if ($ || c)
        e.block$data(Bt.nil, E);
      else
        for (const k of r)
          (0, Lt.checkReportMissingProp)(e, k);
    }
    function h() {
      const k = t.let("missing");
      if ($ || c) {
        const R = t.let("valid", !0);
        e.block$data(R, () => D(k, R)), e.ok(R);
      } else
        t.if((0, Lt.checkMissingProp)(e, r, k)), (0, Lt.reportMissingProp)(e, k), t.else();
    }
    function E() {
      t.forOf("prop", a, (k) => {
        e.setParams({ missingProperty: k }), t.if((0, Lt.noPropertyInData)(t, n, k, v.ownProperties), () => e.error());
      });
    }
    function D(k, R) {
      e.setParams({ missingProperty: k }), t.forOf(k, a, () => {
        t.assign(R, (0, Lt.propertyInData)(t, n, k, v.ownProperties)), t.if((0, Bt.not)(R), () => {
          e.error(), t.break();
        });
      }, Bt.nil);
    }
  }
};
yn.default = si;
var $n = {};
Object.defineProperty($n, "__esModule", { value: !0 });
const Xt = re, oi = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxItems" ? "more" : "fewer";
    return (0, Xt.str)`must NOT have ${r} than ${t} items`;
  },
  params: ({ schemaCode: e }) => (0, Xt._)`{limit: ${e}}`
}, ii = {
  keyword: ["maxItems", "minItems"],
  type: "array",
  schemaType: "number",
  $data: !0,
  error: oi,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e, n = t === "maxItems" ? Xt.operators.GT : Xt.operators.LT;
    e.fail$data((0, Xt._)`${r}.length ${n} ${a}`);
  }
};
$n.default = ii;
var _n = {}, er = {};
Object.defineProperty(er, "__esModule", { value: !0 });
const La = wa;
La.code = 'require("ajv/dist/runtime/equal").default';
er.default = La;
Object.defineProperty(_n, "__esModule", { value: !0 });
const Ur = Zt, ye = re, ci = oe, ui = er, li = {
  message: ({ params: { i: e, j: t } }) => (0, ye.str)`must NOT have duplicate items (items ## ${t} and ${e} are identical)`,
  params: ({ params: { i: e, j: t } }) => (0, ye._)`{i: ${e}, j: ${t}}`
}, di = {
  keyword: "uniqueItems",
  type: "array",
  schemaType: "boolean",
  $data: !0,
  error: li,
  code(e) {
    const { gen: t, data: r, $data: a, schema: n, parentSchema: c, schemaCode: f, it: v } = e;
    if (!a && !n)
      return;
    const $ = t.let("valid"), m = c.items ? (0, Ur.getSchemaTypes)(c.items) : [];
    e.block$data($, h, (0, ye._)`${f} === false`), e.ok($);
    function h() {
      const R = t.let("i", (0, ye._)`${r}.length`), T = t.let("j");
      e.setParams({ i: R, j: T }), t.assign($, !0), t.if((0, ye._)`${R} > 1`, () => (E() ? D : k)(R, T));
    }
    function E() {
      return m.length > 0 && !m.some((R) => R === "object" || R === "array");
    }
    function D(R, T) {
      const w = t.name("item"), p = (0, Ur.checkDataTypes)(m, w, v.opts.strictNumbers, Ur.DataType.Wrong), d = t.const("indices", (0, ye._)`{}`);
      t.for((0, ye._)`;${R}--;`, () => {
        t.let(w, (0, ye._)`${r}[${R}]`), t.if(p, (0, ye._)`continue`), m.length > 1 && t.if((0, ye._)`typeof ${w} == "string"`, (0, ye._)`${w} += "_"`), t.if((0, ye._)`typeof ${d}[${w}] == "number"`, () => {
          t.assign(T, (0, ye._)`${d}[${w}]`), e.error(), t.assign($, !1).break();
        }).code((0, ye._)`${d}[${w}] = ${R}`);
      });
    }
    function k(R, T) {
      const w = (0, ci.useFunc)(t, ui.default), p = t.name("outer");
      t.label(p).for((0, ye._)`;${R}--;`, () => t.for((0, ye._)`${T} = ${R}; ${T}--;`, () => t.if((0, ye._)`${w}(${r}[${R}], ${r}[${T}])`, () => {
        e.error(), t.assign($, !1).break(p);
      })));
    }
  }
};
_n.default = di;
var gn = {};
Object.defineProperty(gn, "__esModule", { value: !0 });
const Jr = re, fi = oe, hi = er, mi = {
  message: "must be equal to constant",
  params: ({ schemaCode: e }) => (0, Jr._)`{allowedValue: ${e}}`
}, pi = {
  keyword: "const",
  $data: !0,
  error: mi,
  code(e) {
    const { gen: t, data: r, $data: a, schemaCode: n, schema: c } = e;
    a || c && typeof c == "object" ? e.fail$data((0, Jr._)`!${(0, fi.useFunc)(t, hi.default)}(${r}, ${n})`) : e.fail((0, Jr._)`${c} !== ${r}`);
  }
};
gn.default = pi;
var En = {};
Object.defineProperty(En, "__esModule", { value: !0 });
const Ht = re, vi = oe, yi = er, $i = {
  message: "must be equal to one of the allowed values",
  params: ({ schemaCode: e }) => (0, Ht._)`{allowedValues: ${e}}`
}, _i = {
  keyword: "enum",
  schemaType: "array",
  $data: !0,
  error: $i,
  code(e) {
    const { gen: t, data: r, $data: a, schema: n, schemaCode: c, it: f } = e;
    if (!a && n.length === 0)
      throw new Error("enum must have non-empty array");
    const v = n.length >= f.opts.loopEnum;
    let $;
    const m = () => $ ?? ($ = (0, vi.useFunc)(t, yi.default));
    let h;
    if (v || a)
      h = t.let("valid"), e.block$data(h, E);
    else {
      if (!Array.isArray(n))
        throw new Error("ajv implementation error");
      const k = t.const("vSchema", c);
      h = (0, Ht.or)(...n.map((R, T) => D(k, T)));
    }
    e.pass(h);
    function E() {
      t.assign(h, !1), t.forOf("v", c, (k) => t.if((0, Ht._)`${m()}(${r}, ${k})`, () => t.assign(h, !0).break()));
    }
    function D(k, R) {
      const T = n[R];
      return typeof T == "object" && T !== null ? (0, Ht._)`${m()}(${r}, ${k}[${R}])` : (0, Ht._)`${r} === ${T}`;
    }
  }
};
En.default = _i;
Object.defineProperty(ln, "__esModule", { value: !0 });
const gi = dn, Ei = fn, wi = hn, bi = pn, Si = vn, Pi = yn, Oi = $n, Ri = _n, Ti = gn, Ni = En, Ci = [
  // number
  gi.default,
  Ei.default,
  // string
  wi.default,
  bi.default,
  // object
  Si.default,
  Pi.default,
  // array
  Oi.default,
  Ri.default,
  // any
  { keyword: "type", schemaType: ["string", "array"] },
  { keyword: "nullable", schemaType: "boolean" },
  Ti.default,
  Ni.default
];
ln.default = Ci;
var wn = {}, kt = {};
Object.defineProperty(kt, "__esModule", { value: !0 });
kt.validateAdditionalItems = void 0;
const yt = re, Yr = oe, ji = {
  message: ({ params: { len: e } }) => (0, yt.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, yt._)`{limit: ${e}}`
}, ki = {
  keyword: "additionalItems",
  type: "array",
  schemaType: ["boolean", "object"],
  before: "uniqueItems",
  error: ji,
  code(e) {
    const { parentSchema: t, it: r } = e, { items: a } = t;
    if (!Array.isArray(a)) {
      (0, Yr.checkStrictMode)(r, '"additionalItems" is ignored when "items" is not an array of schemas');
      return;
    }
    Ka(e, a);
  }
};
function Ka(e, t) {
  const { gen: r, schema: a, data: n, keyword: c, it: f } = e;
  f.items = !0;
  const v = r.const("len", (0, yt._)`${n}.length`);
  if (a === !1)
    e.setParams({ len: t.length }), e.pass((0, yt._)`${v} <= ${t.length}`);
  else if (typeof a == "object" && !(0, Yr.alwaysValidSchema)(f, a)) {
    const m = r.var("valid", (0, yt._)`${v} <= ${t.length}`);
    r.if((0, yt.not)(m), () => $(m)), e.ok(m);
  }
  function $(m) {
    r.forRange("i", t.length, v, (h) => {
      e.subschema({ keyword: c, dataProp: h, dataPropType: Yr.Type.Num }, m), f.allErrors || r.if((0, yt.not)(m), () => r.break());
    });
  }
}
kt.validateAdditionalItems = Ka;
kt.default = ki;
var bn = {}, It = {};
Object.defineProperty(It, "__esModule", { value: !0 });
It.validateTuple = void 0;
const ea = re, gr = oe, Ii = ne, Di = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "array", "boolean"],
  before: "uniqueItems",
  code(e) {
    const { schema: t, it: r } = e;
    if (Array.isArray(t))
      return Ga(e, "additionalItems", t);
    r.items = !0, !(0, gr.alwaysValidSchema)(r, t) && e.ok((0, Ii.validateArray)(e));
  }
};
function Ga(e, t, r = e.schema) {
  const { gen: a, parentSchema: n, data: c, keyword: f, it: v } = e;
  h(n), v.opts.unevaluated && r.length && v.items !== !0 && (v.items = gr.mergeEvaluated.items(a, r.length, v.items));
  const $ = a.name("valid"), m = a.const("len", (0, ea._)`${c}.length`);
  r.forEach((E, D) => {
    (0, gr.alwaysValidSchema)(v, E) || (a.if((0, ea._)`${m} > ${D}`, () => e.subschema({
      keyword: f,
      schemaProp: D,
      dataProp: D
    }, $)), e.ok($));
  });
  function h(E) {
    const { opts: D, errSchemaPath: k } = v, R = r.length, T = R === E.minItems && (R === E.maxItems || E[t] === !1);
    if (D.strictTuples && !T) {
      const w = `"${f}" is ${R}-tuple, but minItems or maxItems/${t} are not specified or different at path "${k}"`;
      (0, gr.checkStrictMode)(v, w, D.strictTuples);
    }
  }
}
It.validateTuple = Ga;
It.default = Di;
Object.defineProperty(bn, "__esModule", { value: !0 });
const Ai = It, Mi = {
  keyword: "prefixItems",
  type: "array",
  schemaType: ["array"],
  before: "uniqueItems",
  code: (e) => (0, Ai.validateTuple)(e, "items")
};
bn.default = Mi;
var Sn = {};
Object.defineProperty(Sn, "__esModule", { value: !0 });
const ta = re, Fi = oe, Vi = ne, zi = kt, Ui = {
  message: ({ params: { len: e } }) => (0, ta.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, ta._)`{limit: ${e}}`
}, qi = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  error: Ui,
  code(e) {
    const { schema: t, parentSchema: r, it: a } = e, { prefixItems: n } = r;
    a.items = !0, !(0, Fi.alwaysValidSchema)(a, t) && (n ? (0, zi.validateAdditionalItems)(e, n) : e.ok((0, Vi.validateArray)(e)));
  }
};
Sn.default = qi;
var Pn = {};
Object.defineProperty(Pn, "__esModule", { value: !0 });
const je = re, hr = oe, Li = {
  message: ({ params: { min: e, max: t } }) => t === void 0 ? (0, je.str)`must contain at least ${e} valid item(s)` : (0, je.str)`must contain at least ${e} and no more than ${t} valid item(s)`,
  params: ({ params: { min: e, max: t } }) => t === void 0 ? (0, je._)`{minContains: ${e}}` : (0, je._)`{minContains: ${e}, maxContains: ${t}}`
}, Ki = {
  keyword: "contains",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  trackErrors: !0,
  error: Li,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, it: c } = e;
    let f, v;
    const { minContains: $, maxContains: m } = a;
    c.opts.next ? (f = $ === void 0 ? 1 : $, v = m) : f = 1;
    const h = t.const("len", (0, je._)`${n}.length`);
    if (e.setParams({ min: f, max: v }), v === void 0 && f === 0) {
      (0, hr.checkStrictMode)(c, '"minContains" == 0 without "maxContains": "contains" keyword ignored');
      return;
    }
    if (v !== void 0 && f > v) {
      (0, hr.checkStrictMode)(c, '"minContains" > "maxContains" is always invalid'), e.fail();
      return;
    }
    if ((0, hr.alwaysValidSchema)(c, r)) {
      let T = (0, je._)`${h} >= ${f}`;
      v !== void 0 && (T = (0, je._)`${T} && ${h} <= ${v}`), e.pass(T);
      return;
    }
    c.items = !0;
    const E = t.name("valid");
    v === void 0 && f === 1 ? k(E, () => t.if(E, () => t.break())) : f === 0 ? (t.let(E, !0), v !== void 0 && t.if((0, je._)`${n}.length > 0`, D)) : (t.let(E, !1), D()), e.result(E, () => e.reset());
    function D() {
      const T = t.name("_valid"), w = t.let("count", 0);
      k(T, () => t.if(T, () => R(w)));
    }
    function k(T, w) {
      t.forRange("i", 0, h, (p) => {
        e.subschema({
          keyword: "contains",
          dataProp: p,
          dataPropType: hr.Type.Num,
          compositeRule: !0
        }, T), w();
      });
    }
    function R(T) {
      t.code((0, je._)`${T}++`), v === void 0 ? t.if((0, je._)`${T} >= ${f}`, () => t.assign(E, !0).break()) : (t.if((0, je._)`${T} > ${v}`, () => t.assign(E, !1).break()), f === 1 ? t.assign(E, !0) : t.if((0, je._)`${T} >= ${f}`, () => t.assign(E, !0)));
    }
  }
};
Pn.default = Ki;
var Ha = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.validateSchemaDeps = e.validatePropertyDeps = e.error = void 0;
  const t = re, r = oe, a = ne;
  e.error = {
    message: ({ params: { property: $, depsCount: m, deps: h } }) => {
      const E = m === 1 ? "property" : "properties";
      return (0, t.str)`must have ${E} ${h} when property ${$} is present`;
    },
    params: ({ params: { property: $, depsCount: m, deps: h, missingProperty: E } }) => (0, t._)`{property: ${$},
    missingProperty: ${E},
    depsCount: ${m},
    deps: ${h}}`
    // TODO change to reference
  };
  const n = {
    keyword: "dependencies",
    type: "object",
    schemaType: "object",
    error: e.error,
    code($) {
      const [m, h] = c($);
      f($, m), v($, h);
    }
  };
  function c({ schema: $ }) {
    const m = {}, h = {};
    for (const E in $) {
      if (E === "__proto__")
        continue;
      const D = Array.isArray($[E]) ? m : h;
      D[E] = $[E];
    }
    return [m, h];
  }
  function f($, m = $.schema) {
    const { gen: h, data: E, it: D } = $;
    if (Object.keys(m).length === 0)
      return;
    const k = h.let("missing");
    for (const R in m) {
      const T = m[R];
      if (T.length === 0)
        continue;
      const w = (0, a.propertyInData)(h, E, R, D.opts.ownProperties);
      $.setParams({
        property: R,
        depsCount: T.length,
        deps: T.join(", ")
      }), D.allErrors ? h.if(w, () => {
        for (const p of T)
          (0, a.checkReportMissingProp)($, p);
      }) : (h.if((0, t._)`${w} && (${(0, a.checkMissingProp)($, T, k)})`), (0, a.reportMissingProp)($, k), h.else());
    }
  }
  e.validatePropertyDeps = f;
  function v($, m = $.schema) {
    const { gen: h, data: E, keyword: D, it: k } = $, R = h.name("valid");
    for (const T in m)
      (0, r.alwaysValidSchema)(k, m[T]) || (h.if(
        (0, a.propertyInData)(h, E, T, k.opts.ownProperties),
        () => {
          const w = $.subschema({ keyword: D, schemaProp: T }, R);
          $.mergeValidEvaluated(w, R);
        },
        () => h.var(R, !0)
        // TODO var
      ), $.ok(R));
  }
  e.validateSchemaDeps = v, e.default = n;
})(Ha);
var On = {};
Object.defineProperty(On, "__esModule", { value: !0 });
const Wa = re, Gi = oe, Hi = {
  message: "property name must be valid",
  params: ({ params: e }) => (0, Wa._)`{propertyName: ${e.propertyName}}`
}, Wi = {
  keyword: "propertyNames",
  type: "object",
  schemaType: ["object", "boolean"],
  error: Hi,
  code(e) {
    const { gen: t, schema: r, data: a, it: n } = e;
    if ((0, Gi.alwaysValidSchema)(n, r))
      return;
    const c = t.name("valid");
    t.forIn("key", a, (f) => {
      e.setParams({ propertyName: f }), e.subschema({
        keyword: "propertyNames",
        data: f,
        dataTypes: ["string"],
        propertyName: f,
        compositeRule: !0
      }, c), t.if((0, Wa.not)(c), () => {
        e.error(!0), n.allErrors || t.break();
      });
    }), e.ok(c);
  }
};
On.default = Wi;
var Cr = {};
Object.defineProperty(Cr, "__esModule", { value: !0 });
const mr = ne, Fe = re, Ji = ze, pr = oe, Yi = {
  message: "must NOT have additional properties",
  params: ({ params: e }) => (0, Fe._)`{additionalProperty: ${e.additionalProperty}}`
}, Bi = {
  keyword: "additionalProperties",
  type: ["object"],
  schemaType: ["boolean", "object"],
  allowUndefined: !0,
  trackErrors: !0,
  error: Yi,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, errsCount: c, it: f } = e;
    if (!c)
      throw new Error("ajv implementation error");
    const { allErrors: v, opts: $ } = f;
    if (f.props = !0, $.removeAdditional !== "all" && (0, pr.alwaysValidSchema)(f, r))
      return;
    const m = (0, mr.allSchemaProperties)(a.properties), h = (0, mr.allSchemaProperties)(a.patternProperties);
    E(), e.ok((0, Fe._)`${c} === ${Ji.default.errors}`);
    function E() {
      t.forIn("key", n, (w) => {
        !m.length && !h.length ? R(w) : t.if(D(w), () => R(w));
      });
    }
    function D(w) {
      let p;
      if (m.length > 8) {
        const d = (0, pr.schemaRefOrVal)(f, a.properties, "properties");
        p = (0, mr.isOwnProperty)(t, d, w);
      } else
        m.length ? p = (0, Fe.or)(...m.map((d) => (0, Fe._)`${w} === ${d}`)) : p = Fe.nil;
      return h.length && (p = (0, Fe.or)(p, ...h.map((d) => (0, Fe._)`${(0, mr.usePattern)(e, d)}.test(${w})`))), (0, Fe.not)(p);
    }
    function k(w) {
      t.code((0, Fe._)`delete ${n}[${w}]`);
    }
    function R(w) {
      if ($.removeAdditional === "all" || $.removeAdditional && r === !1) {
        k(w);
        return;
      }
      if (r === !1) {
        e.setParams({ additionalProperty: w }), e.error(), v || t.break();
        return;
      }
      if (typeof r == "object" && !(0, pr.alwaysValidSchema)(f, r)) {
        const p = t.name("valid");
        $.removeAdditional === "failing" ? (T(w, p, !1), t.if((0, Fe.not)(p), () => {
          e.reset(), k(w);
        })) : (T(w, p), v || t.if((0, Fe.not)(p), () => t.break()));
      }
    }
    function T(w, p, d) {
      const N = {
        keyword: "additionalProperties",
        dataProp: w,
        dataPropType: pr.Type.Str
      };
      d === !1 && Object.assign(N, {
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }), e.subschema(N, p);
    }
  }
};
Cr.default = Bi;
var Rn = {};
Object.defineProperty(Rn, "__esModule", { value: !0 });
const Xi = ke, ra = ne, qr = oe, na = Cr, Zi = {
  keyword: "properties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, it: c } = e;
    c.opts.removeAdditional === "all" && a.additionalProperties === void 0 && na.default.code(new Xi.KeywordCxt(c, na.default, "additionalProperties"));
    const f = (0, ra.allSchemaProperties)(r);
    for (const E of f)
      c.definedProperties.add(E);
    c.opts.unevaluated && f.length && c.props !== !0 && (c.props = qr.mergeEvaluated.props(t, (0, qr.toHash)(f), c.props));
    const v = f.filter((E) => !(0, qr.alwaysValidSchema)(c, r[E]));
    if (v.length === 0)
      return;
    const $ = t.name("valid");
    for (const E of v)
      m(E) ? h(E) : (t.if((0, ra.propertyInData)(t, n, E, c.opts.ownProperties)), h(E), c.allErrors || t.else().var($, !0), t.endIf()), e.it.definedProperties.add(E), e.ok($);
    function m(E) {
      return c.opts.useDefaults && !c.compositeRule && r[E].default !== void 0;
    }
    function h(E) {
      e.subschema({
        keyword: "properties",
        schemaProp: E,
        dataProp: E
      }, $);
    }
  }
};
Rn.default = Zi;
var Tn = {};
Object.defineProperty(Tn, "__esModule", { value: !0 });
const aa = ne, vr = re, sa = oe, oa = oe, Qi = {
  keyword: "patternProperties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, data: a, parentSchema: n, it: c } = e, { opts: f } = c, v = (0, aa.allSchemaProperties)(r), $ = v.filter((T) => (0, sa.alwaysValidSchema)(c, r[T]));
    if (v.length === 0 || $.length === v.length && (!c.opts.unevaluated || c.props === !0))
      return;
    const m = f.strictSchema && !f.allowMatchingProperties && n.properties, h = t.name("valid");
    c.props !== !0 && !(c.props instanceof vr.Name) && (c.props = (0, oa.evaluatedPropsToName)(t, c.props));
    const { props: E } = c;
    D();
    function D() {
      for (const T of v)
        m && k(T), c.allErrors ? R(T) : (t.var(h, !0), R(T), t.if(h));
    }
    function k(T) {
      for (const w in m)
        new RegExp(T).test(w) && (0, sa.checkStrictMode)(c, `property ${w} matches pattern ${T} (use allowMatchingProperties)`);
    }
    function R(T) {
      t.forIn("key", a, (w) => {
        t.if((0, vr._)`${(0, aa.usePattern)(e, T)}.test(${w})`, () => {
          const p = $.includes(T);
          p || e.subschema({
            keyword: "patternProperties",
            schemaProp: T,
            dataProp: w,
            dataPropType: oa.Type.Str
          }, h), c.opts.unevaluated && E !== !0 ? t.assign((0, vr._)`${E}[${w}]`, !0) : !p && !c.allErrors && t.if((0, vr.not)(h), () => t.break());
        });
      });
    }
  }
};
Tn.default = Qi;
var Nn = {};
Object.defineProperty(Nn, "__esModule", { value: !0 });
const xi = oe, ec = {
  keyword: "not",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  code(e) {
    const { gen: t, schema: r, it: a } = e;
    if ((0, xi.alwaysValidSchema)(a, r)) {
      e.fail();
      return;
    }
    const n = t.name("valid");
    e.subschema({
      keyword: "not",
      compositeRule: !0,
      createErrors: !1,
      allErrors: !1
    }, n), e.failResult(n, () => e.reset(), () => e.error());
  },
  error: { message: "must NOT be valid" }
};
Nn.default = ec;
var Cn = {};
Object.defineProperty(Cn, "__esModule", { value: !0 });
const tc = ne, rc = {
  keyword: "anyOf",
  schemaType: "array",
  trackErrors: !0,
  code: tc.validateUnion,
  error: { message: "must match a schema in anyOf" }
};
Cn.default = rc;
var jn = {};
Object.defineProperty(jn, "__esModule", { value: !0 });
const Er = re, nc = oe, ac = {
  message: "must match exactly one schema in oneOf",
  params: ({ params: e }) => (0, Er._)`{passingSchemas: ${e.passing}}`
}, sc = {
  keyword: "oneOf",
  schemaType: "array",
  trackErrors: !0,
  error: ac,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, it: n } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    if (n.opts.discriminator && a.discriminator)
      return;
    const c = r, f = t.let("valid", !1), v = t.let("passing", null), $ = t.name("_valid");
    e.setParams({ passing: v }), t.block(m), e.result(f, () => e.reset(), () => e.error(!0));
    function m() {
      c.forEach((h, E) => {
        let D;
        (0, nc.alwaysValidSchema)(n, h) ? t.var($, !0) : D = e.subschema({
          keyword: "oneOf",
          schemaProp: E,
          compositeRule: !0
        }, $), E > 0 && t.if((0, Er._)`${$} && ${f}`).assign(f, !1).assign(v, (0, Er._)`[${v}, ${E}]`).else(), t.if($, () => {
          t.assign(f, !0), t.assign(v, E), D && e.mergeEvaluated(D, Er.Name);
        });
      });
    }
  }
};
jn.default = sc;
var kn = {};
Object.defineProperty(kn, "__esModule", { value: !0 });
const oc = oe, ic = {
  keyword: "allOf",
  schemaType: "array",
  code(e) {
    const { gen: t, schema: r, it: a } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    const n = t.name("valid");
    r.forEach((c, f) => {
      if ((0, oc.alwaysValidSchema)(a, c))
        return;
      const v = e.subschema({ keyword: "allOf", schemaProp: f }, n);
      e.ok(n), e.mergeEvaluated(v);
    });
  }
};
kn.default = ic;
var In = {};
Object.defineProperty(In, "__esModule", { value: !0 });
const Or = re, Ja = oe, cc = {
  message: ({ params: e }) => (0, Or.str)`must match "${e.ifClause}" schema`,
  params: ({ params: e }) => (0, Or._)`{failingKeyword: ${e.ifClause}}`
}, uc = {
  keyword: "if",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  error: cc,
  code(e) {
    const { gen: t, parentSchema: r, it: a } = e;
    r.then === void 0 && r.else === void 0 && (0, Ja.checkStrictMode)(a, '"if" without "then" and "else" is ignored');
    const n = ia(a, "then"), c = ia(a, "else");
    if (!n && !c)
      return;
    const f = t.let("valid", !0), v = t.name("_valid");
    if ($(), e.reset(), n && c) {
      const h = t.let("ifClause");
      e.setParams({ ifClause: h }), t.if(v, m("then", h), m("else", h));
    } else
      n ? t.if(v, m("then")) : t.if((0, Or.not)(v), m("else"));
    e.pass(f, () => e.error(!0));
    function $() {
      const h = e.subschema({
        keyword: "if",
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }, v);
      e.mergeEvaluated(h);
    }
    function m(h, E) {
      return () => {
        const D = e.subschema({ keyword: h }, v);
        t.assign(f, v), e.mergeValidEvaluated(D, f), E ? t.assign(E, (0, Or._)`${h}`) : e.setParams({ ifClause: h });
      };
    }
  }
};
function ia(e, t) {
  const r = e.schema[t];
  return r !== void 0 && !(0, Ja.alwaysValidSchema)(e, r);
}
In.default = uc;
var Dn = {};
Object.defineProperty(Dn, "__esModule", { value: !0 });
const lc = oe, dc = {
  keyword: ["then", "else"],
  schemaType: ["object", "boolean"],
  code({ keyword: e, parentSchema: t, it: r }) {
    t.if === void 0 && (0, lc.checkStrictMode)(r, `"${e}" without "if" is ignored`);
  }
};
Dn.default = dc;
Object.defineProperty(wn, "__esModule", { value: !0 });
const fc = kt, hc = bn, mc = It, pc = Sn, vc = Pn, yc = Ha, $c = On, _c = Cr, gc = Rn, Ec = Tn, wc = Nn, bc = Cn, Sc = jn, Pc = kn, Oc = In, Rc = Dn;
function Tc(e = !1) {
  const t = [
    // any
    wc.default,
    bc.default,
    Sc.default,
    Pc.default,
    Oc.default,
    Rc.default,
    // object
    $c.default,
    _c.default,
    yc.default,
    gc.default,
    Ec.default
  ];
  return e ? t.push(hc.default, pc.default) : t.push(fc.default, mc.default), t.push(vc.default), t;
}
wn.default = Tc;
var An = {}, Mn = {};
Object.defineProperty(Mn, "__esModule", { value: !0 });
const he = re, Nc = {
  message: ({ schemaCode: e }) => (0, he.str)`must match format "${e}"`,
  params: ({ schemaCode: e }) => (0, he._)`{format: ${e}}`
}, Cc = {
  keyword: "format",
  type: ["number", "string"],
  schemaType: "string",
  $data: !0,
  error: Nc,
  code(e, t) {
    const { gen: r, data: a, $data: n, schema: c, schemaCode: f, it: v } = e, { opts: $, errSchemaPath: m, schemaEnv: h, self: E } = v;
    if (!$.validateFormats)
      return;
    n ? D() : k();
    function D() {
      const R = r.scopeValue("formats", {
        ref: E.formats,
        code: $.code.formats
      }), T = r.const("fDef", (0, he._)`${R}[${f}]`), w = r.let("fType"), p = r.let("format");
      r.if((0, he._)`typeof ${T} == "object" && !(${T} instanceof RegExp)`, () => r.assign(w, (0, he._)`${T}.type || "string"`).assign(p, (0, he._)`${T}.validate`), () => r.assign(w, (0, he._)`"string"`).assign(p, T)), e.fail$data((0, he.or)(d(), N()));
      function d() {
        return $.strictSchema === !1 ? he.nil : (0, he._)`${f} && !${p}`;
      }
      function N() {
        const j = h.$async ? (0, he._)`(${T}.async ? await ${p}(${a}) : ${p}(${a}))` : (0, he._)`${p}(${a})`, z = (0, he._)`(typeof ${p} == "function" ? ${j} : ${p}.test(${a}))`;
        return (0, he._)`${p} && ${p} !== true && ${w} === ${t} && !${z}`;
      }
    }
    function k() {
      const R = E.formats[c];
      if (!R) {
        d();
        return;
      }
      if (R === !0)
        return;
      const [T, w, p] = N(R);
      T === t && e.pass(j());
      function d() {
        if ($.strictSchema === !1) {
          E.logger.warn(z());
          return;
        }
        throw new Error(z());
        function z() {
          return `unknown format "${c}" ignored in schema at path "${m}"`;
        }
      }
      function N(z) {
        const S = z instanceof RegExp ? (0, he.regexpCode)(z) : $.code.formats ? (0, he._)`${$.code.formats}${(0, he.getProperty)(c)}` : void 0, b = r.scopeValue("formats", { key: c, ref: z, code: S });
        return typeof z == "object" && !(z instanceof RegExp) ? [z.type || "string", z.validate, (0, he._)`${b}.validate`] : ["string", z, b];
      }
      function j() {
        if (typeof R == "object" && !(R instanceof RegExp) && R.async) {
          if (!h.$async)
            throw new Error("async format in sync schema");
          return (0, he._)`await ${p}(${a})`;
        }
        return typeof w == "function" ? (0, he._)`${p}(${a})` : (0, he._)`${p}.test(${a})`;
      }
    }
  }
};
Mn.default = Cc;
Object.defineProperty(An, "__esModule", { value: !0 });
const jc = Mn, kc = [jc.default];
An.default = kc;
var Ct = {};
Object.defineProperty(Ct, "__esModule", { value: !0 });
Ct.contentVocabulary = Ct.metadataVocabulary = void 0;
Ct.metadataVocabulary = [
  "title",
  "description",
  "default",
  "deprecated",
  "readOnly",
  "writeOnly",
  "examples"
];
Ct.contentVocabulary = [
  "contentMediaType",
  "contentEncoding",
  "contentSchema"
];
Object.defineProperty(on, "__esModule", { value: !0 });
const Ic = cn, Dc = ln, Ac = wn, Mc = An, ca = Ct, Fc = [
  Ic.default,
  Dc.default,
  (0, Ac.default)(),
  Mc.default,
  ca.metadataVocabulary,
  ca.contentVocabulary
];
on.default = Fc;
var Fn = {}, Ya = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.DiscrError = void 0, function(t) {
    t.Tag = "tag", t.Mapping = "mapping";
  }(e.DiscrError || (e.DiscrError = {}));
})(Ya);
Object.defineProperty(Fn, "__esModule", { value: !0 });
const Ot = re, Br = Ya, ua = Pe, Vc = oe, zc = {
  message: ({ params: { discrError: e, tagName: t } }) => e === Br.DiscrError.Tag ? `tag "${t}" must be string` : `value of tag "${t}" must be in oneOf`,
  params: ({ params: { discrError: e, tag: t, tagName: r } }) => (0, Ot._)`{error: ${e}, tag: ${r}, tagValue: ${t}}`
}, Uc = {
  keyword: "discriminator",
  type: "object",
  schemaType: "object",
  error: zc,
  code(e) {
    const { gen: t, data: r, schema: a, parentSchema: n, it: c } = e, { oneOf: f } = n;
    if (!c.opts.discriminator)
      throw new Error("discriminator: requires discriminator option");
    const v = a.propertyName;
    if (typeof v != "string")
      throw new Error("discriminator: requires propertyName");
    if (a.mapping)
      throw new Error("discriminator: mapping is not supported");
    if (!f)
      throw new Error("discriminator: requires oneOf keyword");
    const $ = t.let("valid", !1), m = t.const("tag", (0, Ot._)`${r}${(0, Ot.getProperty)(v)}`);
    t.if((0, Ot._)`typeof ${m} == "string"`, () => h(), () => e.error(!1, { discrError: Br.DiscrError.Tag, tag: m, tagName: v })), e.ok($);
    function h() {
      const k = D();
      t.if(!1);
      for (const R in k)
        t.elseIf((0, Ot._)`${m} === ${R}`), t.assign($, E(k[R]));
      t.else(), e.error(!1, { discrError: Br.DiscrError.Mapping, tag: m, tagName: v }), t.endIf();
    }
    function E(k) {
      const R = t.name("valid"), T = e.subschema({ keyword: "oneOf", schemaProp: k }, R);
      return e.mergeEvaluated(T, Ot.Name), R;
    }
    function D() {
      var k;
      const R = {}, T = p(n);
      let w = !0;
      for (let j = 0; j < f.length; j++) {
        let z = f[j];
        z != null && z.$ref && !(0, Vc.schemaHasRulesButRef)(z, c.self.RULES) && (z = ua.resolveRef.call(c.self, c.schemaEnv.root, c.baseId, z == null ? void 0 : z.$ref), z instanceof ua.SchemaEnv && (z = z.schema));
        const S = (k = z == null ? void 0 : z.properties) === null || k === void 0 ? void 0 : k[v];
        if (typeof S != "object")
          throw new Error(`discriminator: oneOf subschemas (or referenced schemas) must have "properties/${v}"`);
        w = w && (T || p(z)), d(S, j);
      }
      if (!w)
        throw new Error(`discriminator: "${v}" must be required`);
      return R;
      function p({ required: j }) {
        return Array.isArray(j) && j.includes(v);
      }
      function d(j, z) {
        if (j.const)
          N(j.const, z);
        else if (j.enum)
          for (const S of j.enum)
            N(S, z);
        else
          throw new Error(`discriminator: "properties/${v}" must have "const" or "enum"`);
      }
      function N(j, z) {
        if (typeof j != "string" || j in R)
          throw new Error(`discriminator: "${v}" values must be unique strings`);
        R[j] = z;
      }
    }
  }
};
Fn.default = Uc;
const qc = "http://json-schema.org/draft-07/schema#", Lc = "http://json-schema.org/draft-07/schema#", Kc = "Core schema meta-schema", Gc = {
  schemaArray: {
    type: "array",
    minItems: 1,
    items: {
      $ref: "#"
    }
  },
  nonNegativeInteger: {
    type: "integer",
    minimum: 0
  },
  nonNegativeIntegerDefault0: {
    allOf: [
      {
        $ref: "#/definitions/nonNegativeInteger"
      },
      {
        default: 0
      }
    ]
  },
  simpleTypes: {
    enum: [
      "array",
      "boolean",
      "integer",
      "null",
      "number",
      "object",
      "string"
    ]
  },
  stringArray: {
    type: "array",
    items: {
      type: "string"
    },
    uniqueItems: !0,
    default: []
  }
}, Hc = [
  "object",
  "boolean"
], Wc = {
  $id: {
    type: "string",
    format: "uri-reference"
  },
  $schema: {
    type: "string",
    format: "uri"
  },
  $ref: {
    type: "string",
    format: "uri-reference"
  },
  $comment: {
    type: "string"
  },
  title: {
    type: "string"
  },
  description: {
    type: "string"
  },
  default: !0,
  readOnly: {
    type: "boolean",
    default: !1
  },
  examples: {
    type: "array",
    items: !0
  },
  multipleOf: {
    type: "number",
    exclusiveMinimum: 0
  },
  maximum: {
    type: "number"
  },
  exclusiveMaximum: {
    type: "number"
  },
  minimum: {
    type: "number"
  },
  exclusiveMinimum: {
    type: "number"
  },
  maxLength: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minLength: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  pattern: {
    type: "string",
    format: "regex"
  },
  additionalItems: {
    $ref: "#"
  },
  items: {
    anyOf: [
      {
        $ref: "#"
      },
      {
        $ref: "#/definitions/schemaArray"
      }
    ],
    default: !0
  },
  maxItems: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minItems: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  uniqueItems: {
    type: "boolean",
    default: !1
  },
  contains: {
    $ref: "#"
  },
  maxProperties: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minProperties: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  required: {
    $ref: "#/definitions/stringArray"
  },
  additionalProperties: {
    $ref: "#"
  },
  definitions: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  properties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  patternProperties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    propertyNames: {
      format: "regex"
    },
    default: {}
  },
  dependencies: {
    type: "object",
    additionalProperties: {
      anyOf: [
        {
          $ref: "#"
        },
        {
          $ref: "#/definitions/stringArray"
        }
      ]
    }
  },
  propertyNames: {
    $ref: "#"
  },
  const: !0,
  enum: {
    type: "array",
    items: !0,
    minItems: 1,
    uniqueItems: !0
  },
  type: {
    anyOf: [
      {
        $ref: "#/definitions/simpleTypes"
      },
      {
        type: "array",
        items: {
          $ref: "#/definitions/simpleTypes"
        },
        minItems: 1,
        uniqueItems: !0
      }
    ]
  },
  format: {
    type: "string"
  },
  contentMediaType: {
    type: "string"
  },
  contentEncoding: {
    type: "string"
  },
  if: {
    $ref: "#"
  },
  then: {
    $ref: "#"
  },
  else: {
    $ref: "#"
  },
  allOf: {
    $ref: "#/definitions/schemaArray"
  },
  anyOf: {
    $ref: "#/definitions/schemaArray"
  },
  oneOf: {
    $ref: "#/definitions/schemaArray"
  },
  not: {
    $ref: "#"
  }
}, Jc = {
  $schema: qc,
  $id: Lc,
  title: Kc,
  definitions: Gc,
  type: Hc,
  properties: Wc,
  default: !0
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.MissingRefError = t.ValidationError = t.CodeGen = t.Name = t.nil = t.stringify = t.str = t._ = t.KeywordCxt = void 0;
  const r = ma, a = on, n = Fn, c = Jc, f = ["/properties"], v = "http://json-schema.org/draft-07/schema";
  class $ extends r.default {
    _addVocabularies() {
      super._addVocabularies(), a.default.forEach((R) => this.addVocabulary(R)), this.opts.discriminator && this.addKeyword(n.default);
    }
    _addDefaultMetaSchema() {
      if (super._addDefaultMetaSchema(), !this.opts.meta)
        return;
      const R = this.opts.$data ? this.$dataMetaSchema(c, f) : c;
      this.addMetaSchema(R, v, !1), this.refs["http://json-schema.org/schema"] = v;
    }
    defaultMeta() {
      return this.opts.defaultMeta = super.defaultMeta() || (this.getSchema(v) ? v : void 0);
    }
  }
  e.exports = t = $, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = $;
  var m = ke;
  Object.defineProperty(t, "KeywordCxt", { enumerable: !0, get: function() {
    return m.KeywordCxt;
  } });
  var h = re;
  Object.defineProperty(t, "_", { enumerable: !0, get: function() {
    return h._;
  } }), Object.defineProperty(t, "str", { enumerable: !0, get: function() {
    return h.str;
  } }), Object.defineProperty(t, "stringify", { enumerable: !0, get: function() {
    return h.stringify;
  } }), Object.defineProperty(t, "nil", { enumerable: !0, get: function() {
    return h.nil;
  } }), Object.defineProperty(t, "Name", { enumerable: !0, get: function() {
    return h.Name;
  } }), Object.defineProperty(t, "CodeGen", { enumerable: !0, get: function() {
    return h.CodeGen;
  } });
  var E = Qt;
  Object.defineProperty(t, "ValidationError", { enumerable: !0, get: function() {
    return E.default;
  } });
  var D = xt;
  Object.defineProperty(t, "MissingRefError", { enumerable: !0, get: function() {
    return D.default;
  } });
})(Kr, Kr.exports);
var Vn = Kr.exports;
const Yc = /* @__PURE__ */ Qr(Vn);
var Xr = { exports: {} };
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = Vn, a = re, n = Nt, c = ke, f = jt, v = ze, $ = "errorMessage", m = new r.Name("emUsed"), h = {
    required: "missingProperty",
    dependencies: "property",
    dependentRequired: "property"
  }, E = /\$\{[^}]+\}/, D = /\$\{([^}]+)\}/g, k = /^""\s*\+\s*|\s*\+\s*""$/g;
  function R(w) {
    return {
      keyword: $,
      schemaType: ["string", "object"],
      post: !0,
      code(p) {
        const { gen: d, data: N, schema: j, schemaValue: z, it: S } = p;
        if (S.createErrors === !1)
          return;
        const b = j, A = a.strConcat(v.default.instancePath, S.errorPath);
        d.if(r._`${v.default.errors} > 0`, () => {
          if (typeof b == "object") {
            const [g, o] = L(b);
            o && Q(o), g && J(g), ie(M(b));
          }
          const O = typeof b == "string" ? b : b._;
          O && se(O), w.keepErrors || me();
        });
        function M({ properties: O, items: g }) {
          const o = {};
          if (O) {
            o.props = {};
            for (const l in O)
              o.props[l] = [];
          }
          if (g) {
            o.items = {};
            for (let l = 0; l < g.length; l++)
              o.items[l] = [];
          }
          return o;
        }
        function L(O) {
          let g, o;
          for (const l in O) {
            if (l === "properties" || l === "items")
              continue;
            const C = O[l];
            if (typeof C == "object") {
              g || (g = {});
              const U = g[l] = {};
              for (const F in C)
                U[F] = [];
            } else
              o || (o = {}), o[l] = [];
          }
          return [g, o];
        }
        function Q(O) {
          const g = d.const("emErrors", r.stringify(O)), o = d.const("templates", Re(O, j));
          d.forOf("err", v.default.vErrors, (F) => d.if(Oe(F, g), () => d.code(r._`${g}[${F}.keyword].push(${F})`).assign(r._`${F}.${m}`, !0)));
          const { singleError: l } = w;
          if (l) {
            const F = d.let("message", r._`""`), G = d.let("paramsErrors", r._`[]`);
            C((Z) => {
              d.if(F, () => d.code(r._`${F} += ${typeof l == "string" ? l : ";"}`)), d.code(r._`${F} += ${U(Z)}`), d.assign(G, r._`${G}.concat(${g}[${Z}])`);
            }), f.reportError(p, { message: F, params: r._`{errors: ${G}}` });
          } else
            C((F) => f.reportError(p, {
              message: U(F),
              params: r._`{errors: ${g}[${F}]}`
            }));
          function C(F) {
            d.forIn("key", g, (G) => d.if(r._`${g}[${G}].length`, () => F(G)));
          }
          function U(F) {
            return r._`${F} in ${o} ? ${o}[${F}]() : ${z}[${F}]`;
          }
        }
        function J(O) {
          const g = d.const("emErrors", r.stringify(O)), o = [];
          for (const G in O)
            o.push([
              G,
              Re(O[G], j[G])
            ]);
          const l = d.const("templates", d.object(...o)), C = d.scopeValue("obj", {
            ref: h,
            code: r.stringify(h)
          }), U = d.let("emPropParams"), F = d.let("emParamsErrors");
          d.forOf("err", v.default.vErrors, (G) => d.if(Oe(G, g), () => {
            d.assign(U, r._`${C}[${G}.keyword]`), d.assign(F, r._`${g}[${G}.keyword][${G}.params[${U}]]`), d.if(F, () => d.code(r._`${F}.push(${G})`).assign(r._`${G}.${m}`, !0));
          })), d.forIn("key", g, (G) => d.forIn("keyProp", r._`${g}[${G}]`, (Z) => {
            d.assign(F, r._`${g}[${G}][${Z}]`), d.if(r._`${F}.length`, () => {
              const ce = d.const("tmpl", r._`${l}[${G}] && ${l}[${G}][${Z}]`);
              f.reportError(p, {
                message: r._`${ce} ? ${ce}() : ${z}[${G}][${Z}]`,
                params: r._`{errors: ${F}}`
              });
            });
          }));
        }
        function ie(O) {
          const { props: g, items: o } = O;
          if (!g && !o)
            return;
          const l = r._`typeof ${N} == "object"`, C = r._`Array.isArray(${N})`, U = d.let("emErrors");
          let F, G;
          const Z = d.let("templates");
          g && o ? (F = d.let("emChildKwd"), d.if(l), d.if(C, () => {
            ce(o, j.items), d.assign(F, r.str`items`);
          }, () => {
            ce(g, j.properties), d.assign(F, r.str`properties`);
          }), G = r._`[${F}]`) : o ? (d.if(C), ce(o, j.items), G = r._`.items`) : g && (d.if(a.and(l, a.not(C))), ce(g, j.properties), G = r._`.properties`), d.forOf("err", v.default.vErrors, (ue) => Ie(ue, U, (Te) => d.code(r._`${U}[${Te}].push(${ue})`).assign(r._`${ue}.${m}`, !0))), d.forIn("key", U, (ue) => d.if(r._`${U}[${ue}].length`, () => {
            f.reportError(p, {
              message: r._`${ue} in ${Z} ? ${Z}[${ue}]() : ${z}${G}[${ue}]`,
              params: r._`{errors: ${U}[${ue}]}`
            }), d.assign(r._`${v.default.vErrors}[${v.default.errors}-1].instancePath`, r._`${A} + "/" + ${ue}.replace(/~/g, "~0").replace(/\\//g, "~1")`);
          })), d.endIf();
          function ce(ue, Te) {
            d.assign(U, r.stringify(ue)), d.assign(Z, Re(ue, Te));
          }
        }
        function se(O) {
          const g = d.const("emErrs", r._`[]`);
          d.forOf("err", v.default.vErrors, (o) => d.if(Ue(o), () => d.code(r._`${g}.push(${o})`).assign(r._`${o}.${m}`, !0))), d.if(r._`${g}.length`, () => f.reportError(p, {
            message: q(O),
            params: r._`{errors: ${g}}`
          }));
        }
        function me() {
          const O = d.const("emErrs", r._`[]`);
          d.forOf("err", v.default.vErrors, (g) => d.if(r._`!${g}.${m}`, () => d.code(r._`${O}.push(${g})`))), d.assign(v.default.vErrors, O).assign(v.default.errors, r._`${O}.length`);
        }
        function Oe(O, g) {
          return a.and(
            r._`${O}.keyword !== ${$}`,
            r._`!${O}.${m}`,
            r._`${O}.instancePath === ${A}`,
            r._`${O}.keyword in ${g}`,
            // TODO match the end of the string?
            r._`${O}.schemaPath.indexOf(${S.errSchemaPath}) === 0`,
            r._`/^\\/[^\\/]*$/.test(${O}.schemaPath.slice(${S.errSchemaPath.length}))`
          );
        }
        function Ie(O, g, o) {
          d.if(a.and(r._`${O}.keyword !== ${$}`, r._`!${O}.${m}`, r._`${O}.instancePath.indexOf(${A}) === 0`), () => {
            const l = d.scopeValue("pattern", {
              ref: /^\/([^/]*)(?:\/|$)/,
              code: r._`new RegExp("^\\\/([^/]*)(?:\\\/|$)")`
            }), C = d.const("emMatches", r._`${l}.exec(${O}.instancePath.slice(${A}.length))`), U = d.const("emChild", r._`${C} && ${C}[1].replace(/~1/g, "/").replace(/~0/g, "~")`);
            d.if(r._`${U} !== undefined && ${U} in ${g}`, () => o(U));
          });
        }
        function Ue(O) {
          return a.and(r._`${O}.keyword !== ${$}`, r._`!${O}.${m}`, a.or(r._`${O}.instancePath === ${A}`, a.and(r._`${O}.instancePath.indexOf(${A}) === 0`, r._`${O}.instancePath[${A}.length] === "/"`)), r._`${O}.schemaPath.indexOf(${S.errSchemaPath}) === 0`, r._`${O}.schemaPath[${S.errSchemaPath}.length] === "/"`);
        }
        function Re(O, g) {
          const o = [];
          for (const l in O) {
            const C = g[l];
            E.test(C) && o.push([l, P(C)]);
          }
          return d.object(...o);
        }
        function q(O) {
          return E.test(O) ? new n._Code(n.safeStringify(O).replace(D, (g, o) => `" + JSON.stringify(${c.getData(o, S)}) + "`).replace(k, "")) : r.stringify(O);
        }
        function P(O) {
          return r._`function(){return ${q(O)}}`;
        }
      },
      metaSchema: {
        anyOf: [
          { type: "string" },
          {
            type: "object",
            properties: {
              properties: { $ref: "#/$defs/stringMap" },
              items: { $ref: "#/$defs/stringList" },
              required: { $ref: "#/$defs/stringOrMap" },
              dependencies: { $ref: "#/$defs/stringOrMap" }
            },
            additionalProperties: { type: "string" }
          }
        ],
        $defs: {
          stringMap: {
            type: "object",
            additionalProperties: { type: "string" }
          },
          stringOrMap: {
            anyOf: [{ type: "string" }, { $ref: "#/$defs/stringMap" }]
          },
          stringList: { type: "array", items: { type: "string" } }
        }
      }
    };
  }
  const T = (w, p = {}) => {
    if (!w.opts.allErrors)
      throw new Error("ajv-errors: Ajv option allErrors must be true");
    if (w.opts.jsPropertySyntax)
      throw new Error("ajv-errors: ajv option jsPropertySyntax is not supported");
    return w.addKeyword(R(p));
  };
  t.default = T, e.exports = T, e.exports.default = T;
})(Xr, Xr.exports);
var Bc = Xr.exports;
const Xc = /* @__PURE__ */ Qr(Bc);
var Zr = { exports: {} }, Ba = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatNames = e.fastFormats = e.fullFormats = void 0;
  function t(M, L) {
    return { validate: M, compare: L };
  }
  e.fullFormats = {
    // date: http://tools.ietf.org/html/rfc3339#section-5.6
    date: t(c, f),
    // date-time: http://tools.ietf.org/html/rfc3339#section-5.6
    time: t($, m),
    "date-time": t(E, D),
    // duration: https://tools.ietf.org/html/rfc3339#appendix-A
    duration: /^P(?!$)((\d+Y)?(\d+M)?(\d+D)?(T(?=\d)(\d+H)?(\d+M)?(\d+S)?)?|(\d+W)?)$/,
    uri: T,
    "uri-reference": /^(?:[a-z][a-z0-9+\-.]*:)?(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'"()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?(?:\?(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i,
    // uri-template: https://tools.ietf.org/html/rfc6570
    "uri-template": /^(?:(?:[^\x00-\x20"'<>%\\^`{|}]|%[0-9a-f]{2})|\{[+#./;?&=,!@|]?(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?(?:,(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?)*\})*$/i,
    // For the source: https://gist.github.com/dperini/729294
    // For test cases: https://mathiasbynens.be/demo/url-regex
    url: /^(?:https?|ftp):\/\/(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)(?:\.(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)*(?:\.(?:[a-z\u{00a1}-\u{ffff}]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/iu,
    email: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
    hostname: /^(?=.{1,253}\.?$)[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*\.?$/i,
    // optimized https://www.safaribooksonline.com/library/view/regular-expressions-cookbook/9780596802837/ch07s16.html
    ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
    ipv6: /^((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))$/i,
    regex: A,
    // uuid: http://tools.ietf.org/html/rfc4122
    uuid: /^(?:urn:uuid:)?[0-9a-f]{8}-(?:[0-9a-f]{4}-){3}[0-9a-f]{12}$/i,
    // JSON-pointer: https://tools.ietf.org/html/rfc6901
    // uri fragment: https://tools.ietf.org/html/rfc3986#appendix-A
    "json-pointer": /^(?:\/(?:[^~/]|~0|~1)*)*$/,
    "json-pointer-uri-fragment": /^#(?:\/(?:[a-z0-9_\-.!$&'()*+,;:=@]|%[0-9a-f]{2}|~0|~1)*)*$/i,
    // relative JSON-pointer: http://tools.ietf.org/html/draft-luff-relative-json-pointer-00
    "relative-json-pointer": /^(?:0|[1-9][0-9]*)(?:#|(?:\/(?:[^~/]|~0|~1)*)*)$/,
    // the following formats are used by the openapi specification: https://spec.openapis.org/oas/v3.0.0#data-types
    // byte: https://github.com/miguelmota/is-base64
    byte: p,
    // signed 32 bit integer
    int32: { type: "number", validate: j },
    // signed 64 bit integer
    int64: { type: "number", validate: z },
    // C-type float
    float: { type: "number", validate: S },
    // C-type double
    double: { type: "number", validate: S },
    // hint to the UI to hide input strings
    password: !0,
    // unchecked string payload
    binary: !0
  }, e.fastFormats = {
    ...e.fullFormats,
    date: t(/^\d\d\d\d-[0-1]\d-[0-3]\d$/, f),
    time: t(/^(?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)?$/i, m),
    "date-time": t(/^\d\d\d\d-[0-1]\d-[0-3]\d[t\s](?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)$/i, D),
    // uri: https://github.com/mafintosh/is-my-json-valid/blob/master/formats.js
    uri: /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/)?[^\s]*$/i,
    "uri-reference": /^(?:(?:[a-z][a-z0-9+\-.]*:)?\/?\/)?(?:[^\\\s#][^\s#]*)?(?:#[^\\\s]*)?$/i,
    // email (sources from jsen validator):
    // http://stackoverflow.com/questions/201323/using-a-regular-expression-to-validate-an-email-address#answer-8829363
    // http://www.w3.org/TR/html5/forms.html#valid-e-mail-address (search for 'wilful violation')
    email: /^[a-z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?)*$/i
  }, e.formatNames = Object.keys(e.fullFormats);
  function r(M) {
    return M % 4 === 0 && (M % 100 !== 0 || M % 400 === 0);
  }
  const a = /^(\d\d\d\d)-(\d\d)-(\d\d)$/, n = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  function c(M) {
    const L = a.exec(M);
    if (!L)
      return !1;
    const Q = +L[1], J = +L[2], ie = +L[3];
    return J >= 1 && J <= 12 && ie >= 1 && ie <= (J === 2 && r(Q) ? 29 : n[J]);
  }
  function f(M, L) {
    if (M && L)
      return M > L ? 1 : M < L ? -1 : 0;
  }
  const v = /^(\d\d):(\d\d):(\d\d)(\.\d+)?(z|[+-]\d\d(?::?\d\d)?)?$/i;
  function $(M, L) {
    const Q = v.exec(M);
    if (!Q)
      return !1;
    const J = +Q[1], ie = +Q[2], se = +Q[3], me = Q[5];
    return (J <= 23 && ie <= 59 && se <= 59 || J === 23 && ie === 59 && se === 60) && (!L || me !== "");
  }
  function m(M, L) {
    if (!(M && L))
      return;
    const Q = v.exec(M), J = v.exec(L);
    if (Q && J)
      return M = Q[1] + Q[2] + Q[3] + (Q[4] || ""), L = J[1] + J[2] + J[3] + (J[4] || ""), M > L ? 1 : M < L ? -1 : 0;
  }
  const h = /t|\s/i;
  function E(M) {
    const L = M.split(h);
    return L.length === 2 && c(L[0]) && $(L[1], !0);
  }
  function D(M, L) {
    if (!(M && L))
      return;
    const [Q, J] = M.split(h), [ie, se] = L.split(h), me = f(Q, ie);
    if (me !== void 0)
      return me || m(J, se);
  }
  const k = /\/|:/, R = /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)(?:\?(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
  function T(M) {
    return k.test(M) && R.test(M);
  }
  const w = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/gm;
  function p(M) {
    return w.lastIndex = 0, w.test(M);
  }
  const d = -(2 ** 31), N = 2 ** 31 - 1;
  function j(M) {
    return Number.isInteger(M) && M <= N && M >= d;
  }
  function z(M) {
    return Number.isInteger(M);
  }
  function S() {
    return !0;
  }
  const b = /[^\\]\\Z/;
  function A(M) {
    if (b.test(M))
      return !1;
    try {
      return new RegExp(M), !0;
    } catch {
      return !1;
    }
  }
})(Ba);
var Xa = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatLimitDefinition = void 0;
  const t = Vn, r = re, a = r.operators, n = {
    formatMaximum: { okStr: "<=", ok: a.LTE, fail: a.GT },
    formatMinimum: { okStr: ">=", ok: a.GTE, fail: a.LT },
    formatExclusiveMaximum: { okStr: "<", ok: a.LT, fail: a.GTE },
    formatExclusiveMinimum: { okStr: ">", ok: a.GT, fail: a.LTE }
  }, c = {
    message: ({ keyword: v, schemaCode: $ }) => r.str`should be ${n[v].okStr} ${$}`,
    params: ({ keyword: v, schemaCode: $ }) => r._`{comparison: ${n[v].okStr}, limit: ${$}}`
  };
  e.formatLimitDefinition = {
    keyword: Object.keys(n),
    type: "string",
    schemaType: "string",
    $data: !0,
    error: c,
    code(v) {
      const { gen: $, data: m, schemaCode: h, keyword: E, it: D } = v, { opts: k, self: R } = D;
      if (!k.validateFormats)
        return;
      const T = new t.KeywordCxt(D, R.RULES.all.format.definition, "format");
      T.$data ? w() : p();
      function w() {
        const N = $.scopeValue("formats", {
          ref: R.formats,
          code: k.code.formats
        }), j = $.const("fmt", r._`${N}[${T.schemaCode}]`);
        v.fail$data(r.or(r._`typeof ${j} != "object"`, r._`${j} instanceof RegExp`, r._`typeof ${j}.compare != "function"`, d(j)));
      }
      function p() {
        const N = T.schema, j = R.formats[N];
        if (!j || j === !0)
          return;
        if (typeof j != "object" || j instanceof RegExp || typeof j.compare != "function")
          throw new Error(`"${E}": format "${N}" does not define "compare" function`);
        const z = $.scopeValue("formats", {
          key: N,
          ref: j,
          code: k.code.formats ? r._`${k.code.formats}${r.getProperty(N)}` : void 0
        });
        v.fail$data(d(z));
      }
      function d(N) {
        return r._`${N}.compare(${m}, ${h}) ${n[E].fail} 0`;
      }
    },
    dependencies: ["format"]
  };
  const f = (v) => (v.addKeyword(e.formatLimitDefinition), v);
  e.default = f;
})(Xa);
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = Ba, a = Xa, n = re, c = new n.Name("fullFormats"), f = new n.Name("fastFormats"), v = (m, h = { keywords: !0 }) => {
    if (Array.isArray(h))
      return $(m, h, r.fullFormats, c), m;
    const [E, D] = h.mode === "fast" ? [r.fastFormats, f] : [r.fullFormats, c], k = h.formats || r.formatNames;
    return $(m, k, E, D), h.keywords && a.default(m), m;
  };
  v.get = (m, h = "full") => {
    const D = (h === "fast" ? r.fastFormats : r.fullFormats)[m];
    if (!D)
      throw new Error(`Unknown format "${m}"`);
    return D;
  };
  function $(m, h, E, D) {
    var k, R;
    (k = (R = m.opts.code).formats) !== null && k !== void 0 || (R.formats = n._`require("ajv-formats/dist/formats").${D}`);
    for (const T of h)
      m.addFormat(T, E[T]);
  }
  e.exports = t = v, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = v;
})(Zr, Zr.exports);
var Zc = Zr.exports;
const Qc = /* @__PURE__ */ Qr(Zc), la = Qc(
  Xc(
    new Yc({
      allErrors: !0,
      $data: !0,
      strict: !0,
      strictTypes: !0,
      strictSchema: !0,
      strictRequired: !0,
      strictNumbers: !0,
      strictTuples: !0,
      coerceTypes: !0,
      removeAdditional: !0,
      useDefaults: !0
    })
  )
);
function xc(e, t = 250) {
  const [r, a] = yr(e);
  return Lr(() => {
    const n = setTimeout(() => {
      a(e);
    }, t);
    return () => {
      clearTimeout(n);
    };
  }, [e, t]), r;
}
var Kt = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var da;
function eu() {
  return da || (da = 1, process.env.NODE_ENV !== "production" && function() {
    var e = ha, t = Symbol.for("react.element"), r = Symbol.for("react.portal"), a = Symbol.for("react.fragment"), n = Symbol.for("react.strict_mode"), c = Symbol.for("react.profiler"), f = Symbol.for("react.provider"), v = Symbol.for("react.context"), $ = Symbol.for("react.forward_ref"), m = Symbol.for("react.suspense"), h = Symbol.for("react.suspense_list"), E = Symbol.for("react.memo"), D = Symbol.for("react.lazy"), k = Symbol.for("react.offscreen"), R = Symbol.iterator, T = "@@iterator";
    function w(s) {
      if (s === null || typeof s != "object")
        return null;
      var u = R && s[R] || s[T];
      return typeof u == "function" ? u : null;
    }
    var p = e.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function d(s) {
      {
        for (var u = arguments.length, I = new Array(u > 1 ? u - 1 : 0), V = 1; V < u; V++)
          I[V - 1] = arguments[V];
        N("error", s, I);
      }
    }
    function N(s, u, I) {
      {
        var V = p.ReactDebugCurrentFrame, H = V.getStackAddendum();
        H !== "" && (u += "%s", I = I.concat([H]));
        var X = I.map(function(B) {
          return String(B);
        });
        X.unshift("Warning: " + u), Function.prototype.apply.call(console[s], console, X);
      }
    }
    var j = !1, z = !1, S = !1, b = !1, A = !1, M;
    M = Symbol.for("react.module.reference");
    function L(s) {
      return !!(typeof s == "string" || typeof s == "function" || s === a || s === c || A || s === n || s === m || s === h || b || s === k || j || z || S || typeof s == "object" && s !== null && (s.$$typeof === D || s.$$typeof === E || s.$$typeof === f || s.$$typeof === v || s.$$typeof === $ || // This needs to include all possible module reference object
      // types supported by any Flight configuration anywhere since
      // we don't know which Flight build this will end up being used
      // with.
      s.$$typeof === M || s.getModuleId !== void 0));
    }
    function Q(s, u, I) {
      var V = s.displayName;
      if (V)
        return V;
      var H = u.displayName || u.name || "";
      return H !== "" ? I + "(" + H + ")" : I;
    }
    function J(s) {
      return s.displayName || "Context";
    }
    function ie(s) {
      if (s == null)
        return null;
      if (typeof s.tag == "number" && d("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof s == "function")
        return s.displayName || s.name || null;
      if (typeof s == "string")
        return s;
      switch (s) {
        case a:
          return "Fragment";
        case r:
          return "Portal";
        case c:
          return "Profiler";
        case n:
          return "StrictMode";
        case m:
          return "Suspense";
        case h:
          return "SuspenseList";
      }
      if (typeof s == "object")
        switch (s.$$typeof) {
          case v:
            var u = s;
            return J(u) + ".Consumer";
          case f:
            var I = s;
            return J(I._context) + ".Provider";
          case $:
            return Q(s, s.render, "ForwardRef");
          case E:
            var V = s.displayName || null;
            return V !== null ? V : ie(s.type) || "Memo";
          case D: {
            var H = s, X = H._payload, B = H._init;
            try {
              return ie(B(X));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var se = Object.assign, me = 0, Oe, Ie, Ue, Re, q, P, O;
    function g() {
    }
    g.__reactDisabledLog = !0;
    function o() {
      {
        if (me === 0) {
          Oe = console.log, Ie = console.info, Ue = console.warn, Re = console.error, q = console.group, P = console.groupCollapsed, O = console.groupEnd;
          var s = {
            configurable: !0,
            enumerable: !0,
            value: g,
            writable: !0
          };
          Object.defineProperties(console, {
            info: s,
            log: s,
            warn: s,
            error: s,
            group: s,
            groupCollapsed: s,
            groupEnd: s
          });
        }
        me++;
      }
    }
    function l() {
      {
        if (me--, me === 0) {
          var s = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: se({}, s, {
              value: Oe
            }),
            info: se({}, s, {
              value: Ie
            }),
            warn: se({}, s, {
              value: Ue
            }),
            error: se({}, s, {
              value: Re
            }),
            group: se({}, s, {
              value: q
            }),
            groupCollapsed: se({}, s, {
              value: P
            }),
            groupEnd: se({}, s, {
              value: O
            })
          });
        }
        me < 0 && d("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var C = p.ReactCurrentDispatcher, U;
    function F(s, u, I) {
      {
        if (U === void 0)
          try {
            throw Error();
          } catch (H) {
            var V = H.stack.trim().match(/\n( *(at )?)/);
            U = V && V[1] || "";
          }
        return `
` + U + s;
      }
    }
    var G = !1, Z;
    {
      var ce = typeof WeakMap == "function" ? WeakMap : Map;
      Z = new ce();
    }
    function ue(s, u) {
      if (!s || G)
        return "";
      {
        var I = Z.get(s);
        if (I !== void 0)
          return I;
      }
      var V;
      G = !0;
      var H = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var X;
      X = C.current, C.current = null, o();
      try {
        if (u) {
          var B = function() {
            throw Error();
          };
          if (Object.defineProperty(B.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(B, []);
            } catch (ve) {
              V = ve;
            }
            Reflect.construct(s, [], B);
          } else {
            try {
              B.call();
            } catch (ve) {
              V = ve;
            }
            s.call(B.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (ve) {
            V = ve;
          }
          s();
        }
      } catch (ve) {
        if (ve && V && typeof ve.stack == "string") {
          for (var K = ve.stack.split(`
`), te = V.stack.split(`
`), ee = K.length - 1, W = te.length - 1; ee >= 1 && W >= 0 && K[ee] !== te[W]; )
            W--;
          for (; ee >= 1 && W >= 0; ee--, W--)
            if (K[ee] !== te[W]) {
              if (ee !== 1 || W !== 1)
                do
                  if (ee--, W--, W < 0 || K[ee] !== te[W]) {
                    var ae = `
` + K[ee].replace(" at new ", " at ");
                    return s.displayName && ae.includes("<anonymous>") && (ae = ae.replace("<anonymous>", s.displayName)), typeof s == "function" && Z.set(s, ae), ae;
                  }
                while (ee >= 1 && W >= 0);
              break;
            }
        }
      } finally {
        G = !1, C.current = X, l(), Error.prepareStackTrace = H;
      }
      var le = s ? s.displayName || s.name : "", de = le ? F(le) : "";
      return typeof s == "function" && Z.set(s, de), de;
    }
    function Te(s, u, I) {
      return ue(s, !1);
    }
    function ut(s) {
      var u = s.prototype;
      return !!(u && u.isReactComponent);
    }
    function qe(s, u, I) {
      if (s == null)
        return "";
      if (typeof s == "function")
        return ue(s, ut(s));
      if (typeof s == "string")
        return F(s);
      switch (s) {
        case m:
          return F("Suspense");
        case h:
          return F("SuspenseList");
      }
      if (typeof s == "object")
        switch (s.$$typeof) {
          case $:
            return Te(s.render);
          case E:
            return qe(s.type, u, I);
          case D: {
            var V = s, H = V._payload, X = V._init;
            try {
              return qe(X(H), u, I);
            } catch {
            }
          }
        }
      return "";
    }
    var pe = Object.prototype.hasOwnProperty, et = {}, Be = p.ReactDebugCurrentFrame;
    function De(s) {
      if (s) {
        var u = s._owner, I = qe(s.type, s._source, u ? u.type : null);
        Be.setExtraStackFrame(I);
      } else
        Be.setExtraStackFrame(null);
    }
    function tt(s, u, I, V, H) {
      {
        var X = Function.call.bind(pe);
        for (var B in s)
          if (X(s, B)) {
            var K = void 0;
            try {
              if (typeof s[B] != "function") {
                var te = Error((V || "React class") + ": " + I + " type `" + B + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof s[B] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw te.name = "Invariant Violation", te;
              }
              K = s[B](u, B, V, I, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (ee) {
              K = ee;
            }
            K && !(K instanceof Error) && (De(H), d("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", V || "React class", I, B, typeof K), De(null)), K instanceof Error && !(K.message in et) && (et[K.message] = !0, De(H), d("Failed %s type: %s", I, K.message), De(null));
          }
      }
    }
    var lt = Array.isArray;
    function be(s) {
      return lt(s);
    }
    function _e(s) {
      {
        var u = typeof Symbol == "function" && Symbol.toStringTag, I = u && s[Symbol.toStringTag] || s.constructor.name || "Object";
        return I;
      }
    }
    function rt(s) {
      try {
        return nt(s), !1;
      } catch {
        return !0;
      }
    }
    function nt(s) {
      return "" + s;
    }
    function Le(s) {
      if (rt(s))
        return d("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", _e(s)), nt(s);
    }
    var Ae = p.ReactCurrentOwner, gt = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Ee, Ke, Et;
    Et = {};
    function tr(s) {
      if (pe.call(s, "ref")) {
        var u = Object.getOwnPropertyDescriptor(s, "ref").get;
        if (u && u.isReactWarning)
          return !1;
      }
      return s.ref !== void 0;
    }
    function dt(s) {
      if (pe.call(s, "key")) {
        var u = Object.getOwnPropertyDescriptor(s, "key").get;
        if (u && u.isReactWarning)
          return !1;
      }
      return s.key !== void 0;
    }
    function rr(s, u) {
      if (typeof s.ref == "string" && Ae.current && u && Ae.current.stateNode !== u) {
        var I = ie(Ae.current.type);
        Et[I] || (d('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', ie(Ae.current.type), s.ref), Et[I] = !0);
      }
    }
    function jr(s, u) {
      {
        var I = function() {
          Ee || (Ee = !0, d("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", u));
        };
        I.isReactWarning = !0, Object.defineProperty(s, "key", {
          get: I,
          configurable: !0
        });
      }
    }
    function nr(s, u) {
      {
        var I = function() {
          Ke || (Ke = !0, d("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", u));
        };
        I.isReactWarning = !0, Object.defineProperty(s, "ref", {
          get: I,
          configurable: !0
        });
      }
    }
    var Ne = function(s, u, I, V, H, X, B) {
      var K = {
        // This tag allows us to uniquely identify this as a React Element
        $$typeof: t,
        // Built-in properties that belong on the element
        type: s,
        key: u,
        ref: I,
        props: B,
        // Record the component responsible for creating this element.
        _owner: X
      };
      return K._store = {}, Object.defineProperty(K._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(K, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: V
      }), Object.defineProperty(K, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: H
      }), Object.freeze && (Object.freeze(K.props), Object.freeze(K)), K;
    };
    function kr(s, u, I, V, H) {
      {
        var X, B = {}, K = null, te = null;
        I !== void 0 && (Le(I), K = "" + I), dt(u) && (Le(u.key), K = "" + u.key), tr(u) && (te = u.ref, rr(u, H));
        for (X in u)
          pe.call(u, X) && !gt.hasOwnProperty(X) && (B[X] = u[X]);
        if (s && s.defaultProps) {
          var ee = s.defaultProps;
          for (X in ee)
            B[X] === void 0 && (B[X] = ee[X]);
        }
        if (K || te) {
          var W = typeof s == "function" ? s.displayName || s.name || "Unknown" : s;
          K && jr(B, W), te && nr(B, W);
        }
        return Ne(s, K, te, H, V, Ae.current, B);
      }
    }
    var Dt = p.ReactCurrentOwner, ar = p.ReactDebugCurrentFrame;
    function at(s) {
      if (s) {
        var u = s._owner, I = qe(s.type, s._source, u ? u.type : null);
        ar.setExtraStackFrame(I);
      } else
        ar.setExtraStackFrame(null);
    }
    var At;
    At = !1;
    function Mt(s) {
      return typeof s == "object" && s !== null && s.$$typeof === t;
    }
    function Xe() {
      {
        if (Dt.current) {
          var s = ie(Dt.current.type);
          if (s)
            return `

Check the render method of \`` + s + "`.";
        }
        return "";
      }
    }
    function Ir(s) {
      {
        if (s !== void 0) {
          var u = s.fileName.replace(/^.*[\\\/]/, ""), I = s.lineNumber;
          return `

Check your code at ` + u + ":" + I + ".";
        }
        return "";
      }
    }
    var Ft = {};
    function Dr(s) {
      {
        var u = Xe();
        if (!u) {
          var I = typeof s == "string" ? s : s.displayName || s.name;
          I && (u = `

Check the top-level render call using <` + I + ">.");
        }
        return u;
      }
    }
    function wt(s, u) {
      {
        if (!s._store || s._store.validated || s.key != null)
          return;
        s._store.validated = !0;
        var I = Dr(u);
        if (Ft[I])
          return;
        Ft[I] = !0;
        var V = "";
        s && s._owner && s._owner !== Dt.current && (V = " It was passed a child from " + ie(s._owner.type) + "."), at(s), d('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', I, V), at(null);
      }
    }
    function Vt(s, u) {
      {
        if (typeof s != "object")
          return;
        if (be(s))
          for (var I = 0; I < s.length; I++) {
            var V = s[I];
            Mt(V) && wt(V, u);
          }
        else if (Mt(s))
          s._store && (s._store.validated = !0);
        else if (s) {
          var H = w(s);
          if (typeof H == "function" && H !== s.entries)
            for (var X = H.call(s), B; !(B = X.next()).done; )
              Mt(B.value) && wt(B.value, u);
        }
      }
    }
    function Ar(s) {
      {
        var u = s.type;
        if (u == null || typeof u == "string")
          return;
        var I;
        if (typeof u == "function")
          I = u.propTypes;
        else if (typeof u == "object" && (u.$$typeof === $ || // Note: Memo only checks outer props here.
        // Inner props are checked in the reconciler.
        u.$$typeof === E))
          I = u.propTypes;
        else
          return;
        if (I) {
          var V = ie(u);
          tt(I, s.props, "prop", V, s);
        } else if (u.PropTypes !== void 0 && !At) {
          At = !0;
          var H = ie(u);
          d("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", H || "Unknown");
        }
        typeof u.getDefaultProps == "function" && !u.getDefaultProps.isReactClassApproved && d("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function sr(s) {
      {
        for (var u = Object.keys(s.props), I = 0; I < u.length; I++) {
          var V = u[I];
          if (V !== "children" && V !== "key") {
            at(s), d("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", V), at(null);
            break;
          }
        }
        s.ref !== null && (at(s), d("Invalid attribute `ref` supplied to `React.Fragment`."), at(null));
      }
    }
    function or(s, u, I, V, H, X) {
      {
        var B = L(s);
        if (!B) {
          var K = "";
          (s === void 0 || typeof s == "object" && s !== null && Object.keys(s).length === 0) && (K += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var te = Ir(H);
          te ? K += te : K += Xe();
          var ee;
          s === null ? ee = "null" : be(s) ? ee = "array" : s !== void 0 && s.$$typeof === t ? (ee = "<" + (ie(s.type) || "Unknown") + " />", K = " Did you accidentally export a JSX literal instead of a component?") : ee = typeof s, d("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", ee, K);
        }
        var W = kr(s, u, I, H, X);
        if (W == null)
          return W;
        if (B) {
          var ae = u.children;
          if (ae !== void 0)
            if (V)
              if (be(ae)) {
                for (var le = 0; le < ae.length; le++)
                  Vt(ae[le], s);
                Object.freeze && Object.freeze(ae);
              } else
                d("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              Vt(ae, s);
        }
        return s === a ? sr(W) : Ar(W), W;
      }
    }
    function ir(s, u, I) {
      return or(s, u, I, !0);
    }
    function y(s, u, I) {
      return or(s, u, I, !1);
    }
    var i = y, _ = ir;
    Kt.Fragment = a, Kt.jsx = i, Kt.jsxs = _;
  }()), Kt;
}
var Gt = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var fa;
function tu() {
  if (fa)
    return Gt;
  fa = 1;
  var e = ha, t = Symbol.for("react.element"), r = Symbol.for("react.fragment"), a = Object.prototype.hasOwnProperty, n = e.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, c = { key: !0, ref: !0, __self: !0, __source: !0 };
  function f(v, $, m) {
    var h, E = {}, D = null, k = null;
    m !== void 0 && (D = "" + m), $.key !== void 0 && (D = "" + $.key), $.ref !== void 0 && (k = $.ref);
    for (h in $)
      a.call($, h) && !c.hasOwnProperty(h) && (E[h] = $[h]);
    if (v && v.defaultProps)
      for (h in $ = v.defaultProps, $)
        E[h] === void 0 && (E[h] = $[h]);
    return { $$typeof: t, type: v, key: D, ref: k, props: E, _owner: n.current };
  }
  return Gt.Fragment = r, Gt.jsx = f, Gt.jsxs = f, Gt;
}
process.env.NODE_ENV === "production" ? tu() : eu();
const nu = (e, t, r) => {
  var S;
  const a = Za(Gn(e)), [n, c] = yr(Gn(e)), [f, v] = yr(null), [$, m] = yr(0), h = xc(f, (r == null ? void 0 : r.debounceTime) || 500);
  (S = r == null ? void 0 : r.customKeywords) != null && S.length && ts(la, r.customKeywords);
  const E = la.compile(t), D = () => {
    c(
      Object.keys(n).reduce((b, A) => ({
        ...b,
        [A]: {
          value: "",
          error: ""
        }
      }), {})
    );
  }, k = (b) => {
    const A = E({ [b]: n[b].value }), M = E.errors || [], L = A ? {} : Mr(M, r == null ? void 0 : r.userDefinedMessages), Q = j && L[b] || "";
    c((J) => ({
      ...J,
      [b]: {
        ...J[b],
        error: Q
      }
    }));
  }, R = (b) => {
    k(b);
  }, T = (b) => {
    c((A) => {
      var Q;
      const M = Object.keys(b)[0], L = { ...A };
      return L[M] = {
        ...L[M],
        value: dr(b[M]),
        error: ((Q = L[M]) == null ? void 0 : Q.error) || ""
      }, v({ name: M, editId: $ }), m($ + 1), L;
    });
  }, w = (b) => Object.keys(b).reduce(
    (A, M) => {
      const L = M;
      return {
        ...A,
        [M]: {
          value: dr(n[L].value),
          error: b[M] || ""
        }
      };
    },
    { ...n }
  ), p = () => {
    try {
      const b = Object.keys(n).reduce((A, M) => ({
        ...A,
        [M]: dr(n[M].value)
      }), {});
      if (!E(b) && E.errors) {
        const A = Mr(
          E.errors,
          r == null ? void 0 : r.userDefinedMessages
        );
        return c(
          w(
            Object.keys(A).reduce((M, L) => ({
              ...M,
              [L]: dr(A[L])
            }), {})
          )
        ), { isValid: !1, data: null };
      }
      return { isValid: !0, data: b };
    } catch {
      return { isValid: !1, data: null };
    }
  }, d = (b, A) => Object.keys(b).some(
    (M) => b[M].value !== A[M].value
  ), N = (b) => !Object.keys(b).some((A) => b[A].error !== ""), j = Kn(
    () => d(n, a.current),
    [n]
  ), z = Kn(() => N(n), [n]);
  return Lr(() => {
    (r == null ? void 0 : r.shouldDebounceAndValidate) === !1 || !h || k(h.name);
  }, [h]), Lr(() => {
    var b;
    (b = r == null ? void 0 : r.errors) != null && b.length && c(w(Mr(r == null ? void 0 : r.errors, r == null ? void 0 : r.userDefinedMessages)));
  }, [r == null ? void 0 : r.errors]), {
    reset: D,
    set: T,
    validate: p,
    onBlur: R,
    isValid: z,
    isDirty: j,
    state: n
  };
};
export {
  nu as default
};
